'Goodies (11/18/2001 8:34:49 am)'.!


Object subclass: #BlueButtonMenuEnhancements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Enhancements'!
!BlueButtonMenuEnhancements commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Blue Button Enhancements
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Blue Button Enhancements
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BBMenuEn.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BBMenuEn.txt

Summary:

This goodies adds a menu item "inspect" to blue button menu.
It is useful to investigate the MVC or so. 


How to install:

FileIn this goodies and makes a class "BlueButtonMenuEnhancements" in a 
category "Goodies-Enhancements". 
AND
1 methods are added in a category "private" of the class 
"StandardSystemController".

StandardSystemController>>blueButtonActivity

When you want to restore your image, please remove this class 
"BlueButtonMenuEnhancements" from your system, simply.
Also a menu item "inspect" is removed automatically from 
blue button menu.


How to use:

When you install this goodies, it adds a menu item "inspect" 
to blue button menu automatically.


##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BBMenuEn.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BBMenuEn.txt
QƂĂB

IWi͎ȊĂAũNX⃁\bhɂ͈؂̕ύX
Ă܂vÃR[hł́A
"StandardSystemController"  "private" JeS쐬A

StandardSystemController>>blueButtonActivity

}܂̂ŁAӂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlueButtonMenuEnhancements class
	instanceVariableNames: 'enhancements '!

!BlueButtonMenuEnhancements class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!BlueButtonMenuEnhancements class methodsFor: 'copyright'!
system
	^'Goodies'! !

!BlueButtonMenuEnhancements class methodsFor: 'copyright'!
version
	^'003'! !


!BlueButtonMenuEnhancements class methodsFor: 'class initialization'!
induct
	"BlueButtonMenuEnhancements induct."

	self blueButtonActivityInStandardSystemController! !

!BlueButtonMenuEnhancements class methodsFor: 'class initialization'!
initialize
	"BlueButtonMenuEnhancements initialize."

	self induct! !

!BlueButtonMenuEnhancements class methodsFor: 'class initialization'!
install
	"BlueButtonMenuEnhancements install."

	| default done process count |
	Cursor normal show.
	default := false.
	done := false.
	process := 
			[default := self confirm: 'Do you want to enhance the blue button menu?'.
			default ifTrue: [self induct].
			done := true] newProcess.
	process priority: Processor activeProcess priority + 0.
	process resume.
	count := 0.
	[done not and: [count < 10]]
		whileTrue: 
			[count := count + 1.
			(Delay forSeconds: 1) wait].
	process terminate.
	done ifFalse: [default ifTrue: [self induct]]! !

!BlueButtonMenuEnhancements class methodsFor: 'class initialization'!
obsolete
	self uninduct.
	super obsolete! !

!BlueButtonMenuEnhancements class methodsFor: 'class initialization' stamp: 'nishis 4/12/98 11:05'!
uninduct
	"BlueButtonMenuEnhancements uninduct."

	| aClass aSelector |
	enhancements notNil
		ifTrue: 
			[enhancements copy
				do: 
					[:anArray | 
					aClass := Compiler evaluate: (anArray at: 1)
								logged: false.
					aSelector := anArray at: 3.
					self uninstallEnhanceClass: aClass selector: aSelector.
					aClass organization removeEmptyCategories	"added by nishis, 1998/04/12 11:05"].
			enhancements := nil]! !

!BlueButtonMenuEnhancements class methodsFor: 'class initialization'!
uninstall
	"BlueButtonMenuEnhancements uninstall."

	self uninduct! !


!BlueButtonMenuEnhancements class methodsFor: 'enhancements' stamp: 'nishis 4/13/98 13:21'!
blueButtonActivityInStandardSystemController
	"BlueButtonMenuEnhancements blueButtonActivityInStandardSystemController."

	self
		installEnhanceClass: StandardSystemController
		protocol: 'private'
		code: 'blueButtonActivity
	| menu choice scheduledBlueButtonMenu messages labels lines |
	ScheduledBlueButtonMenu
		ifNil: [^ super controlActivity].
	scheduledBlueButtonMenu _ ScheduledBlueButtonMenu copy.
	labels _ ScheduledBlueButtonMenu labelString , ''\inspect'' withCRs.
	lines _ OrderedCollection new: scheduledBlueButtonMenu lineArray size + 1.
	lines addAll: scheduledBlueButtonMenu lineArray.
	lines add: scheduledBlueButtonMenu selections size.
	messages _ OrderedCollection new: scheduledBlueButtonMenu selections size + 1.
	messages addAll: scheduledBlueButtonMenu selections.
	messages add: #inspect.
	menu _ PopUpMenu labels: labels lines: lines asArray.
	choice _ menu startUp.
	(choice = 0
			or: [choice isNil])
		ifTrue: [^ super controlActivity].
	^ self
		perform: (messages asArray at: choice)'
"
	| menu item choice |
	menu := ScheduledBlueButtonMenu.
	menu addItemGroup: (Array with: (item := MenuItem labeled: ''inspect''))
		values: (Array with: #inspect).
	[choice := self
				trackMenu: menu
				at: self sensor globalCursorPoint
				centered: false]
		valueNowOrOnUnwindDo: [menu removeItem: item].
	(choice = 0 or: [choice isNil])
		ifTrue: [^self].
	self perform: choice'
"! !


!BlueButtonMenuEnhancements class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:37'!
save
	"BlueButtonMenuEnhancements save."

	| fileName classCollection aStream timeStamp |
	fileName := 'BBMenuEn.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!BlueButtonMenuEnhancements class methodsFor: 'saving'!
saveClasses
	"BlueButtonMenuEnhancements saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*BlueButtonMenuEnhancements*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!BlueButtonMenuEnhancements class methodsFor: 'private' stamp: 'nishis 4/12/98 09:20'!
installEnhanceClass: aClass protocol: aProtocol code: aCode 
	| aSelector anArray oldCode aCategory bool |
	(aClass isKindOf: Behavior) ifFalse: [^self].
	aSelector := Parser new parseSelector: aCode.
	aSelector isNil ifTrue: [^self].
	enhancements isNil ifTrue: [enhancements := OrderedCollection new].
	anArray := enhancements
				detect: 
					[:array | 
					bool := aClass name asString = (array at: 1).
					bool := bool and: [aSelector = (array at: 3)].
					bool yourself]
				ifNone: [nil].
	anArray isNil
		ifTrue: 
			[(aClass includesSelector: aSelector)
				ifTrue: 
					[oldCode := aClass sourceCodeAt: aSelector.
					aCategory := aClass organization categoryOfElement: aSelector.
					aCategory isNil ifTrue: [aCategory := #undefined]]
				ifFalse: 
					[oldCode := nil.
					aCategory := aProtocol].
			enhancements add: (Array
					with: aClass name asString
					with: aCategory asString
					with: aSelector
					with: oldCode)].
	aClass compile: aCode classified: aProtocol! !

!BlueButtonMenuEnhancements class methodsFor: 'private' stamp: 'nishis 4/12/98 09:21'!
uninstallEnhanceClass: aClass selector: aSelector 
	| anArray aProtocol oldCode bool |
	(aClass isKindOf: Behavior) ifFalse: [^self].
	(aSelector isKindOf: Symbol)
		ifFalse: [^self].
	enhancements isNil ifTrue: [^self].
	anArray := enhancements
				detect: 
					[:array | 
					bool := aClass name asString = (array at: 1).
					bool := bool and: [aSelector = (array at: 3)].
					bool yourself]
				ifNone: [nil].
	anArray isNil ifTrue: [^self].
	aProtocol := anArray at: 2.
	oldCode := anArray at: 4.
	oldCode isNil
		ifTrue: ["remove method"
			aClass removeSelector: aSelector]
		ifFalse: ["restore method"
			aClass compile: oldCode classified: aProtocol].
	enhancements remove: anArray! !


BlueButtonMenuEnhancements initialize!
