'Goodies (11/18/2001 8:34:51 am)'.!


StringHolder subclass: #MessageSpy
	instanceVariableNames: 'targetBlock howOften omitValue observedProcess signalObject watchingProcess previousTime totalTime rootRecord reportList selectedItem blockSource '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Spy'!
!MessageSpy commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Message Spy
Time Profiler Goodies for Squeak. 

Yet Another MessageTally>>spyOn: with messege list browser.
With a little bit of enhancement or fake.

It runs on Squeak 1.31 (MVC), 2.3 beta (MVC or Morphic)

This goodies is a modification for Squeak,
originaly written by Mr. AOKI.
Message Spy
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05

see below 
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/MsgSpy.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/MsgSpy.txt

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@nifty.ne.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!MessageSpy methodsFor: 'initialize-release' stamp: 'nishis 12/7/1998 04:15'!
close
	rootRecord notNil ifTrue: [rootRecord reverseDo: [:children | children close]].
	rootRecord := nil.
	reportList := nil! !


!MessageSpy methodsFor: 'accessing' stamp: 'nishis 12/4/1998 15:18'!
blockSource
	blockSource isNil ifTrue: [blockSource := '[]'].
	^blockSource! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 12/4/1998 15:18'!
blockSource: aString
	blockSource := aString! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:41'!
howOften
	howOften isNil ifTrue: [howOften := self class defaultHowOften].
	^howOften! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:55'!
howOften: milliseconds 
	howOften := self minHowOften max: (milliseconds min: self maxHowOften)
! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:42'!
omitValue
	omitValue isNil ifTrue: [omitValue := self class defaultOmitValue].
	^omitValue! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:55'!
omitValue: aNumber 
	omitValue := self minOmitValue max: (aNumber min: self maxOmitValue)! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:42'!
targetBlock
	targetBlock isNil ifTrue: [targetBlock := []].
	^targetBlock! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 12/4/1998 16:45'!
targetBlock: aBlock 
	self blockSource: (self decompileFrom: aBlock).
	targetBlock := aBlock.
	rootRecord := SpyRecord
				whose: aBlock receiver class
				method: aBlock method
				value: 0
				home: aBlock home.
	self reportList! !

!MessageSpy methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:43'!
totalTime
	totalTime isNil ifTrue: [totalTime := 0].
	^totalTime! !


!MessageSpy methodsFor: 'spying' stamp: 'nishis 12/1/1998 16:10'!
epilogue
	(watchingProcess isMemberOf: Process)
		ifTrue: [watchingProcess terminate].
	observedProcess := nil.
	signalObject := nil.
	watchingProcess := nil.
	previousTime := nil.
	self normalize.
	reportList := nil.
	self changed: #selectedItem! !

!MessageSpy methodsFor: 'spying' stamp: 'nishis 11/29/1998 05:43'!
normalize
	totalTime := rootRecord value.
	totalTime <= 0
		ifTrue: 
			[rootRecord value: 1.0.
			rootRecord children: nil.
			^self].
	rootRecord do: [:record | record value: (record value / totalTime) asFloat].
	rootRecord value: 1.0! !

!MessageSpy methodsFor: 'spying' stamp: 'nishis 12/4/98 00:34'!
prologue
	observedProcess := Processor activeProcess.
	signalObject := Delay forMilliseconds: self howOften.
	watchingProcess := 
		[[true] 
			whileTrue: 
				[signalObject wait.
				self watch]] newProcess.
	watchingProcess priority: Processor userInterruptPriority.
	watchingProcess resume.
	previousTime := Time millisecondClockValue.
	totalTime := 0! !

!MessageSpy methodsFor: 'spying' stamp: 'nishis 12/6/1998 02:16'!
spy
	[self prologue.
	self targetBlock value.
	self epilogue] 
		ifError: 
			[:err :rcvr | 
			self epilogue.
			self error: '*** ', rcvr asString, ': ', err asString]! !


!MessageSpy methodsFor: 'watching' stamp: 'nishis 11/29/1998 05:44'!
watch
	| time |
	previousTime notNil
		ifTrue: 
			[time := Time millisecondClockValue - previousTime.
			self watch: observedProcess suspendedContext value: time].
	previousTime := Time millisecondClockValue! !

!MessageSpy methodsFor: 'watching' stamp: 'nishis 12/1/1998 16:26'!
watch: context value: amount 
	| parent method record |
	context sender isNil ifTrue: [^nil].
	context method == rootRecord method
		ifTrue: 
			[rootRecord value: rootRecord value + amount.
			^rootRecord].
	parent := self watch: context sender value: amount.
	parent isNil
		ifTrue: [^nil]
		ifFalse: 
			[method := context method.
			1 to: parent children size
				do: 
					[:index | 
					record := parent children at: index.
					record method == method
						ifTrue: 
							[record value: record value + amount.
							^record]].
			record := SpyRecord
						whose: context receiver class
						method: method
						value: amount
						home: context home.
			record parent: parent.
			parent children: (parent children copyWith: record).
			^record]! !


!MessageSpy methodsFor: 'reporting' stamp: 'nishis 12/1/1998 17:50'!
report
	self open! !

!MessageSpy methodsFor: 'reporting' stamp: 'nishis 11/29/1998 05:54'!
result
	| aStream |
	aStream := WriteStream on: (String new: 1024).
	aStream nextPutAll: self titleString.
	aStream cr.
	self reportList
		do: 
			[:each | 
			aStream nextPutAll: each.
			aStream cr].
	^aStream contents! !


!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:04'!
allMenu
	"Squeak 1.31 only."

	| selectedClassAndSelector aClass aSelector |
	self selectedItem isNil 
		ifTrue: 
			[^self allMenuNoSelected]
		ifFalse: 
			[selectedClassAndSelector := self selectedClassAndSelector.
			aClass := selectedClassAndSelector first.
			aSelector := selectedClassAndSelector second.
			(aClass notNil and: [aSelector notNil]) 
				ifTrue: [^self allMenuSelectedAndSpawnable]
				ifFalse: [^self allMenuSelectedAndDispawnable]]! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:05'!
allMenuNoSelected
	"Squeak 1.31 only."

	^SelectionMenu 
		labels: 
'Target block
Sampling time
Cut off
show...
do it again
inspect
spyOn:
tallySends:
time:'
		lines: #(3 6)
		selections: #(#resetBlock #samplingTime #cutOff #show #reprofiling #inspect #spyOn: #tallySends: #time:)! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:05'!
allMenuSelectedAndDispawnable
	"Squeak 1.31 only."

	^SelectionMenu 
		labels: 
'Target block
Sampling time
Cut off
show...
class
senders
implementors
again
inspect
spyOn:
tallySends:
time:'
		lines: #(3 4 9)
		selections: #(#resetBlock #samplingTime #cutOff #show #class #senders #implementors #reprofiling #inspect #spyOn: #tallySends: #time:)! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:05'!
allMenuSelectedAndSpawnable
	"Squeak 1.31 only."

	^SelectionMenu 
		labels: 
'Target block
Sampling time
Cut off
spawn
show...
class
senders
implementors
again
inspect
spyOn:
tallySends:
time:'
		lines: #(3 5 10)
		selections: #(#resetBlock #samplingTime #cutOff #spawn #show #class #senders #implementors #reprofiling #inspect #spyOn: #tallySends: #time:)! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/1998 04:27'!
reportList
	| aCollection aStream stringLength aFloat aString |
	reportList isNil
		ifTrue: 
			[aCollection := OrderedCollection new: rootRecord size.
			rootRecord do: [:record :level | record value >= self omitValue
					ifTrue: 
						[aStream := WriteStream on: String new.
						level timesRepeat: [aStream nextPutAll: self levelString].
						aFloat := (10 raisedTo: ((self omitValue / 10) floorLog: 10)) asFloat.
						stringLength := aFloat printString size.
						record value = 1.0
							ifTrue: [aFloat := record value asFloat]
							ifFalse: [aFloat := (record value roundTo: aFloat) asFloat].
						aString := aFloat printString.
						aStream nextPutAll: aString.
						stringLength - aString size timesRepeat: [aStream nextPutAll: '0'].
						aStream space; space.
						aStream nextPutAll: record name.
						aCollection add: aStream contents]]
				level: 0.
			reportList := aCollection].
	^reportList! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/1/1998 17:02'!
reportMenu
	^self reportMenu: SelectionMenu! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:05'!
reportMenu: aMenu
	| aClass aSelector selectedClassAndSelector |
	^self selectedItem isNil 
		ifTrue: 
			[self reportMenuNoSelected: aMenu]
		ifFalse: 
			[selectedClassAndSelector := self selectedClassAndSelector.
			aClass := selectedClassAndSelector first.
			aSelector := selectedClassAndSelector second.
			(aClass notNil and: [aSelector notNil]) 
				ifTrue: 
					[self reportMenuSelectedAndSpawnable: aMenu]
				ifFalse: 
					[self reportMenuSelectedAndDispawnable: aMenu]]! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:06'!
reportMenuNoSelected: aMenu
	^aMenu 
		labels: 
'show...
do it again
inspect
spyOn:
tallySends:
time:'
		lines: #(1 3)
		selections: #(#show #reprofiling #inspect #spyOn: #tallySends: #time:)! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:06'!
reportMenuSelectedAndDispawnable: aMenu
	^aMenu
		labels: 
'show...
class
senders
implementors
do it again
inspect
spyOn:
tallySends:
time:'
		lines: #(1 6)
		selections: #(#show #class #senders #implementors #reprofiling #inspect #spyOn: #tallySends: #time:)! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/7/98 05:06'!
reportMenuSelectedAndSpawnable: aMenu
	^aMenu
		labels: 
'spawn
show...
class
senders
implementors
do it again
inspect
spyOn:
tallySends:
time:'
		lines: #(2 7)
		selections: #(#spawn #show #class #senders #implementors #reprofiling #inspect #spyOn: #tallySends: #time:)! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 11/29/1998 11:42'!
selectedItem
	^selectedItem! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 11/29/1998 11:42'!
selectedItem: selection 
	selectedItem := selection! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/1/1998 17:01'!
spyMenu
	^self spyMenu: SelectionMenu! !

!MessageSpy methodsFor: 'aspects' stamp: 'nishis 12/1/1998 17:01'!
spyMenu: aMenu
	^aMenu 
		labels: 
'Target block
Sampling time
Cut off'
		lines: #()
		selections: #(#resetBlock #samplingTime #cutOff)! !


!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/7/1998 03:10'!
class
	| aClass selectedClassAndSelector aSelector |
	selectedClassAndSelector := self selectedClassAndSelector.
	aClass := selectedClassAndSelector first.
	aSelector := selectedClassAndSelector second.
	aClass isNil 
		ifFalse: 
			[self versionOfSqueak < 2.0 
				ifTrue: 
					[Browser perform: #postOpenSuggestion: with: (Array with: aClass with: aSelector).
					Browser newOnClass: aClass]
				ifFalse: 
					[Browser perform: #newOnClass:selector: with: aClass with: aSelector]]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/7/1998 01:36'!
cutOff
	| previousValue result |
	previousValue := self omitValue.
	result := FillInTheBlank
			request: 'Type Cut off value (max: 1.0, min: 0.001).'
			initialAnswer: self omitValue printString.
	(result isEmpty or: [result isNil]) ifTrue: [^self].
	self omitValue: result asNumber.
	previousValue ~= self omitValue 
		ifTrue: 
			[reportList := nil.
			self reportList.
			self changed: #titleString.
			self changed: #reportList.
			self versionOfSqueak < 2.0 ifTrue: [self updateStringHolderView]]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/4/1998 15:19'!
evaluateSelection
	| rcvr ctxt result blockString |
	self versionOfSqueak < 2.0 ifTrue: [^self evaluateSelection131].
	blockString := FillInTheBlank
			multiLineRequest: 'Type new Block statement (requires: []).' 
			centerAt: Sensor cursorPoint 
			initialAnswer: self blockSource  
			answerHeight: 200.
	(blockString isEmpty or: [blockString isNil]) ifTrue: [^self targetBlock].
	FakeClassPool adopt: self class.
	rcvr := self doItReceiver.
	ctxt := self doItContext.
	result := rcvr class evaluatorClass new 
				evaluate: blockString
				in: ctxt 
				to: rcvr 
				notifying: nil
				ifFail: 
					[FakeClassPool adopt: nil.
					^self targetBlock].
	FakeClassPool adopt: nil.
	self blockSource: blockString.
	^result! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/4/1998 15:19'!
evaluateSelection131
	"Squeak 1.31 only."

	| rcvr ctxt result blockString saveBits aController |
	blockString := FillInTheBlank
			request: 'Type new Block statement (requires: []).' 
			initialAnswer: self blockSource.
	(blockString isEmpty or: [blockString isNil]) ifTrue: [^self targetBlock].
	rcvr := self doItReceiver.
	ctxt := self doItContext.
	aController := ScheduledControllers scheduledControllers
			detect: [:each | each model == self]
			ifNone: [nil].
	((saveBits := Sensor leftShiftDown) and: [aController notNil])
		ifTrue: 
			[aController view topView deEmphasize.
			aController view cacheBits].
	result := self doItReceiver class evaluatorClass new
				evaluate: blockString
				in: ctxt 
				to: rcvr 
				notifying: nil
				ifFail: 
					[^self targetBlock].
	saveBits ifTrue: [Sensor waitClickButton. ScheduledControllers restore].
	self blockSource: blockString.
	^result! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 11/30/1998 01:20'!
implementors
	| messageSelector |
	messageSelector := self selectedItems at: 3.
	(messageSelector isNil or: [messageSelector == #unboundMethod]) 
		ifFalse: [Smalltalk browseAllImplementorsOf: messageSelector asSymbol]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/6/1998 23:31'!
reprofiling
	self close.
	self targetBlock: self targetBlock.
	self spy.
	self changed: #reportList.
	self changed: #titleString.
	self versionOfSqueak < 2.0 ifTrue: [self updateStringHolderView]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/1/1998 17:19'!
resetBlock
	| previousBlock aBlock |
	previousBlock := self targetBlock.
	aBlock := self evaluateSelection.
	(aBlock notNil and: [aBlock ~= previousBlock]) 
		ifTrue: 
			[self targetBlock: aBlock.
			self reprofiling]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/1/1998 17:19'!
samplingTime
	| previousValue result |
	previousValue := self howOften.
	result := FillInTheBlank
			request: 'Type Sampling time value (msec).'
			initialAnswer: self howOften printString.
	(result isEmpty or: [result isNil]) ifTrue: [^self].
	self howOften: result asNumber.
	previousValue ~= self howOften ifTrue: [self reprofiling]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 11/29/1998 23:31'!
senders
	| messageSelector |
	messageSelector := self selectedItems at: 3.
	(messageSelector isNil or: [messageSelector == #unboundMethod]) 
		ifFalse: [Smalltalk browseAllCallsOn: messageSelector asSymbol]! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 11/29/1998 08:58'!
show
	| aModel |
	aModel := StringHolder new contents: self result.
	StringHolderView open: aModel label: 'Message Spy'! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/7/1998 00:43'!
spawn
	| messageSelector aClass messageBrowser selectedClassAndSelector |
	selectedClassAndSelector := self selectedClassAndSelector.
	aClass := selectedClassAndSelector first.
	messageSelector := selectedClassAndSelector second.
	self versionOfSqueak < 2.0 
		ifTrue: [messageBrowser := Smalltalk at: #BrowserView]
		ifFalse: [messageBrowser := Smalltalk at: #Browser].
	messageBrowser openMessageBrowserForClass: aClass 
		selector: messageSelector editString: nil! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/7/98 05:11'!
spyOn: ignored
	"Cursor execute showWhile: [aWindow open] was never recover cursor!!"
	"copied from MessageTally (calss)>>#spyOn:"

	| node model timer |
	[Cursor execute showWhile: 
		[node := MessageTally new.
		node spyEvery: 16 on: targetBlock.
		model := StringHolder new 
				contents: (String streamContents: [:s | node report: s; close])]]
		ifError: 
			[:err :rcvr | 
			timer := node class classPool at: #Timer.
			(timer isMemberOf: Process) ifTrue: [timer terminate].
			node close.
			^self error: '*** ', rcvr asString, ': ', err asString].
	StringHolderView open: model label: 'Spy Results'! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/7/98 05:10'!
tallySends: ignored
	"Cursor execute showWhile: [aWindow open] was never recover cursor!!"
	"copied from MessageTally (calss)>>#tallySends:, #tallySendsTo:inBlock:showTree:"

	| prev tallies startTime spendTime receiver model treeOption |
	[Cursor execute showWhile: 
		[receiver := nil.
		treeOption := true.
		startTime := Time millisecondClockValue.
		tallies := MessageTally new class: targetBlock receiver class
								method: targetBlock method.
		prev := targetBlock.
		thisContext sender
			runSimulated: targetBlock
			contextAtEachStep:
				[:current |
				current == prev ifFalse: 
					["call or return"
					prev sender == nil ifFalse: 
						["call only"
						(receiver == nil or: [current receiver == receiver])
							ifTrue: [tallies tally: current by: 1]].
					prev _ current]].

		spendTime := Time millisecondClockValue - startTime // 1000.0 roundTo: 0.01.
		model := StringHolder new contents:
			(String streamContents:
				[:s |
				s nextPutAll: 'This simulation took ' , spendTime printString
								, ' seconds.'; cr.
				treeOption
					ifTrue: [tallies fullPrintOn: s tallyExact: true orThreshold: 0]
					ifFalse: [tallies leavesPrintOn: s tallyExact: true orThreshold: 0].
				tallies close])]]
		ifError: 
			[:err :rcvr | 
			tallies close.
			^self error: '*** ', rcvr asString, ': ', err asString].
	StringHolderView open: model label: 'Spy Results'! !

!MessageSpy methodsFor: 'menu messages' stamp: 'nishis 12/1/1998 17:06'!
time: ignored
	^Utilities informUser: (MessageTally time: self targetBlock) printString during: [Sensor waitButton]! !


!MessageSpy methodsFor: 'interface opening' stamp: 'nishis 12/5/1998 19:34'!
open
	"MessageSpy example6."

	| topView textView listView textViewHeight |
	self versionOfSqueak < 2.0 ifTrue: [^self open131].
	World ifNotNil: [^self openAsMorph].

	topView := StandardSystemView new 
			model: self;
			label: 'Message Spy';
			minimumSize: 300 @ 200.
	topView borderWidth: 1.

	textViewHeight := 24.
	textView := (Smalltalk at: #PluggableTextView) 
			on: self 
			text: #titleString 
			accept: nil 
			readSelection: nil 
			menu: #spyMenu:.
	textView window: (0 @ 0 extent: 300 @ textViewHeight).
	textView borderWidth: 1.
	topView addSubView: textView.

	listView := (Smalltalk at: #PluggableListViewByItem)
			on: self
			list: #reportList
			selected: #selectedItem
			changeSelected: #selectedItem:
			menu: #reportMenu:.

	listView window: (0 @ textViewHeight extent: 300 @ (200 - textViewHeight)).
	topView addSubView: listView below: textView.

	self postBuildWith: textView.
	topView controller open! !

!MessageSpy methodsFor: 'interface opening' stamp: 'nishis 12/4/98 00:31'!
open131
	"Squeak 1.31 only."

	| topView textView listView textViewHeight |
	World ifNotNil: [^self openAsMorph].
	topView := StandardSystemView new 
			model: self;
			label: 'Message Spy';
			minimumSize: 300 @ 200.

	textViewHeight := 24.
	textView := StringHolderView container: (StringHolder new contents: self titleString).
	textView controller: NoController new.
	textView window: (0 @ 0 extent: 300 @ textViewHeight).
	textView borderWidthLeft: 2 right: 2 top: 2 bottom: 0.
	topView addSubView: textView.

	listView := (Smalltalk at: #PluggableListView)
		on: self
		list: #reportList
		selected: #selectedItem
		changeSelected: #selectedItem:
		menu: #allMenu.
	listView borderWidth: 2.
	listView window: (0 @ textViewHeight extent: 300 @ (200 - textViewHeight)).
	topView addSubView: listView below: textView.

	self postBuildWith: textView.
	topView controller open
! !

!MessageSpy methodsFor: 'interface opening' stamp: 'nishis 12/7/1998 04:31'!
openAsMorph
	| window textViewMorph listViewMorph textViewMorphHeight |
	window := ((Smalltalk at: #SystemWindow) labelled: 'Message Spy')
			model: self.
	window borderWidth: 1.

	textViewMorphHeight := 0.1.
	textViewMorph := (Smalltalk at: #PluggableTextMorph) 
			on: self 
			text: #titleString 
			accept: nil 
			readSelection: nil 
			menu: #spyMenu:.
	window addMorph: textViewMorph frame: (0 @ 0 extent: 1.0 @ textViewMorphHeight).

	listViewMorph := (Smalltalk at: #PluggableListMorphByItem)
			on: self
			list: #reportList
			selected: #selectedItem
			changeSelected: #selectedItem:
			menu: #reportMenu:.

	window addMorph: listViewMorph frame: (0 @ textViewMorphHeight extent: 1 @ (1.0 - textViewMorphHeight)).

	self postBuildWith: textViewMorph.
	^window openInWorld
! !

!MessageSpy methodsFor: 'interface opening' stamp: 'nishis 12/5/1998 19:33'!
postBuildWith: view 
	"Squeak 1.31 requires."

	view editString: self titleString! !


!MessageSpy methodsFor: 'printing' stamp: 'nishis 11/30/1998 15:06'!
printOn: aStream 
	| cutValue stringLength aString aFloat |
	aStream nextPutAll: self class name.
	aStream nextPutAll: ' ('.
	aStream cr.
	aStream nextPutAll: self titleString.
	aStream cr.
	cutValue := 0.2.
	rootRecord do: [:record :level | record value >= cutValue
			ifTrue: 
				[level timesRepeat: [aStream nextPutAll: '| '].
				aFloat := (10 raisedTo: ((0.2 / 10) floorLog: 10)) asFloat.
				stringLength := aFloat printString size.
				record value = 1.0
					ifTrue: [aFloat := record value asFloat]
					ifFalse: [aFloat := (record value roundTo: aFloat) asFloat].
				aString := aFloat printString.
				aStream nextPutAll: aString.
				stringLength - aString size timesRepeat: [aStream nextPutAll: '0'].
				aStream space.
				aStream nextPutAll: record name.
				aStream cr]]
		level: 0.
	aStream nextPutAll: ')'! !

!MessageSpy methodsFor: 'printing' stamp: 'nishis 12/6/1998 23:22'!
titleString
	| aStream |
	aStream := WriteStream on: (String new: 64).
	aStream nextPutAll: 'Processing time: '.
	aStream nextPutAll: (self totalTime / 1000.0) asFloat printString.
	aStream nextPutAll: ' sec.'.
	aStream cr.
	aStream nextPutAll: 'Sampling time: '.
	aStream nextPutAll: self howOften printString.
	aStream nextPutAll: ' msec., '.
	aStream nextPutAll: 'Cut off: '.
	aStream nextPutAll: self omitValue printString.
	^aStream contents! !


!MessageSpy methodsFor: 'private' stamp: 'nishis 12/7/1998 02:33'!
decompileFrom: aBlock 
	| decompileString start end |
	aBlock home sender isNil ifTrue: [^self blockSource].
	"ok, this is ugly. it's only a rock'n roll and called at first time only."
	decompileString := aBlock method decompileString.
	start := decompileString findString: '[' startingAt: 1.
	end := decompileString reversed findString: ']' startingAt: 1.
	end := decompileString size - end + 1.
	(end > 0 and: [start > 0]) 
		ifTrue: [end > start 
				ifTrue: [^decompileString copyFrom: start to: end]].
	^self blockSource! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:52'!
delimiter
	| stream |
	stream := WriteStream on: (String new: 3).
	stream space.
	stream tab.
	stream cr.
	^stream contents! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:52'!
levelString
	^'| ' copy! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:53'!
maxHowOften
	^1000! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:53'!
maxOmitValue
	^1! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:53'!
minHowOften
	^1! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:53'!
minOmitValue
	^0.001! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 12/7/1998 02:08'!
selectedClassAndSelector
	| selectedItems aClass isMeta aSelector anArray |
	anArray := Array new: 2.
	selectedItems := self selectedItems.
	aClass := Smalltalk at: (selectedItems at: 1) ifAbsent: [nil].
	isMeta := selectedItems at: 2.
	aSelector := selectedItems at: 3.
	(aClass isNil or: [isMeta isNil or: [aSelector isNil]])
		ifTrue: [^anArray].
	isMeta
		ifTrue: 
			[anArray at: 1 put: aClass class.
			(aClass class selectors includes: aSelector)
				ifTrue: 
					[anArray at: 2 put: aSelector]]
		ifFalse: 
			[anArray at: 1 put: aClass.
			(aClass selectors includes: aSelector)
				ifTrue: 
					[anArray at: 2 put: aSelector]].
	^anArray! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 12/7/1998 02:10'!
selectedItems
	| className isMeta messageSelector aCollection index aString anArray |
	anArray := Array new: 3.
	self selectedItem isNil ifTrue: [^anArray].
	className := isMeta := messageSelector := nil.
	index := self selectedItem findFirst: [:char | (self levelString includes: char) not].
	index <= 0
		ifTrue: [aString := self selectedItem]
		ifFalse: [aString := self selectedItem copyFrom: index to: self selectedItem size].
	aCollection := self separate: aString delimiter: self delimiter.
	aCollection size = 3
		ifTrue: 
			[className := aCollection at: 2.
			isMeta := false.
			messageSelector := aCollection at: 3].
	(aCollection size = 4 and: ['class' = (aCollection at: 3)])
		ifTrue: 
			[className := aCollection at: 2.
			isMeta := true.
			messageSelector := aCollection at: aCollection size].
	(aCollection size > 4 and: ['[]' = (aCollection at: 2)])
		ifTrue: 
			[className := aCollection at: aCollection size - 1.
			isMeta := false.
			className = 'class'
				ifTrue: 
					[className := aCollection at: aCollection size - 2.
					isMeta := true].
			messageSelector := aCollection at: aCollection size].
	className := (className isNil ifFalse: [className asSymbol] ifTrue: [nil]).
	messageSelector := messageSelector isNil ifFalse: [messageSelector asSymbol] ifTrue: [nil].
	anArray at: 1 put: className.
	anArray at: 2 put: isMeta.
	anArray at: 3 put: messageSelector.
	^anArray! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/1998 05:53'!
separate: separateCollection delimiter: delimiterCollection 
	| indexCollection index intervalCollection s e result |
	indexCollection := OrderedCollection new.
	indexCollection add: 0.
	index := 1.
	separateCollection
		do: 
			[:each | 
			(delimiterCollection includes: each)
				ifTrue: [indexCollection add: index].
			index := index + 1].
	indexCollection add: separateCollection size + 1.
	intervalCollection := OrderedCollection new.
	1 to: indexCollection size - 1
		do: 
			[:i | 
			s := indexCollection at: i.
			e := indexCollection at: i + 1.
			intervalCollection add: (s + 1 to: e - 1)].
	result := OrderedCollection new.
	intervalCollection do: [:interval | interval size > 0 ifTrue: [result add: (separateCollection copyFrom: interval first to: interval last)]].
	^result! !

!MessageSpy methodsFor: 'private' stamp: 'nishis 11/29/98 21:20'!
versionOfSqueak
	^self class versionOfSqueak! !


!MessageSpy methodsFor: 'updating' stamp: 'nishis 12/6/1998 23:30'!
okToChange
	| aMethod aClient aSelector |
	aMethod := thisContext sender method.
	aClient := thisContext client.
	aSelector := aClient class
					selectorAtMethod: aMethod
					setClass: [:mclass | ].
	((aClient isKindOf: StandardSystemController)
		and: [aSelector = #close])
		ifTrue:
			[(self confirm: 'Really close?')
				ifFalse: [^false].
			self close].
	^super okToChange! !

!MessageSpy methodsFor: 'updating' stamp: 'nishis 12/4/1998 16:32'!
updateStringHolderView
	"Squeak 1.31 only."

	| aController topView aStringHolderView |
	aController := ScheduledControllers scheduledControllers
			detect: [:each | each model == self]
			ifNone: [nil].
	aController notNil
		ifTrue:
			[topView := aController view topView.
			aStringHolderView := topView subViews 
					detect: [:each | each isKindOf: StringHolderView] 
					ifNone: [^nil].
			aStringHolderView model contents: self titleString.
			aStringHolderView model changed]
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageSpy class
	instanceVariableNames: ''!

!MessageSpy class methodsFor: 'copyright' stamp: 'nishis 11/29/1998 05:36'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!MessageSpy class methodsFor: 'copyright' stamp: 'nishis 11/29/1998 05:37'!
system
	^'Goodies'! !

!MessageSpy class methodsFor: 'copyright' stamp: 'nishis 11/29/1998 05:37'!
version
	^'003'! !


!MessageSpy class methodsFor: 'instance creation' stamp: 'nishis 12/6/1998 04:00'!
on: aBlock 
	aBlock hasMethodReturn
		ifTrue: 
			[self inform: 'simulation of blocks with ^ can run loose.'.
			^nil].
	^super new targetBlock: aBlock! !


!MessageSpy class methodsFor: 'utilities' stamp: 'nishis 11/29/1998 05:39'!
spy: aBlock 
	"MessageSpy spy: [ScheduledControllers restore]."

	^self
		spy: aBlock
		often: self defaultHowOften
		omit: self defaultOmitValue! !

!MessageSpy class methodsFor: 'utilities' stamp: 'nishis 11/29/1998 05:39'!
spy: aBlock often: milliseconds 
	"MessageSpy spy: [ScheduledControllers restore] often: 50."

	^self
		spy: aBlock
		often: milliseconds
		omit: self defaultOmitValue! !

!MessageSpy class methodsFor: 'utilities' stamp: 'nishis 12/5/1998 04:23'!
spy: aBlock often: milliseconds omit: percentage 
	"MessageSpy 
		spy: [ScheduledControllers restore] 
		often: 100 
		omit: 0.2."

	| sendingProve |
	(sendingProve := self on: aBlock) isNil ifTrue: [^nil].
	sendingProve howOften: milliseconds.
	sendingProve omitValue: percentage.
	sendingProve spy.
	sendingProve report.
	^sendingProve! !

!MessageSpy class methodsFor: 'utilities' stamp: 'nishis 11/9/2001 00:31'!
versionOfSqueak
	"MessageSpy versionOfSqueak."

	| versionString |
	versionString := Smalltalk version.
	^ [((versionString findTokens: ' ')
		at: 2) asNumber]
		on: Error do: 
		[:ex | 
		| stream string |
		stream := WriteStream on: String new.
		versionString do: [:c | (c isDigit or: [c == $.])
				ifTrue: [stream nextPut: c]].
		string := stream contents copyFrom: 1 to: (stream contents indexOf: $.)
				+ 1.
		ex return: string asNumber]! !


!MessageSpy class methodsFor: 'defaults' stamp: 'nishis 11/29/1998 05:39'!
defaultHowOften
	^10! !

!MessageSpy class methodsFor: 'defaults' stamp: 'nishis 11/29/1998 05:39'!
defaultOmitValue
	^0.01! !


!MessageSpy class methodsFor: 'saving' stamp: 'nishis 12/7/98 05:21'!
save
	"MessageSpy save."

	| fileName classCollection aStream timeStamp |
	fileName := 'MsgSpy.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today printString, ' ' , Time now printString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (Character cr asString, 
							self comment asString, Character cr asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr.
					aStream cr]].
	aStream close.
	^classCollection! !

!MessageSpy class methodsFor: 'saving' stamp: 'nishis 11/29/1998 06:00'!
saveClasses
	"MessageSpy saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*MessageSpy*' '*SpyRecord*').
	classCollection := (SystemOrganization superclassOrder: self category).
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 02:42'!
example1
	"MessageSpy example1."

	| aBlock |
	aBlock := [ScheduledControllers restore].
	World ifNotNil: 
		[aBlock := 
			[ScheduledControllers restore.
			World fullRepaintNeeded]].
	^MessageSpy spy: aBlock! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 02:43'!
example2
	"MessageSpy example2."

	| aBlock |
	aBlock := [ScheduledControllers restore].
	World ifNotNil: 
		[aBlock := 
			[ScheduledControllers restore.
			World fullRepaintNeeded]].
	^MessageSpy
		spy: aBlock
		often: 50! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 02:43'!
example3
	"MessageSpy example3."

	| aBlock |
	aBlock := [ScheduledControllers restore].
	World ifNotNil: 
		[aBlock := 
			[ScheduledControllers restore.
			World fullRepaintNeeded]].
	^MessageSpy
		spy: aBlock
		often: 100
		omit: 0.1! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 02:43'!
example4
	"MessageSpy example4."

	| aSpy aModel aBlock |
	aBlock := [ScheduledControllers restore].
	World ifNotNil: 
		[aBlock := 
			[ScheduledControllers restore.
			World fullRepaintNeeded]].
	aSpy := MessageSpy on: aBlock.
	aSpy howOften: 50.
	aSpy omitValue: 0.2.
	aSpy spy.
	aModel := StringHolder new contents: aSpy result.
	StringHolderView open: aModel label: 'Message Spy'.
	^aSpy! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 02:38'!
example5
	"MessageSpy example5."

	| aSpy aModel aBlock |
	aBlock := [ScheduledControllers restore].
	World ifNotNil: 
		[aBlock := 
			[ScheduledControllers restore.
			World fullRepaintNeeded]].
	aSpy := MessageSpy on: aBlock.
	aSpy howOften: self defaultHowOften.
	aSpy omitValue: self defaultOmitValue.
	aSpy spy.
	aModel := StringHolder new contents: aSpy result.
	StringHolderView open: aModel label: 'Message Spy'.
	^aSpy! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 04:12'!
example6
	"MessageSpy example6."

	^MessageSpy spy: [Smalltalk allCallsOn: #+]! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/1/1998 03:08'!
example7
	"MessageSpy example7."

	^MessageSpy spy: [Transcript cr; show: 26 benchFib printString]! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 03:36'!
example8
	"MessageSpy example8."

	| repeats aBlock roundTime |
	aBlock := [10 benchmark].
	roundTime := (Time millisecondsToRun: aBlock) max: 1.
	repeats := 60 * 1000 // roundTime.
	^MessageSpy spy: [repeats timesRepeat: aBlock]! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 03:36'!
example9
	"MessageSpy example9."

	| aMessageSpy |
	aMessageSpy := MessageSpy exampleSpyBlock.
	^MessageSpy spy: [10 timesRepeat: [aMessageSpy spy]]! !

!MessageSpy class methodsFor: 'examples' stamp: 'nishis 12/7/1998 03:36'!
exampleSpyBlock
	^MessageSpy on: [10 benchmark]! !
