'Goodies (11/18/2001 8:34:52 am)'.!


Array variableSubclass: #PrologScannerTable
	instanceVariableNames: ''
	classVariableNames: 'ScanningTable '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologScannerTable commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologScannerTable methodsFor: 'accessing'!
at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^#xSymbol]
				ifFalse: [^#xBinary]].
	index = 0 ifTrue: [^#xDelimiter].
	^super at: index! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologScannerTable class
	instanceVariableNames: ''!

!PrologScannerTable class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologScannerTable class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologScannerTable class methodsFor: 'copyright'!
version
	^'003'! !


!PrologScannerTable class methodsFor: 'class initialization'!
initialize
	"PrologScannerTable initialize."

	| newTable |
	newTable := self new: 256 withAll: #xBinary.
	newTable atAll: #(9 10 12 13 32 ) put: #xDelimiter.
	newTable atAll: ($0 asInteger to: $9 asInteger) put: #xDigit.
	newTable atAll: ($A asInteger to: $Z asInteger) put: #xVariable.
	newTable at: $~ asInteger put: #xVariable.
	newTable atAll: ($a asInteger to: $z asInteger) put: #xSymbol.
	128 to: 256 do: [:i | newTable at: i put: #xSymbol].
	#($!! $: $* $/ $\ $> $< $= $_) do: [:each | newTable at: each asInteger put: #xSymbol].
	newTable at: $^ asInteger put: #eof.
	newTable at: $" asInteger put: #xDoubleQuote.
	newTable at: $$ asInteger put: #xDollar.
	newTable at: $' asInteger put: #xSingleQuote.
	newTable at: $( asInteger put: #leftParenthesis.
	newTable at: $) asInteger put: #rightParenthesis.
	newTable at: $. asInteger put: #period.
	newTable at: $: asInteger put: #xColon.
	newTable at: $? asInteger put: #xColon.
	newTable at: $; asInteger put: #semicolon.
	newTable at: $[ asInteger put: #leftBracket.
	newTable at: $] asInteger put: #rightBracket.
	newTable at: ${ asInteger put: #leftBrace.
	newTable at: $} asInteger put: #rightBrace.
	newTable at: $, asInteger put: #comma.
	newTable at: $| asInteger put: #verticalBar.
	newTable at: $+ asInteger put: #xSign.
	newTable at: $- asInteger put: #xSign.
	newTable at: $% asInteger put: #xComment.
	ScanningTable := newTable! !


!PrologScannerTable class methodsFor: 'table access'!
scannerTable
	^ScanningTable! !


PrologScannerTable initialize!
