'Goodies (11/18/2001 8:34:52 am)'.!


Object subclass: #MessageTracer
	instanceVariableNames: 'targetBlock rootContext currentContext returnObject reportStream '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Tracer'!
!MessageTracer commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Message Tracer
Sent Message Tracing Goodies for Squeak. 

Yet Another ContextPart>>trace:

It runs on Squeak 1.31 (MVC), 2.3 beta (MVC or Morphic)

This goodies is a modification for Squeak,
originaly written by Mr. AOKI.
Message Tracer
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05

see below 
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/MsgTrace.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/MsgTrace.txt

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@nifty.ne.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!MessageTracer methodsFor: 'accessing' stamp: 'nishis 12/4/1998 14:07'!
on: aBlock 
	targetBlock := aBlock! !

!MessageTracer methodsFor: 'accessing' stamp: 'nishis 12/2/1998 16:50'!
reporter
	reportStream isNil ifTrue: [^Transcript].
	^reportStream! !

!MessageTracer methodsFor: 'accessing' stamp: 'nishis 12/2/1998 14:59'!
reporter: aStream 
	reportStream := aStream! !

!MessageTracer methodsFor: 'accessing' stamp: 'nishis 12/6/1998 02:02'!
value
	targetBlock hasMethodReturn
		ifTrue: [^self inform: 'simulation of blocks with ^ can run loose.'; yourself].
	self traceInitialize.
	self traceLoop.
	self traceTerminate.
	^returnObject! !


!MessageTracer methodsFor: 'tracing' stamp: 'nishis 11/7/2001 23:45'!
traceInitialize
	rootContext := MethodContext 
						sender: nil 
						receiver: nil 
						method: self rootMethod 
						arguments: #().
	currentContext := (BlockContext newForMethod: targetBlock method)
						home: targetBlock home 
						startpc: targetBlock pc 
						nargs: targetBlock numArgs.
	self senderIsYou.
	currentContext pushArgs: Array new from: rootContext! !

!MessageTracer methodsFor: 'tracing' stamp: 'nishis 12/7/1998 01:39'!
traceLoop
	"Browser fullOnClass: ContextPart class selector: #trace:."
	"Browser fullOnClass: ContextPart selector: #runSimulated:contextAtEachStep:."

	[Cursor write showWhile: [self traceReport].
	currentContext := currentContext step.
	currentContext == rootContext] 
		whileFalse: 
			[].
	returnObject := rootContext pop! !

!MessageTracer methodsFor: 'tracing' stamp: 'nishis 12/7/1998 01:53'!
traceReport
	"aContext isKindOf: BlockContext ifTrue: 'tempAt:' returns BlockContext's home at: index.
	So use not 'tempAt:' but 'at:'.  see below, 
	Browser fullOnClass: BlockContext selector: #tempAt:.
	Browser fullOnClass: ContextVariablesInspector selector: #selection."

	| sender receiver selector count argument |
	currentContext willSend 
		ifTrue:
			[(selector := self peekForSelector: currentContext) isNil ifTrue: [^nil].
			self stackPointer - selector numArgs < 1 ifTrue: [^nil].
			receiver := currentContext at: self stackPointer - selector numArgs.
			(receiver respondsTo: selector) 
				ifFalse: [^nil].
			sender := self senderFromContext: currentContext.
			self reporter nextPutAll: (self objectString: sender).
			self reporter nextPutAll: ' sent '.
			self reporter nextPutAll: (self objectString: receiver). 
			self reporter nextPutAll: ' '.
			self reporter nextPutAll: '#' , selector printString.
			selector numArgs > 0
				ifTrue: 
					[self reporter nextPutAll: ' with '.
					count := selector numArgs - 1.
					[count >= 0]
						whileTrue: 
							[argument := currentContext at: self stackPointer - count.
							self reporter nextPutAll: (self objectString: argument).
							count > 1 ifTrue: [self reporter nextPutAll: ', '].
							count = 1 ifTrue: [self reporter nextPutAll: ' and '].
							count := count - 1]].
			self reporter nextPutAll: '.'.
			self reporter cr.
			(self reporter respondsTo: #endEntry) ifTrue: [self reporter endEntry].
			(self reporter respondsTo: #flush) ifTrue: [self reporter flush]]! !

!MessageTracer methodsFor: 'tracing' stamp: 'nishis 12/4/1998 11:44'!
traceTerminate
	rootContext := nil.
	currentContext := nil! !


!MessageTracer methodsFor: 'private' stamp: 'nishis 12/3/1998 17:09'!
objectString: object 
	| string1 string2 |
	string1 := object class name.
	(string1 at: 1) isVowel
		ifTrue: [string1 := 'an ' , string1]
		ifFalse: [string1 := 'a ' , string1].
	[string2 := object printString] 
		ifError: [:err :rcvr | string2 := string1].
	string1 size < string2 size
		ifTrue: [^string1]
		ifFalse: [^string2]! !

!MessageTracer methodsFor: 'private' stamp: 'nishis 12/5/1998 18:38'!
peekForSelector: aContext
	"Browser fullOnClass: InstructionStream selector: #addSelectorTo:."

	| selectors |
	selectors := Set new.
	aContext addSelectorTo: selectors.
	^selectors detect: [:element | element notNil] ifNone: [nil]! !

!MessageTracer methodsFor: 'private' stamp: 'nishis 11/11/2001 02:47'!
rootMethod
	"^CompiledMethod newBytes: 0 nArgs: 0 nTemps: 0 nStack: 0 nLits: 0 primitive: 256"
	"^CompiledMethod newBytes: 0 trailerBytes: #(0 0 0 0) nArgs: 0 nTemps: 0 nStack: 0 nLits: 0 primitive: 256"
	| compiledMethod trailer |
	true ifTrue: [^CompiledMethod newBytes: 0 nArgs: 0 nTemps: 0 nStack: 0 nLits: 0 primitive: 256].
	trailer := #(0 0 0 0).
	compiledMethod := CompiledMethod newMethod: trailer size
		header: 256.
	1 to: trailer size do:  "Copy the source code trailer to the end"
		[:i | compiledMethod at: compiledMethod size - trailer size + i put: (trailer at: i)].
	^compiledMethod! !

!MessageTracer methodsFor: 'private' stamp: 'nishis 12/6/1998 09:08'!
senderFromContext: aContext
	((aContext receiver == rootContext receiver) and: [aContext sender ~= rootContext])
		ifTrue: [^aContext]	"from root but in targetBlock."
		ifFalse: [^aContext receiver]! !

!MessageTracer methodsFor: 'private' stamp: 'nishis 12/7/1998 01:51'!
senderIsYou
	currentContext home instVarAt: (MethodContext allInstVarNames indexOf: #receiver) put: nil! !

!MessageTracer methodsFor: 'private' stamp: 'nishis 12/5/1998 19:22'!
stackPointer
	"ContextPart>>stackPtr is For use only by the SystemTracer."
	^currentContext instVarAt: (ContextPart allInstVarNames indexOf: #stackp)! !


!MessageTracer methodsFor: 'debug' stamp: 'nishis 12/2/1998 21:55'!
debug: aBlock
	"aBlock value"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageTracer class
	instanceVariableNames: ''!

!MessageTracer class methodsFor: 'copyright' stamp: 'nishis 12/2/1998 15:03'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!MessageTracer class methodsFor: 'copyright' stamp: 'nishis 12/2/1998 15:04'!
system
	^'Goodies'! !

!MessageTracer class methodsFor: 'copyright' stamp: 'nishis 12/2/1998 15:04'!
version
	^'003'! !


!MessageTracer class methodsFor: 'instance creation' stamp: 'nishis 12/5/1998 02:45'!
on: aBlock 
	^super new on: aBlock! !

!MessageTracer class methodsFor: 'instance creation' stamp: 'nishis 12/2/1998 15:06'!
value: aBlock 
	| messageTracer |
	messageTracer := MessageTracer on: aBlock.
	^messageTracer value! !


!MessageTracer class methodsFor: 'saving' stamp: 'nishis 12/7/98 05:21'!
save
	"MessageTracer save."

	| fileName classCollection aStream timeStamp |
	fileName := 'MsgTrace.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today printString, ' ' , Time now printString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (Character cr asString, 
							self comment asString, Character cr asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr.
					aStream cr]].
	aStream close.
	^classCollection! !

!MessageTracer class methodsFor: 'saving' stamp: 'nishis 12/2/1998 15:05'!
saveClasses
	"MessageTracer saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*MessageTracer*').
	classCollection := (SystemOrganization superclassOrder: self category).
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!MessageTracer class methodsFor: 'examples' stamp: 'nishis 12/7/1998 03:11'!
example1
	"MessageTracer example1."

	Transcript cr.
	^MessageTracer value: [#('a' 'b' 'c' 'd' 'e') select: [:each | each > 'c']]! !

!MessageTracer class methodsFor: 'examples' stamp: 'nishis 12/5/1998 18:32'!
example2
	"MessageTracer example2."

	| aBlock aTracer aStream anObject aModel |
	aBlock := [#('a' 'b' 'c' 'd' 'e') select: [:each | each > 'c']].
	aTracer := MessageTracer on: aBlock.
	aStream := WriteStream on: String new.
	aTracer reporter: aStream.
	anObject := aTracer value.
	aModel := StringHolder new contents: aStream contents.
	StringHolderView open: aModel label: 'Trace'.
	^anObject! !

!MessageTracer class methodsFor: 'examples' stamp: 'nishis 12/2/1998 15:08'!
example3
	"MessageTracer example3."

	| aBlock aTracer aStream anObject |
	aBlock := [#('a' 'b' 'c' 'd' 'e') select: [:each | each > 'c']].
	aTracer := MessageTracer on: aBlock.
	aStream := FileStream newFileNamed: 'Trace.txt'.
	aTracer reporter: aStream.
	[anObject := aTracer value.
	aStream close]
		ifError: [:err :rcvr | aStream close].
	^anObject! !

!MessageTracer class methodsFor: 'examples' stamp: 'nishis 12/3/1998 03:24'!
example4
	"MessageTracer example4."

	| aBlock aTracer aStream anObject aModel |
	aBlock := [3 factorial].
	aTracer := MessageTracer on: aBlock.
	aStream := WriteStream on: String new.
	aTracer reporter: aStream.
	anObject := aTracer value.
	aModel := StringHolder new contents: aStream contents.
	StringHolderView open: aModel label: 'Trace'.
	^anObject! !

!MessageTracer class methodsFor: 'examples' stamp: 'nishis 12/3/1998 11:44'!
example5
	"MessageTracer example5."

	| aBlock aTracer aStream anObject aModel |
	aBlock := [3.14159 printString].
	aTracer := MessageTracer on: aBlock.
	aStream := WriteStream on: String new.
	aTracer reporter: aStream.
	anObject := aTracer value.
	aModel := StringHolder new contents: aStream contents.
	StringHolderView open: aModel label: 'Trace'.
	^anObject! !
