'Goodies (11/18/2001 8:34:53 am)'.!


MouseMenuController subclass: #HistogramController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Histogram'!

!HistogramController methodsFor: 'basic control sequence'!
controlTerminate
	Cursor normal show! !


!HistogramController methodsFor: 'control defaults' stamp: 'nishis 6/28/1998 06:20'!
controlActivity
	(Sensor redButtonPressed and: [self viewHasCursor])
		ifTrue: [^self redButtonActivity].
	(Sensor yellowButtonPressed and: [self viewHasCursor])
		ifTrue: [^self yellowButtonActivity].
	self idleActivity! !

!HistogramController methodsFor: 'control defaults' stamp: 'nishis 7/19/1998 02:33'!
idleActivity
	| boxes point cursor |
	(boxes := view boxCollection) isNil ifTrue: [^self].
	cursor := Cursor currentCursor.
	point := Sensor cursorPoint - view insetDisplayBox topLeft.
	(boxes findFirst: [:box | box containsPoint: point])
		> 0
		ifTrue: [cursor = Cursor crossHair ifFalse: [Cursor crossHair show]]
		ifFalse: [cursor = Cursor normal ifFalse: [Cursor normal show]]! !

!HistogramController methodsFor: 'control defaults' stamp: 'nishis 5/23/98 05:44'!
redButtonActivity
	| boxes point sections |
	(boxes := view boxCollection) isNil ifTrue: [^self].
	point := Sensor cursorPoint - view insetDisplayBox topLeft.
	[Sensor redButtonPressed]
		whileTrue: 
			[point := Sensor cursorPoint - view insetDisplayBox topLeft.
			self idleActivity].
	sections := self model sections.
	1 to: boxes size do: [:index | (((boxes at: index)
			containsPoint: point)
			and: [index <= sections size])
			ifTrue: 
				[self controlTerminate.
				^self model showItems: (sections at: index)]].
	^nil! !

!HistogramController methodsFor: 'control defaults' stamp: 'nishis 7/19/1998 02:36'!
yellowButtonActivity
	| menu selector |
	(menu := self model yellowButtonMenu) isNil ifTrue: [^self].
	self controlTerminate.
	selector := menu startUp.
	(selector isNil or: [selector = 0])
		ifTrue: [^self].
	self model perform: selector! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HistogramController class
	instanceVariableNames: ''!

!HistogramController class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!HistogramController class methodsFor: 'copyright'!
system
	^'Goodies'! !

!HistogramController class methodsFor: 'copyright'!
version
	^'003'! !
