'Goodies (11/18/2001 8:34:53 am)'.!


Array variableSubclass: #PrologCharMap
	instanceVariableNames: ''
	classVariableNames: 'SymbolMap VariableMap '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologCharMap commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologCharMap methodsFor: 'accessing'!
at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^true]
				ifFalse: [^false]].
	index = 0 ifTrue: [^false].
	^super at: index! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologCharMap class
	instanceVariableNames: ''!

!PrologCharMap class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologCharMap class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologCharMap class methodsFor: 'copyright'!
version
	^'003'! !


!PrologCharMap class methodsFor: 'class initialization'!
initialize
	"PrologCharMap initialize"

	self initializeSymbolMap.
	self initializeVariableMap! !

!PrologCharMap class methodsFor: 'class initialization'!
initializeSymbolMap
	| newMap |
	newMap := self new: 256 withAll: false.
	newMap atAll: ($0 asInteger to: $9 asInteger)
		put: true.
	newMap atAll: ($A asInteger to: $Z asInteger)
		put: true.
	newMap atAll: ($a asInteger to: $z asInteger)
		put: true.
	128 to: 256 do: [:i | newMap at: i put: true].
	#($+ $- $!! $: $* $/ $\ $> $< $= $_) do: [:each | newMap at: each asInteger put: true].
	SymbolMap := newMap! !

!PrologCharMap class methodsFor: 'class initialization'!
initializeVariableMap
	| newMap |
	newMap := self new: 256 withAll: false.
	newMap atAll: ($0 asInteger to: $9 asInteger)
		put: true.
	newMap atAll: ($A asInteger to: $Z asInteger)
		put: true.
	newMap atAll: ($a asInteger to: $z asInteger)
		put: true.
	newMap at: $~ asInteger put: true.
	VariableMap := newMap! !


!PrologCharMap class methodsFor: 'table access'!
symbolMap
	^SymbolMap! !

!PrologCharMap class methodsFor: 'table access'!
variableMap
	^VariableMap! !


PrologCharMap initialize!
