'Goodies (11/18/2001 8:34:54 am)'.!


Object subclass: #ImageProcessorExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Images'!
!ImageProcessorExample commentStamp: '<historical>' prior: 0!
The class ported for Squeak from 'Bout With Cancer' by Mr. AOKI Atsushi.

see http://www.sra.co.jp/people/aoki/BoutWithCancer/index.html
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ImageProcessorExample class
	instanceVariableNames: ''!

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 03:45'!
example0
	"ImageProcessorExample example0."

	| filename image |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	ImageProcessor show: image label: 'Program 0'.
	^image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 03:45'!
example1
	"ImageProcessorExample example1."

	| filename image bwImage |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	ImageProcessor show: bwImage label: 'Program 1'.
	^image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 05:23'!
example2
	"ImageProcessorExample example2."

	| filename image bwImage extent lineForm displayPoint clearBlock polylines savedArea |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	lineForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: Color red.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			polylines := ImageProcessor traceBorder: bwImage 
					interim: 
						[:point | 
						(Line from: point to: point withForm: lineForm) 
							displayOn: Display at: displayPoint;
							displayOn: image]].
	savedArea displayOn: Display at: displayPoint - 1.
	ImageProcessor show: image label: 'Program 2'.
	^polylines! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 04:50'!
example3
	"ImageProcessorExample example3."

	| filename image bwImage extent lineForm displayPoint clearBlock polylines savedArea boxes box random color |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	lineForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: Color red.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			polylines := ImageProcessor traceBorder: bwImage 
					interim: 
						[:point | 
						(Line from: point to: point withForm: lineForm) 
							displayOn: Display at: displayPoint;
							displayOn: image].
			boxes := OrderedCollection new.
			polylines 
				do: 
					[:polyline | 
					box := nil.
					polyline do: [:point | box isNil 
							ifTrue: [box := point extent: 1 @ 1]
							ifFalse: [box := box merge: (point extent: 1 @ 1)]].
					boxes add: box].
			random := Random new.
			polylines with: boxes 
				do: 
					[:polyline :eachBox | 
					color := Color 
							r: random next
							g: random next
							b: random next.
					[0.75 > color luminance and: [color luminance > 0.25]]
						whileFalse: [color := Color 
										r: random next
										g: random next
										b: random next].
					self displayRectangleOn: Display 
							rectangle: eachBox 
							at: displayPoint 
							fillColor: color 
							paintColor: color.
					self displayRectangleOn: image 
							rectangle: eachBox 
							at: 0 @ 0 
							fillColor: color 
							paintColor: color.
					color := Color black.
					self displayPolylineOn: Display 
							points: polyline 
							at: displayPoint 
							color: color.
					self displayPolylineOn: image 
							points: polyline 
							at: 0 @ 0 
							color: color]].
	savedArea displayOn: Display at: displayPoint - 1.
	ImageProcessor show: image label: 'Program 3'.
	^polylines! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 06:25'!
example4
	"ImageProcessorExample example4."

	| image bwImage extent lineForm displayPoint clearBlock polylines savedArea boxes box color collection sortBlock |
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: 'HyoGan2.bmp'].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	lineForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: Color red.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			polylines := ImageProcessor traceBorder: bwImage 
					interim: 
						[:point | 
						(Line from: point to: point withForm: lineForm) 
							displayOn: Display at: displayPoint;
							displayOn: image].
			boxes := OrderedCollection new.
			polylines 
				do: 
					[:polyline | 
					box := nil.
					polyline do: [:point | box isNil 
							ifTrue: [box := point extent: 1 @ 1]
							ifFalse: [box := box merge: (point extent: 1 @ 1)]].
					boxes add: box].
			collection := SortedCollection new.
			sortBlock := [:assoc1 :assoc2 | assoc1 key > assoc2 key].
			collection sortBlock: sortBlock.
			polylines with: boxes do: [:polyline :eachBox | collection add: eachBox area -> (polyline -> eachBox)].
			polylines := ((collection copyFrom: 1 to: (10 min: collection size)) sortBlock: sortBlock)
							collect: [:association | association value key].
			boxes := ((collection copyFrom: 1 to: (10 min: collection size)) sortBlock: sortBlock)
							collect: [:association | association value value].
			polylines with: boxes 
				do: 
					[:polyline :eachBox | 
					color := Color yellow.
					self displayRectangleOn: Display 
							rectangle: eachBox 
							at: displayPoint 
							fillColor: color 
							paintColor: color.
					self displayRectangleOn: image 
							rectangle: eachBox 
							at: 0 @ 0 
							fillColor: color 
							paintColor: color.
					color := Color red.
					self displayPolylineOn: Display 
							points: polyline 
							at: displayPoint 
							color: color.
					self displayPolylineOn: image 
							points: polyline 
							at: 0 @ 0 
							color: color]].
	savedArea displayOn: Display at: displayPoint - 1.
	ImageProcessor show: image label: 'Program 4'.
	^polylines! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 06:25'!
example5
	"ImageProcessorExample example5."

	"Cannot compile--stack including temps is too deep"
	| filename image bwImage displayPoint extent savedArea clearBlock polylines boxes collection array sortBlock startTime |
	filename := self filename.
	startTime := Time now.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	displayPoint := Display boundingBox center - ((bwImage boundingBox extent) / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	extent := bwImage boundingBox extent.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			image displayOn: Display at: displayPoint.
			polylines := ImageProcessor traceBorder: bwImage 
					interim: 
						[:point | 
						self displayLineOn: Display 
								from: point 
								to: point 
								at: displayPoint 
								color: Color red.
						self displayLineOn: image 
								from: point 
								to: point 
								at: 0 @ 0 
								color: Color red].
			boxes := self boxesMergedWith: polylines.
			sortBlock := [:association1 :association2 | association1 key > association2 key].
			collection := self collectionFrom: polylines with: boxes sortBlock: sortBlock.
			polylines := self polylinesCollectedFrom: collection sortBlock: sortBlock.
			boxes := self boxesCollectedFrom: collection sortBlock: sortBlock.
			collection := self polylineAndBoxFrom: polylines with: boxes.
			(collection copyFrom: 1 to: 1) 
				do: 
					[:association | 
					array := self sortedAssociationKeyFrom: association.
					array := array copyFrom: 1 to: (4 min: array size).
					array 
						do: 
							[:polyline | 
							self displayPolygonOn: Display 
									points: polyline 
									at: displayPoint 
									color: Color yellow.
							self displayPolygonOn: image 
									points: polyline 
									at: 0 @ 0 
									color: Color yellow]]].
	savedArea displayOn: Display at: displayPoint - 1.
	Transcript cr; show: 'Program 5: ', (Time now asSeconds - startTime asSeconds) printString.
	ImageProcessor show: image label: 'Program 5'.
	^polylines! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 05:23'!
example6
	"ImageProcessorExample example6."

	| filename image bwImage extent displayPoint clearBlock savedArea |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			image := ImageProcessor makeThin: bwImage 
					interim: 
						[:img | img displayOn: Display at: displayPoint]].
	savedArea displayOn: Display at: displayPoint - 1.
	ImageProcessor show: image label: 'Program 6'.
	^image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 05:24'!
example6b
	"ImageProcessorExample example6b."

	| filename image bwImage extent displayPoint clearBlock savedArea |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			image := ImageProcessor makeThin2: bwImage 
					interim: 
						[:img | img displayOn: Display at: displayPoint]].
	savedArea displayOn: Display at: displayPoint - 1.
	ImageProcessor show: image label: 'Program 6'.
	^image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 21:44'!
example6c
	"ImageProcessorExample example6c."

	| filename image bwImage extent displayPoint clearBlock savedArea |
	filename := 'HyoGan2.bmp'.
	"filename := 'hv2.BMP'."
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	Transcript cr; show: 'Program 6c: ', (Time millisecondsToRun: 
	[bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			image := ImageProcessor makeThin2: bwImage 
					interim: 
						[:img | img displayOn: Display at: displayPoint]].
	savedArea displayOn: Display at: displayPoint - 1.
	]) printString.
	ImageProcessor show: image label: 'Program 6'.
	^image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 21:44'!
example6d
	"ImageProcessorExample example6d."

	| filename image bwImage extent displayPoint clearBlock savedArea |
	filename := '300.bmp'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	Transcript cr; show: 'Program 6d: ', (Time millisecondsToRun: 
	[bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	image := Form extent: extent depth: Display depth.
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			image := ImageProcessor makeThin2: bwImage 
					interim: 
						[:img | img displayOn: Display at: displayPoint]].
	savedArea displayOn: Display at: displayPoint - 1.
	]) printString.
	ImageProcessor show: image label: 'Program 6'.
	^image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 03:51'!
example7
	"ImageProcessorExample example7."

	| filename image bwImage extent displayPoint clearBlock savedArea original polylines color lineForm collection thin thinAndImage |
	filename := 'HyoGan2.bmp'.
	Cursor read
		showWhile: 
			[original := image := Form fromBMPFileNamed: filename].
	bwImage := Form extent: image extent.
	image displayOn: bwImage.
	extent := bwImage boundingBox extent.
	lineForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: Color red.
	displayPoint := Display boundingBox center - (extent / 2) rounded.
	clearBlock := [:ext | ((Form extent: ext + 2) fillWhite borderWidth:1) displayOn: Display at: displayPoint - 1].
	Cursor wait 
		showWhile: 
			[savedArea := Form fromDisplay: (displayPoint - 1 extent: extent + 2).
			clearBlock value: extent.
			image displayOn: Display at: displayPoint.
			thin := image := ImageProcessor makeThin: bwImage 
					interim: 
						[:img | img displayOn: Display at: displayPoint].
			polylines := ImageProcessor traceBorder: image 
					 interim: 
						[:point | 
						color := Color red.
						(Line from: point to: point withForm: lineForm) 
							displayOn: Display at: displayPoint;
							displayOn: image].
			image := Form extent: extent depth: Display depth.
			original displayOn: Display at: displayPoint clippingBox: (displayPoint - 1 extent: extent + 2).
			original displayOn: image.
			polylines 
				do: 
					[:polyline | 
					color := Color red.
					self displayPolylineOn: Display 
							points: polyline 
							at: displayPoint 
							color: color.
					self displayPolylineOn: image 
							points: polyline 
							at: 0 @ 0 
							color: color].
			collection := polylines asSortedCollection: [:polyline1 :polyline2 | polyline1 size > polyline2 size].
			(collection copyFrom: 1 to: (1 min: collection size)) 
				do: 
					[:polyline | 
					color := Color yellow.
					self displayPolylineOn: Display 
							points: polyline 
							at: displayPoint 
							color: color.
					self displayPolylineOn: image 
							points: polyline 
							at: 0 @ 0 
							color: color]].
	savedArea displayOn: Display at: displayPoint - 1.
	thinAndImage := Form extent: (image extent scaleBy: 2 @ 1) + (3 @ 2) depth: Display depth.
	thinAndImage borderWidth: 1.
	thinAndImage drawLine: (Form dotOfSize: 1) 
			from: thinAndImage boundingBox topCenter 
			to: thinAndImage boundingBox bottomCenter 
			clippingBox: thinAndImage boundingBox 
			rule: Form paint 
			fillColor: nil.
	thin displayOn: thinAndImage at: thinAndImage boundingBox origin + 1.
	image displayOn: thinAndImage at: thin boundingBox topRight + (2 @ 1).
	ImageProcessor show: image label: 'Program 7'.
	^Array with: thin with: image! !

!ImageProcessorExample class methodsFor: 'examples' stamp: 'nishis 10/19/1998 03:49'!
exampleGrayScale
	"ImageProcessorExample exampleGrayScale."

	| filename image |
	filename := 'hv2.BMP'.
	Cursor read
		showWhile: 
			[image := Form fromBMPFileNamed: filename].
	ImageProcessor show: image asGrayScale label: 'Program GrayScale'.
	^image! !


!ImageProcessorExample class methodsFor: 'private' stamp: 'nishis 8/18/1998 18:04'!
displayPolygonOn: graphicsContext points: points at: offsetPoint color: color
	"not implemented yet."

	| aLinearFit aForm aLineWidth |
	aLineWidth := 1 + self polygonLikeOffset.
	aLinearFit := LinearFit new.
	aForm := Form extent: aLineWidth @ aLineWidth depth: Display depth.
	aForm fillColor: color.
	aForm offset: self polygonLikeOffset / 2 rounded negated asPoint.
	aLinearFit form: aForm.
	points do: [:point | aLinearFit add: point].
	aLinearFit displayOn: graphicsContext at: offsetPoint clippingBox: graphicsContext boundingBox "rule: Form and fillColor: nil"! !

!ImageProcessorExample class methodsFor: 'private' stamp: 'nishis 8/18/1998 16:23'!
displayPolylineOn: graphicsContext points: points at: offsetPoint color: color
	| aLinearFit aForm  |
	aLinearFit := LinearFit new.
	aForm := Form extent: 1 @ 1 depth: graphicsContext depth.
	aForm fillColor: color.
	aLinearFit form: aForm.
	points do: [:point | aLinearFit add: point].
	aLinearFit displayOn: graphicsContext at: offsetPoint clippingBox: graphicsContext boundingBox "rule: Form and fillColor: nil"! !

!ImageProcessorExample class methodsFor: 'private' stamp: 'nishis 10/19/1998 04:39'!
displayRectangleOn: graphicsContext rectangle: rectangle at: offsetPoint fillColor: fillColor paintColor: paintColor
	(Form extent: rectangle extent depth: Display depth)
		fillColor: fillColor;
		borderWidth: 1 color: paintColor;
		displayOn: graphicsContext at: offsetPoint + rectangle origin
! !

!ImageProcessorExample class methodsFor: 'private' stamp: 'nishis 8/18/1998 18:03'!
polygonLikeOffset
	^2! !


!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/26/1998 22:53'!
boxesCollectedFrom: collection sortBlock: sortBlock
	| boxes |
	boxes := ((collection copyFrom: 1 to: (10 min: collection size)) sortBlock: sortBlock) 
				collect: [:association | association value value].
	^boxes! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/18/1998 20:55'!
boxesMergedWith: polylines
	| boxes box |
	boxes := OrderedCollection new.
	polylines 
		do: 
			[:polyline | 
			box := nil.
			polyline do: [:point | box isNil 
					ifTrue: [box := point extent: 1 @ 1]
					ifFalse: [box := box merge: (point extent: 1 @ 1)]].
			boxes add: box].
	^boxes! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/26/1998 22:51'!
collectionFrom: polylines with: boxes sortBlock: sortBlock
	| collection |
	collection := SortedCollection new.
	collection sortBlock: sortBlock.
	polylines with: boxes do: [:polyline :eachBox | collection add: eachBox area -> (polyline -> eachBox)].
	^collection
! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/18/1998 20:28'!
displayLineOn: graphicsContext from: from to: to at: offsetPoint color: color
	| lineForm |
	lineForm := (Form extent: 1 @ 1 depth: Display depth) fillColor: color.
	(Line from: from to: to withForm: lineForm) 
			displayOn: graphicsContext at: offsetPoint! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/18/1998 20:21'!
filename
	| filename |
	 filename := FillInTheBlank
		request: 'Input BMP file name.'
		initialAnswer: 'HyoGan2.bmp'.
	^(FileStream readOnlyFileNamed: filename) name! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/18/1998 20:49'!
polylineAndBoxFrom: polylines with: boxes
	| collection array box |
	collection := OrderedCollection new.
	polylines with: boxes 
		do: 
			[:polyline :box1 | 
			array := Array with: polyline.
			box := box1.
			polylines with: boxes do: [:polyline2 :box2 | (box intersects: box2) 
					ifTrue: 
						[array := array , (Array with: polyline2).
						 box := box merge: box2]].
			collection add: array -> box].
	^collection
! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/26/1998 22:51'!
polylinesCollectedFrom: collection sortBlock: sortBlock
	| polylines |
	polylines := ((collection copyFrom: 1 to: (10 min: collection size)) sortBlock: sortBlock)
					collect: [:association | association value key].
	^polylines
! !

!ImageProcessorExample class methodsFor: 'private for example5' stamp: 'nishis 8/18/1998 21:02'!
sortedAssociationKeyFrom: association
	| array |
	array := (association key asSortedCollection: [:polyline1 :polyline2 | polyline1 size > polyline2 size]) asArray.
	^array
! !


!ImageProcessorExample class methodsFor: 'documentation' stamp: 'nishis 8/19/1998 00:04'!
readMe
"
	The class ported for Squeak from 'Bout With Cancer' by Mr. AOKI Atsushi.

	see http://www.sra.co.jp/people/aoki/BoutWithCancer/index.html
"! !
