'Goodies (11/18/2001 8:34:56 am)'.!


ScheduledView subclass: #AlteredScheduledView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-ScheduledVC'!

!AlteredScheduledView methodsFor: 'controller access' stamp: 'nishis 5/15/98 23:02'!
defaultControllerClass
	^AlteredScheduledController! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AlteredScheduledView class
	instanceVariableNames: ''!

!AlteredScheduledView class methodsFor: 'copyright' stamp: 'nishis 5/15/98 23:03'!
copyright
	^'Copyright (C) 1998 NISHIHARA Satoshi, All Rights Reserved.'! !

!AlteredScheduledView class methodsFor: 'copyright' stamp: 'nishis 5/15/98 23:03'!
system
	^'Goodies'! !

!AlteredScheduledView class methodsFor: 'copyright' stamp: 'nishis 5/15/98 23:03'!
version
	^'001'! !


!AlteredScheduledView class methodsFor: 'instance creation' stamp: 'nishis 5/15/98 23:33'!
model: aModel label: aString minimumSize: aPoint
	| scheduledView |
	scheduledView := self new.
	scheduledView model: aModel.
	scheduledView label: aString.
	scheduledView minimumSize: aPoint + scheduledView labelOffset..
	scheduledView borderWidth: 1.
	^scheduledView! !

!AlteredScheduledView class methodsFor: 'instance creation' stamp: 'nishis 5/15/98 23:33'!
model: aModel label: aString minimumSize: minimumPoint maximumSize: maximumPoint 
	| scheduledView |
	scheduledView := self model: aModel label: aString minimumSize: minimumPoint.
	scheduledView maximumSize: maximumPoint + scheduledView labelOffset.
	^scheduledView! !


!AlteredScheduledView class methodsFor: 'saving' stamp: 'nishis 5/15/98 23:48'!
save
	"AlteredScheduledView save."

	| patternCollection fileName classCollection fileStream |
	patternCollection := #('*Scheduled*').
	fileName := 'ASchedVC.st'.
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection select: [:aClass |
		(patternCollection detect: [:it | it match: aClass name asString] ifNone: [nil]) notNil].
	fileStream := FileStream newFileNamed: fileName.
	Cursor write showWhile: [
		fileStream nextPut: $'.
		fileStream nextPutAll: Date today printString.
		fileStream space.
		fileStream nextPutAll: Time now printString.
		fileStream nextPut: $'.
		fileStream nextChunkPut: String new.
		fileStream cr.
		fileStream cr.
		classCollection
			do: [:aClass |
				fileStream nextChunkPut: aClass definition.
				fileStream cr.
				fileStream cr].
		classCollection
			do: [:aClass |
				fileStream nextPut: Character newPage.
				aClass sharedPools size > 0
					ifTrue: [aClass shouldFileOutPools
						ifTrue: [aClass fileOutSharedPoolsOn: fileStream]].
				aClass fileOutOn: fileStream moveSource: false toFile: 0.
				fileStream cr.
				fileStream cr]].
	fileStream close! !


!AlteredScheduledView class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:41'!
example1
	"AlteredScheduledView example1."

	| topView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200
		maximumSize: 300 @ 200.
	topView controller open! !

!AlteredScheduledView class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:40'!
example2
	"AlteredScheduledView example2."

	| topView leftView rightView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200.
	leftView := View new.
	leftView borderWidth: 1.
	leftView backgroundColor: Color red.
	topView addSubView: leftView.
	rightView := View new.
	rightView borderWidth: 1.
	rightView backgroundColor: Color green.
	topView addSubView: rightView toRightOf: leftView.
	topView controller openIn: (100 @ 100 extent: topView minimumSize)
! !

!AlteredScheduledView class methodsFor: 'examples' stamp: 'nishis 6/10/1998 00:51'!
example3
	"AlteredScheduledView example3."

	| topView leftView rightView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200
		maximumSize: 300 @ 200.
	leftView := View new.
	leftView borderWidth: 1.
	leftView backgroundColor: Color red.
	topView addSubView: leftView.
	rightView := View new.
	rightView borderWidth: 1.
	rightView backgroundColor: Color green.
	topView addSubView: rightView toRightOf: leftView.
	topView controller openAt: 100 @ 100! !
