'Goodies (11/18/2001 8:34:58 am)'.!


Object subclass: #HtmlReportWriter
	instanceVariableNames: 'name categories filter header footer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Tools'!
!HtmlReportWriter commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
HTML Report Writer
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
HTML Report Writer
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/HtmlRprt.st

Summary:


This goodies makes html files describing the class specification 
such as superclass, class comment, variables, method definition, 
method comment etc.  So you can browse it using WebBrowser as 
Netscape etc.  This goodies is good for some documentaion-ing.


Installing:

FileIn this goodies and makes a class "HtmlReportWriter" in a 
category "Goodies-Tools". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"HtmlReportWriter" from your system, simply.


how to use:

The instance of the class HtmlReportWriter decides the classes 
to report by gathering on a given pattern (category) and 
passing through a given filter.  If you send a message "report", 
you can get the report of these classes.

For example, 

| aHtmlReportWriter |
aHtmlReportWriter :=
	HtmlReportWriter
		name: 'Report01'
		categories: #('Goodies*')
		filter: [:aClass | aClass name = HtmlReportWriter name].
aHtmlReportWriter report.

Above, it point the category pattern matching "Goodies*".  
Each of these classes is evaluated by aBlockContext filter, 
picking up each value is true.  In this example, the one only 
class "HtmlReportWriter" will be selected.

After above, he instance of the class HtmlReportWriter receives 
a message "report", saves the reporting files below in the 
directory "Report01".

Report01:
	Rpt00000.htm
	Rpt00001.htm


The first "Rpt00000.htm" is a index file.  The second 
"Rpt00001.htm" is a report  from HtmlReportWriter.  If there 
are more classes, produced Rpt?????.htm incrementally.

You can use these reports as Hypertexts with a WebBrowser as 
Netscape.  The classes is listing on Rpt00000.htm.

You can add header and footer on each html file, using as to 
show copyright or system information etc.  More information 
see examples.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/HtmlRprt.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/HtmlRprt.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!HtmlReportWriter methodsFor: 'accessing'!
categories
	^categories! !

!HtmlReportWriter methodsFor: 'accessing'!
filter
	^filter! !

!HtmlReportWriter methodsFor: 'accessing'!
footer
	^footer! !

!HtmlReportWriter methodsFor: 'accessing'!
footer: aString 
	footer := aString asString! !

!HtmlReportWriter methodsFor: 'accessing'!
header
	^header! !

!HtmlReportWriter methodsFor: 'accessing'!
header: aString 
	header := aString asString! !

!HtmlReportWriter methodsFor: 'accessing'!
name
	^name! !

!HtmlReportWriter methodsFor: 'accessing'!
name: nameString categories: stringArray filter: filterBlock 
	name := nameString asString.
	categories := (stringArray collect: [:each | each asString]) asArray.
	filter := filterBlock.
	^self! !


!HtmlReportWriter methodsFor: 'classes'!
allClassNames
	^self allClasses collect: [:each | each name]! !

!HtmlReportWriter methodsFor: 'classes'!
allClasses
	| rootClasses allClasses blockClosure |
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	blockClosure := [:each | ((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: [allClasses add: each]].
	rootClasses
		do: 
			[:root | 
			blockClosure value: root.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each]]].
	^allClasses asArray! !

!HtmlReportWriter methodsFor: 'classes'!
allNumberOfClasses
	^self allClasses size! !

!HtmlReportWriter methodsFor: 'classes'!
classNames
	^self classes collect: [:each | each name]! !

!HtmlReportWriter methodsFor: 'classes' stamp: 'nishis 3/31/98 00:53'!
classes
	| blockClosure rootClasses allClasses patterns |
	self categories isNil ifTrue: [^Array new].
	blockClosure := 
			[:each :classes | 
			((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: 
					[patterns := self categories select: [:pattern | self class stringMatch: each category asString and: pattern].
					(patterns isEmpty not and: [self filter value: each])
						ifTrue: [classes add: each]]].
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	rootClasses
		do: 
			[:root | 
			blockClosure value: root value: allClasses.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each value: allClasses]]].
	^allClasses asArray! !

!HtmlReportWriter methodsFor: 'classes'!
numberOfClasses
	^self classes size! !


!HtmlReportWriter methodsFor: 'messages'!
messages
	| instanceMessages classMessages |
	instanceMessages := Set new.
	classMessages := Set new.
	self classes
		do: 
			[:each | 
			instanceMessages addAll: each selectors.
			classMessages addAll: each class selectors].
	instanceMessages := instanceMessages asSortedCollection.
	classMessages := classMessages asSortedCollection.
	^Array with: instanceMessages with: classMessages! !

!HtmlReportWriter methodsFor: 'messages'!
numberOfMessages
	^self messages collect: [:each | each size]! !


!HtmlReportWriter methodsFor: 'methods'!
methods
	| instanceMethods classMethods |
	instanceMethods := Bag new.
	classMethods := Bag new.
	self classes
		do: 
			[:each | 
			instanceMethods addAll: each selectors.
			classMethods addAll: each class selectors].
	instanceMethods := instanceMethods asSortedCollection.
	classMethods := classMethods asSortedCollection.
	^Array with: instanceMethods with: classMethods! !

!HtmlReportWriter methodsFor: 'methods'!
numberOfMethods
	^self methods collect: [:each | each size]! !


!HtmlReportWriter methodsFor: 'steps' stamp: 'nishis 3/30/98 22:33'!
getchar: aStream 
	| char |
	aStream atEnd
		ifTrue: [char := nil]
		ifFalse: 
			[char := aStream next.
			char = Character linefeed
				ifTrue: [char := Character cr]
				ifFalse: [char = Character cr ifTrue: [aStream peek = Character linefeed ifTrue: [aStream next]]]].
	^char! !

!HtmlReportWriter methodsFor: 'steps'!
getline: aStream 
	| stream char |
	stream := WriteStream on: (String new: 128).
	char := self getchar: aStream.
	[char notNil and: [char ~= Character cr]]
		whileTrue: 
			[stream nextPut: char.
			char := self getchar: aStream].
	(char notNil and: [char = Character cr])
		ifTrue: [stream nextPut: char].
	^stream contents! !

!HtmlReportWriter methodsFor: 'steps'!
numberOfSteps
	| array |
	array := self steps.
	^array first! !

!HtmlReportWriter methodsFor: 'steps'!
steps
	| aDictionary iTotal cTotal iCount cCount |
	aDictionary := Dictionary new.
	iTotal := 0.
	cTotal := 0.
	self classes
		do: 
			[:each | 
			iCount := 0.
			cCount := 0.
			each selectors do: [:selector | iCount := iCount + (self steps: each selector: selector)].
			each class selectors do: [:selector | cCount := cCount + (self steps: each class selector: selector)].
			aDictionary add: each -> (Array with: iCount with: cCount).
			iTotal := iTotal + iCount.
			cTotal := cTotal + cCount].
	^Array with: (Array with: iTotal with: cTotal)
		with: aDictionary! !

!HtmlReportWriter methodsFor: 'steps'!
steps: aClass selector: aSelector 
	| count stream line |
	count := 0.
	Cursor read showWhile: [stream := ReadStream on: (aClass sourceCodeAt: aSelector)].
	[stream atEnd]
		whileFalse: 
			[line := self getline: stream.
			count := count + 1 + (line size // 60)].
	^count! !


!HtmlReportWriter methodsFor: 'reporting' stamp: 'nishis 6/28/1998 05:18'!
report
	| reportingClasses separatorString saveDirectory baseString fileNames fileNo fileName writeStream filename file |
	reportingClasses := self classes.
	reportingClasses isEmpty ifTrue: [^nil].
	reportingClasses size > 1
		ifTrue: [Transcript cr; cr; show: self name , ': reporting ' , reportingClasses size printString , ' classes ...']
		ifFalse: [Transcript cr; cr; show: self name , ': reporting ' , reportingClasses size printString , ' class ...'].
	separatorString := String with: FileDirectory pathNameDelimiter.
	saveDirectory := FileDirectory on: self class defaultDirectoryName , self name.
	(saveDirectory containingDirectory includesKey: saveDirectory pathParts last)
		ifTrue: [saveDirectory fileNames
				do: 
					[:each | 
					filename := self class defaultDirectoryName , self name , separatorString , each.
					(FileDirectory on: self class defaultDirectoryName, self name) 						deleteFileNamed: each 
						ifAbsent: []]]
		ifFalse: [saveDirectory containingDirectory 
					createDirectory: saveDirectory pathParts last].
	baseString := String new.
	8 - self reportPrefix size timesRepeat: [baseString := baseString , '0'].
	fileNames := OrderedCollection new.
	fileNo := 1.
	reportingClasses
		do: 
			[:each | 
			fileNames add: (self filename: fileNo).
			fileNo := fileNo + 1].
	reportingClasses with: fileNames
		do: 
			[:each :it | 
			filename := self class defaultDirectoryName , self name.
			filename := filename , separatorString , it.
			file := FileStream fileNamed: filename.
			self
				privateReportClass: each
				into: file
				classes: reportingClasses
				files: fileNames.
			file close.
			Transcript cr; show: each name , ' -> ' , it].
	fileName := self class defaultDirectoryName , self name.
	fileName := fileName , separatorString , (self filename: 0).
	Transcript cr; show: self name , ' -> ' , (self filename: 0).
	writeStream := FileStream fileNamed: fileName.
	self
		privateReportTable: reportingClasses
		into: writeStream
		files: fileNames.
	writeStream close.
	Transcript cr; show: '... done at ' , Date today printString , ' ' , Time now printString! !

!HtmlReportWriter methodsFor: 'reporting'!
reportPrefix
	^'Rpt' copy! !


!HtmlReportWriter methodsFor: 'filename'!
filename: fileNo 
	"HtmlReportWriter new filename: 123."

	| extensionString baseString aStream |
	extensionString := '.htm'.
	baseString := String new.
	8 - self reportPrefix size timesRepeat: [baseString := baseString , '0'].
	aStream := WriteStream on: (String new: 12).
	aStream nextPutAll: self reportPrefix.
	baseString size - fileNo printString size timesRepeat: [aStream nextPutAll: '0'].
	aStream nextPutAll: fileNo printString.
	aStream nextPutAll: extensionString.
	^aStream contents! !


!HtmlReportWriter methodsFor: 'private'!
privateReportClass: aClass into: aStream 
	aStream nextPutAll: '<H2>'.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: '</H2>'.
	aStream cr.
	aStream cr.
	aClass comment asString
		do: 
			[:char | 
			char = Character cr ifTrue: [aStream nextPutAll: '<BR>'].
			aStream nextPut: char].
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportClass: aClass into: aStream classes: classCollection files: fileNames 
	self privateReportHeader: aClass name asString into: aStream.
	aStream cr.
	self privateReportClass: aClass into: aStream.
	aStream cr.
	self
		privateReportSuperclass: aClass
		into: aStream
		classes: classCollection
		files: fileNames.
	aStream cr.
	self
		privateReportInstanceVariables: aClass
		into: aStream
		label: 'instance variables'.
	aStream cr.
	self
		privateReportInstanceVariables: aClass class
		into: aStream
		label: 'class instance variables'.
	aStream cr.
	self privateReportClassVariables: aClass into: aStream.
	aStream cr.
	self privateReportPoolVariables: aClass into: aStream.
	aStream cr.
	self
		privateReportMethods: aClass
		into: aStream
		label: 'instance methods'.
	aStream cr.
	self
		privateReportMethods: aClass class
		into: aStream
		label: 'class methods'.
	aStream cr.
	self privateReportFooter: aClass name asString into: aStream.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportClassVariables: aClass into: aStream 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>class variabels:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aClass classPool keys asSortedCollection
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI><B>'.
			aStream nextPutAll: each asString.
			aStream nextPutAll: '</B>'].
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportFooter: aString into: aStream 
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr.
	aStream nextPutAll: '<A HREF="'.
	aStream nextPutAll: (self filename: 0).
	aStream nextPutAll: '"><B>index</B></A><BR>'.
	aStream cr.
	(self footer isNil or: [self footer isEmpty])
		ifFalse: 
			[aStream nextPutAll: self footer.
			aStream nextPutAll: '<BR>'.
			aStream cr].
	aStream cr.
	aStream nextPutAll: '</BODY>'.
	aStream cr.
	aStream nextPutAll: '</HTML>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportHeader: aString into: aStream 
	aStream nextPutAll: '<HTML>'.
	aStream cr.
	aStream nextPutAll: '<HEAD>'.
	aStream cr.
	aStream nextPutAll: '<TITLE>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: '</TITLE>'.
	aStream cr.
	aStream nextPutAll: '</HEAD>'.
	aStream cr.
	aStream nextPutAll: '<BODY>'.
	aStream cr.
	aStream cr.
	(self header isNil or: [self header isEmpty])
		ifFalse: 
			[aStream nextPutAll: self header.
			aStream nextPutAll: '<BR>'.
			aStream cr].
	aStream nextPutAll: '<A HREF="'.
	aStream nextPutAll: (self filename: 0).
	aStream nextPutAll: '"><B>index</B></A><BR>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportInstanceVariables: aClass into: aStream label: aString 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: ':</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aClass instVarNames
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI><B>'.
			aStream nextPutAll: each asString.
			aStream nextPutAll: '</B>'].
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private' stamp: 'nishis 3/30/98 22:44'!
privateReportMethod: aClass selector: aSelector into: aStream 
	| source parser pattern collection string comments |
	source := aClass sourceCodeAt: aSelector.
	parser := aClass parserClass new.
	parser parseSelector: source.
	pattern := source copyFrom: 1 to: parser endOfLastToken.
	[pattern last isSeparator]
		whileTrue: [pattern := pattern copyFrom: 1 to: pattern size - 1].
	aSelector numArgs = 0
		ifTrue: 
			[aStream nextPutAll: '<B>'.
			aStream nextPutAll: pattern asString.
			aStream nextPutAll: '</B>']
		ifFalse: 
			[collection := Scanner new scanTokens: pattern.
			1
				to: collection size
				by: 2
				do: 
					[:index | 
					index > 1 ifTrue: [aStream space].
					aStream nextPutAll: '<B>'.
					aStream nextPutAll: (collection at: index).
					aStream nextPutAll: '</B>'.
					aStream space.
					aStream nextPutAll: (collection at: index + 1)]].
	string := (aClass organization categoryOfElement: aSelector) asString.
	aStream nextPutAll: ' <I>[' , string , ']</I>'.
	aStream nextPutAll: '<BR>'.
	comments := Parser new parseMethodComment: source setPattern: [:x | ].
	comments isEmpty
		ifFalse: 
			[aStream cr.
			comments first asString
				do: 
					[:char | 
					char = Character cr ifTrue: [aStream nextPutAll: '<BR>'].
					aStream nextPut: char]].
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportMethods: aClass into: aStream label: aString 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>'.
	aStream nextPutAll: aString.
	aStream nextPutAll: ':</I>'.
	aStream cr.
	aStream nextPutAll: '<OL>'.
	aClass selectors asSortedCollection
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI>'.
			self
				privateReportMethod: aClass
				selector: each asSymbol
				into: aStream].
	aStream cr.
	aStream nextPutAll: '</OL>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportPoolVariables: aClass into: aStream 
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>pool variabels:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aClass sharedPools
		do: 
			[:each | 
			aStream cr.
			aStream nextPutAll: '<LI><B>'.
			aStream nextPutAll: (Smalltalk keyAtValue: each) asString.
			aStream nextPutAll: '</B>'].
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportSuperclass: aClass into: aStream classes: classCollection files: fileNames 
	| index |
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<I>superclass:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	aStream nextPutAll: '<LI><B>'.
	index := classCollection findFirst: [:each | each = aClass superclass].
	index = 0
		ifTrue: [aStream nextPutAll: aClass superclass name asString]
		ifFalse: 
			[aStream nextPutAll: '<A HREF="'.
			aStream nextPutAll: (fileNames at: index) asString.
			aStream nextPutAll: '">'.
			aStream nextPutAll: aClass superclass name asString.
			aStream nextPutAll: '</A>'].
	aStream nextPutAll: '</B>'.
	aStream cr.
	aStream nextPutAll: '</UL>'.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private'!
privateReportTable: allClasses into: aStream files: fileNames 
	| collection key value array dictionary |
	collection := SortedCollection new: allClasses size.
	collection sortBlock: [:x :y | x key name < y key name].
	allClasses with: fileNames
		do: 
			[:aClass :fileName | 
			key := aClass.
			value := fileName.
			collection add: key -> value].
	self privateReportHeader: self name asString into: aStream.
	aStream cr.
	aStream nextPutAll: '<H2>'.
	aStream nextPutAll: self name asString.
	aStream nextPutAll: '</H2>'.
	aStream cr.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: 'classes: '.
	aStream nextPutAll: allClasses size printString.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	aStream nextPutAll: 'instance methods & class methods: '.
	Cursor wait showWhile: [array := self numberOfMethods].
	aStream nextPutAll: array first printString.
	aStream nextPutAll: ' & '.
	aStream nextPutAll: array last printString.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	Cursor wait
		showWhile: 
			[array := self steps.
			dictionary := array last].
	aStream nextPutAll: 'instance method steps & class method steps: '.
	aStream nextPutAll: array first first printString.
	aStream nextPutAll: ' & '.
	aStream nextPutAll: array first last printString.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	collection
		do: 
			[:association | 
			aStream nextPutAll: '<LI><A HREF="'.
			aStream nextPutAll: association value asString.
			aStream nextPutAll: '"><STRONG>'.
			aStream nextPutAll: association key name asString.
			aStream nextPutAll: '</STRONG></A>'.
			array := dictionary at: association key ifAbsent: [nil].
			array isNil
				ifFalse: 
					[aStream nextPutAll: ' (steps: '.
					aStream nextPutAll: array first printString.
					aStream nextPutAll: ' & '.
					aStream nextPutAll: array last printString.
					aStream nextPutAll: ')'].
			aStream cr].
	aStream nextPutAll: '</UL>'.
	aStream cr.
	self privateReportFooter: self name asString into: aStream.
	aStream cr.
	^aStream! !

!HtmlReportWriter methodsFor: 'private' stamp: 'nishis 3/30/98 17:58'!
privateValues
	^ self class privateValues
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HtmlReportWriter class
	instanceVariableNames: ''!

!HtmlReportWriter class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!HtmlReportWriter class methodsFor: 'copyright'!
system
	^'Goodies'! !

!HtmlReportWriter class methodsFor: 'copyright'!
version
	^'003'! !


!HtmlReportWriter class methodsFor: 'instance creation'!
name: nameString categories: symbolArray 
	^super new
		name: nameString
		categories: symbolArray
		filter: [:aClass | true]! !

!HtmlReportWriter class methodsFor: 'instance creation'!
name: nameString categories: stringArray filter: filterBlock 
	^super new
		name: nameString
		categories: stringArray
		filter: filterBlock! !


!HtmlReportWriter class methodsFor: 'utilities' stamp: 'nishis 3/30/98 23:24'!
defaultDirectoryName
	"HtmlReportWriter defaultDirectoryName."

	| directoryName |
	directoryName := FileDirectory default pathName.
	directoryName last = FileDirectory pathNameDelimiter ifFalse: [directoryName := directoryName , (String with: FileDirectory pathNameDelimiter)].
	^directoryName! !

!HtmlReportWriter class methodsFor: 'utilities'!
separate: separateCollection dividers: dividerCollection 
	"HtmlReportWriter separate: #(a b c d e f g h) dividers: #(d f)."

	| indexCollection index intervalCollection s e result |
	indexCollection := OrderedCollection new.
	indexCollection add: 0.
	index := 1.
	separateCollection
		do: 
			[:each | 
			(dividerCollection includes: each)
				ifTrue: [indexCollection add: index].
			index := index + 1].
	indexCollection add: separateCollection size + 1.
	intervalCollection := OrderedCollection new.
	1 to: indexCollection size - 1
		do: 
			[:i | 
			s := indexCollection at: i.
			e := indexCollection at: i + 1.
			intervalCollection add: (s + 1 to: e - 1)].
	result := OrderedCollection new.
	intervalCollection do: [:interval | interval size > 0 ifTrue: [result add: (separateCollection copyFrom: interval first to: interval last)]].
	^result! !

!HtmlReportWriter class methodsFor: 'utilities' stamp: 'nishis 3/30/98 22:35'!
separators
	"HtmlReportWriter separators."

	| stream |
	stream := WriteStream on: (String new: 4).
	stream nextPut: Character space.
	stream nextPut: Character tab.
	stream nextPut: Character cr.
	stream nextPut: Character linefeed.
	^stream contents! !

!HtmlReportWriter class methodsFor: 'utilities'!
stringMatch: string and: pattern 
	"HtmlReportWriter stringMatch: ' Aoki' and: 'Ju*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!HtmlReportWriter class methodsFor: 'utilities'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !


!HtmlReportWriter class methodsFor: 'saving' stamp: 'nishis 6/28/1998 04:57'!
save
	"HtmlReportWriter save."

	| fileName classCollection aStream timeStamp saveBlock |
	fileName := 'HtmlRprt.st'.
	classCollection := self saveClasses.
	FileDirectory default
			deleteFileNamed: fileName asFileName
			ifAbsent: [].
	aStream := FileStream fileNamed: fileName asFileName.
	aStream reset.
	saveBlock := [Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy , ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr]]].
	saveBlock ifError: [:err :rcvr | aStream close].
	aStream closed ifFalse: [aStream close].
	^classCollection! !

!HtmlReportWriter class methodsFor: 'saving'!
saveClasses
	"HtmlReportWriter saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*HtmlReportWriter*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!HtmlReportWriter class methodsFor: 'examples' stamp: 'nishis 3/31/98 01:18'!
example1
	"HtmlReportWriter example1."

	| htmlReportWriter |
	htmlReportWriter := HtmlReportWriter
				name: 'Report01'
				categories: #('Goodies-*' 'Numeric-Numbers' 'Graphics-Primitives')
				filter: [:aClass | aClass = HtmlReportWriter or: [aClass withAllSuperclasses includes: Number]].
	htmlReportWriter header: 'This is a header. System name is recommended as header.'.
	htmlReportWriter footer: 'This is a footer. Copyright or E-Mail address is recommended as footer.'.
	htmlReportWriter report.
	^htmlReportWriter! !

!HtmlReportWriter class methodsFor: 'examples' stamp: 'nishis 3/31/98 01:16'!
example2
	"HtmlReportWriter example2."

	| htmlReportWriter |
	htmlReportWriter := HtmlReportWriter
				name: 'Report01'
				categories: #('Goodies-*' 'Numeric-Numbers' 'Graphics-Primitives')
				filter: [:aClass | aClass = HtmlReportWriter or: [aClass withAllSuperclasses includes: Number]].
	Transcript cr; show: 'classes: '.
	Transcript space; show: htmlReportWriter numberOfClasses printString.
	Transcript cr; show: 'instance messages & class messages: '.
	Transcript space; show: htmlReportWriter numberOfMessages printString.
	Transcript cr; show: 'instance methods & class methods: '.
	Transcript space; show: htmlReportWriter numberOfMethods printString.
	Transcript cr; show: 'instance method steps & class method steps: '.
	Transcript space; show: htmlReportWriter numberOfSteps printString.
	^htmlReportWriter! !


!HtmlReportWriter class methodsFor: 'private'!
privateValues
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: Smalltalk size.
	Smalltalk do: [:value | anOrderedCollection add: value].
	^anOrderedCollection! !
