'Goodies (11/18/2001 8:34:59 am)'.!


Object subclass: #SpyRecord
	instanceVariableNames: 'whose method value name parent children home '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Spy'!

!SpyRecord methodsFor: 'initialize-release' stamp: 'nishis 12/6/1998 23:33'!
close
	whose := method := value := name := parent := children := home := nil! !


!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:30'!
children
	children isNil ifTrue: [children := Array new].
	^children! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:30'!
children: messageRecords 
	children := messageRecords! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 12/1/1998 17:52'!
home
	^home! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/30/1998 00:02'!
home: aMethodContext
	home := aMethodContext! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:30'!
method
	^method! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:31'!
method: aMethod 
	method := aMethod! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:34'!
name
	name isNil ifTrue: [name := self computeName].
	^name! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:31'!
parent
	^parent! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:31'!
parent: messageRecord 
	parent := messageRecord! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:32'!
root
	parent isNil
		ifTrue: [^self]
		ifFalse: [^parent root]! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 12/7/1998 04:22'!
selector
	| aSelector |
	aSelector := whose selectorAtMethod: method setClass: [:mClass | ].
	^aSelector! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:32'!
value
	^value! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:32'!
value: anObject 
	value := anObject! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:33'!
whose
	^whose! !

!SpyRecord methodsFor: 'accessing' stamp: 'nishis 11/29/1998 05:33'!
whose: aClass 
	whose := aClass! !


!SpyRecord methodsFor: 'enumerating' stamp: 'nishis 11/29/1998 05:33'!
do: aBlock 
	aBlock value: self.
	self children do: [:each | each do: aBlock]! !

!SpyRecord methodsFor: 'enumerating' stamp: 'nishis 11/29/1998 05:33'!
do: aBlock level: anInteger 
	aBlock value: self value: anInteger.
	self children do: [:each | each do: aBlock level: anInteger + 1]! !

!SpyRecord methodsFor: 'enumerating' stamp: 'nishis 12/6/1998 03:05'!
reverseDo: aBlock
	self children reverseDo: [:each | each reverseDo: aBlock].
	aBlock value: self.! !


!SpyRecord methodsFor: 'printing' stamp: 'nishis 11/29/1998 05:34'!
printOn: aStream 
	aStream nextPutAll: self value printString.
	aStream nextPutAll: ' '.
	aStream nextPutAll: self name! !


!SpyRecord methodsFor: 'compatibility' stamp: 'nishis 11/9/2001 00:18'!
size
	^[super size]
		on: Error
		do: [:ex | ex return: 0]! !


!SpyRecord methodsFor: 'private' stamp: 'nishis 12/1/1998 17:48'!
computeName
	| aSelector aClass |
	children isNil
		ifTrue: [^'Primitive']
		ifFalse: 
			[aSelector := whose selectorAtMethod: method setClass: [:mclass | ].
			(aSelector = #DoIt) ifTrue: [aSelector := #unboundMethod].
			aClass := self findClassFor: method.
			^aClass name , '  ' , aSelector]! !

!SpyRecord methodsFor: 'private' stamp: 'nishis 12/7/1998 02:01'!
findClassFor: aIgnoredMethod 
	| aClass client requestor model |
	(whose == FakeClassPool)
		ifTrue: 
			[client := (self home sender respondsTo: #receiver) ifTrue: [self home client] ifFalse: [^nil].
			(client isMemberOf: Compiler) 
				ifTrue: 
					[requestor := client instVarNamed: #requestor.
					model := requestor model.
					aClass := model selectedClass.
					model metaClassIndicated 
						ifTrue: [^aClass class] 
						ifFalse: [^aClass]]].
	^whose
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SpyRecord class
	instanceVariableNames: ''!

!SpyRecord class methodsFor: 'copyright' stamp: 'nishis 11/29/1998 05:29'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!SpyRecord class methodsFor: 'copyright' stamp: 'nishis 11/29/1998 05:29'!
system
	^'Goodies'! !

!SpyRecord class methodsFor: 'copyright' stamp: 'nishis 11/29/1998 05:29'!
version
	^'003'
! !


!SpyRecord class methodsFor: 'instance creation' stamp: 'nishis 11/30/1998 00:03'!
whose: aClass method: aMethod value: anObject home: aMethodContext 
	^(super new) whose: aClass; method: aMethod; value: anObject; home: aMethodContext; yourself! !
