'Goodies (11/18/2001 8:34:59 am)'.!


Object subclass: #ColorSpuit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Colors'!
!ColorSpuit commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Color Spuit
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Color Spuit
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ColorSpt.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ColorSpt.txt


Summary:

Color Spuit gets a color from any place as you like.
(within a Squeak window only)
This re-implementation for Squeak is scale-down from oroginal 
program.


How to install:

FileIn this goodies and makes a class "ColorSpuit" in a 
category "Goodies-Colors". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"ColorSpuit" from your system, simply.


how to use:

Send a message "request" to class "ColorSpuit".  The mouse 
cursor becomes a spuit.  Its hotspot is a point of spuit.

ColorSpuit request.

Also see examples.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ColorSpt.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ColorSpt.txt
QƂĂB

IWĩvOAȂȗĂ܂̂ŁA
ӂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ColorSpuit class
	instanceVariableNames: ''!

!ColorSpuit class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!ColorSpuit class methodsFor: 'copyright'!
system
	^'Goodies'! !

!ColorSpuit class methodsFor: 'copyright'!
version
	^'003'! !


!ColorSpuit class methodsFor: 'utilities' stamp: 'nishis 4/13/98 17:44'!
request
	"ColorSpuit request."
	"Transcript cr; show: ColorSpuit request printString."

	| aColor |
	Cursors spuitCursor 
		showWhile: 
			[Sensor waitClickButton.
			aColor := Display colorAt: (Sensor cursorPoint)].
	^ aColor! !


!ColorSpuit class methodsFor: 'cursors' stamp: 'nishis 1/4/1999 13:49'!
spuitCursor
	"ColorSpuit spuitCursor."
	"
	ColorSpuit spuitCursor show. 
	(Delay forSeconds: 2) wait. 
	Cursor normal show. 
	"

	^self
		extent: 16@16 
		fromArray: #(
2r0000000000000000
2r0000000000011100
2r0000000000111110
2r0000000000111110
2r0000000111111110
2r0000000011111100
2r0000000101110000
2r0000001000110000
2r0000010001010000
2r0000100010000000
2r0001000100000000
2r0010001000000000
2r0010010000000000
2r0101100000000000
2r0010000000000000
2r0000000000000000
)
		mask: #(
2r0000000000011100
2r0000000000111110
2r0000000001111111
2r0000011111111111
2r0000001111111111
2r0000000111111110
2r0000001111111100
2r0000011111111000
2r0000111111111000
2r0001111111011000
2r0011111110001000
2r0111111100000000
2r0111111000000000
2r1101110000000000
2r0111100000000000
2r0010000000000000
)
		offset: 2 @ 13! !


!ColorSpuit class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:35'!
save
	"ColorSpuit save."

	| fileName classCollection aStream timeStamp |
	fileName := 'ColorSpt.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!ColorSpuit class methodsFor: 'saving'!
saveClasses
	"ColorSpuit saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*ColorSpuit*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!ColorSpuit class methodsFor: 'examples' stamp: 'nishis 4/13/98 17:33'!
example1
	"ColorSpuit example1."

	| colorValue aWindow |
	colorValue := ColorSpuit request.
	aWindow := ScheduledControllers activeController view.
	aWindow clearInside: colorValue.
	aWindow update.
	Cursor crossHair showWhile: [Sensor waitClickButton].
	aWindow display! !

!ColorSpuit class methodsFor: 'examples' stamp: 'nishis 4/13/98 17:55'!
example2
	"ColorSpuit example2."

	| colorValue aWindow demonstlations |
	demonstlations := #(dominantColor halfTonePattern1 halfTonePattern2 darker lighter muchLighter).
	colorValue := ColorSpuit request.
	demonstlations
		do:
			[:demonstlation | 
			aWindow := ScheduledControllers activeController view.
			aWindow clearInside: (colorValue perform: demonstlation).
			aWindow update.
			Cursor crossHair showWhile: [Sensor waitClickButton].
			aWindow display]! !

!ColorSpuit class methodsFor: 'examples' stamp: 'nishis 4/13/98 17:43'!
example3
	"ColorSpuit example3."

	| aColor |
	aColor := ColorSpuit request.
	Transcript cr; show: aColor printString.
	^ aColor! !


!ColorSpuit class methodsFor: 'private' stamp: 'nishis 1/4/1999 13:49'!
extent: extentPoint fromArray: anArray mask: maskArray offset: offsetPoint
	| cursorMaker |
	cursorMaker := Smalltalk at: #CursorWithMask ifAbsent: [nil].
	cursorMaker isNil 
		ifTrue: 
			[^self extent: extentPoint fromArray: anArray offset: offsetPoint].
	^(cursorMaker 
			extent: extentPoint 
			fromArray: anArray
			offset: offsetPoint * -1)
		setMaskForm: 
			(Form 
				extent: extentPoint
				fromArray: (maskArray collect: [:bits | bits bitShift: 16]) 
				offset: 0 @ 0)! !

!ColorSpuit class methodsFor: 'private'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	^ Cursor extent: extentPoint fromArray: anArray offset: offsetPoint * -1 ! !
