'Goodies (11/18/2001 8:35 am)'.!


Model subclass: #DumpModel
	instanceVariableNames: 'byteArray startAddress textModel '
	classVariableNames: 'YellowButtonMenu '
	poolDictionaries: ''
	category: 'Goodies-Dump'!
!DumpModel commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Dump
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Dump
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Dump.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Dump.txt


Summary:

This goodies dumps from a ByteArray, contents of a file to 
hex number and strings.


How to install:

FileIn this goodies and makes classes below in a category 
"Goodies-Dump". 

DumpModel

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove a class 
"DumpModel" from your system, simply.


how to use:

To dump a ByteArray: 

(DumpModel bytes: 'AOKI Atsushi' asByteArray) open

To dump the contents of a file:

(DumpModel filename: 'filename') open

	on Mac: ':directory:filename', etc.
	on Win: 'directory\filename', etc.
	on Unix: 'directory/filename', etc.


To dump the contents of a part of afile, use start address 
and stop address:

(DumpModel
    filename: 'filename' 
    start: 100
    stop: 200) open

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Dump.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Dump.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!DumpModel methodsFor: 'accessing'!
bytes
	byteArray isNil ifTrue: [byteArray := ByteArray new].
	^byteArray! !

!DumpModel methodsFor: 'accessing' stamp: 'nishis 5/21/98 21:31'!
bytes: bytes start: start 
	byteArray := ByteArray newFrom: bytes.
	startAddress := start.
	self textModel contents: self dump! !

!DumpModel methodsFor: 'accessing'!
start
	startAddress isNil ifTrue: [startAddress := 0].
	^startAddress! !

!DumpModel methodsFor: 'accessing'!
stop
	^self bytes size! !


!DumpModel methodsFor: 'comparing'!
= dumpModel 
	^self bytes = dumpModel bytes and: [self start = dumpModel start]! !


!DumpModel methodsFor: 'model accessing' stamp: 'nishis 5/21/98 21:31'!
textModel
	textModel isNil ifTrue: [textModel := StringHolder new contents: Text new].
	^textModel! !


!DumpModel methodsFor: 'interface opening' stamp: 'nishis 5/24/98 07:40'!
open
	| topView view |
	view := StringHolderView new.
	view model: self textModel.
	view  borderWidth: 1.
	topView := StandardSystemView new.
	topView
			model: view model;
			label: 'Dump';
			borderWidth: 1;
			minimumSize: 450 @ 250;
			backgroundColor: Color white.
	topView addSubView: view.
	topView controller open! !


!DumpModel methodsFor: 'printing' stamp: 'nishis 5/21/98 13:07'!
printOn: aStream 
	aStream nextPutAll: self textModel contents! !


!DumpModel methodsFor: 'private' stamp: 'nishis 5/21/98 21:40'!
addressString: address 
	| stream string |
	stream := WriteStream on: (String new: 9).
	string := self printStringOf: address radix: 16.
	string size > 8
		ifTrue: [string := string copyFrom: string size - 8 + 1 to: string size]
		ifFalse: [8 - string size timesRepeat: [stream nextPutAll: '0']].
	stream nextPutAll: string.
	stream nextPutAll: ':'.
	^stream contents! !

!DumpModel methodsFor: 'private'!
assert: assertBlock do: doBlock ensure: ensureBlock 
	^self class
		assert: assertBlock
		do: doBlock
		ensure: ensureBlock! !

!DumpModel methodsFor: 'private' stamp: 'nishis 5/21/98 21:41'!
dump
	| stream dump count chars string |
	self
		assert: [stream := ReadWriteStream on: (String new: 1024)]
		do: 
			[count := self start.
			chars := WriteStream on: (String new: 16).
			count \\ 16 = 0
				ifFalse: 
					[stream nextPutAll: (self addressString: count - (count \\ 16)).
					0 to: count \\ 16 - 1
						do: 
							[:n | 
							n \\ 2 = 0 ifTrue: [stream space].
							n \\ 8 = 0 ifTrue: [stream space].
							stream space; space.
							chars space]].
			self bytes do: 
				[:byte | 
				self
					assert: 
						[count \\ 16 = 0 ifTrue: [stream nextPutAll: (self addressString: count)].
						count \\ 2 = 0 ifTrue: [stream space].
						count \\ 8 = 0 ifTrue: [stream space]]
					do: 
						[string := self printStringOf: byte radix: 16.
						2 - string size timesRepeat: [stream nextPutAll: '0'].
						stream nextPutAll: string.
						chars nextPut: (self printable: byte)]
					ensure: 
						[count := count + 1.
						count \\ 16 = 0
							ifTrue: 
								[stream space; space.
								stream nextPutAll: chars contents.
								stream cr.
								chars := WriteStream on: (String new: 16)]]].
			[count \\ 16 = 0]
				whileFalse: [self
						assert: 
							[count \\ 2 = 0 ifTrue: [stream space].
							count \\ 8 = 0 ifTrue: [stream space]]
						do: [stream space; space]
						ensure: 
							[count := count + 1.
							count \\ 16 = 0
								ifTrue: 
									[stream space; space.
									stream nextPutAll: chars contents.
									stream cr.
									chars := WriteStream on: (String new: 16)]]].
			dump := stream contents]
		ensure: [stream close].
	^dump! !

!DumpModel methodsFor: 'private' stamp: 'nishis 5/21/98 22:05'!
printOn: aStream number: number base: b 
	"by nishis, 1998/05/21 22:05"
	"see SmallInteger>>printOn:base:."
	| digitsInReverse x i |
	number < 0 ifTrue: [
		aStream nextPut: $-.
		^ number negated printOn: aStream base: b.
	].
	"by nishis, 1998/05/21 22:05"
	"not print base"
	"b = 10 ifFalse: [aStream print: b; nextPut: $r]."
	digitsInReverse _ Array new: 32.
	x _ number.
	i _ 0.
	[x >= b] whileTrue: [
		digitsInReverse at: (i _ i + 1) put: x \\ b.
		x _ x // b.
	].
	digitsInReverse at: (i _ i + 1) put: x.
	[i > 0] whileTrue: [
		aStream nextPut: (Character digitValue: (digitsInReverse at: i)).
		i _ i - 1.
	].! !

!DumpModel methodsFor: 'private' stamp: 'nishis 5/21/98 21:44'!
printStringOf: number radix: radix 
	| aStream |
	aStream := WriteStream on: (String new: 16).
	self printOn: aStream number: number base: radix.
	^aStream contents! !

!DumpModel methodsFor: 'private'!
printable: byte 
	(33 <= byte and: [byte <= 126])
		ifTrue: [^Character value: byte].
	^Character space! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DumpModel class
	instanceVariableNames: ''!

!DumpModel class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!DumpModel class methodsFor: 'copyright'!
system
	^'Goodies'! !

!DumpModel class methodsFor: 'copyright'!
version
	^'003'! !


!DumpModel class methodsFor: 'class initialization'!
flushMenus
	"DumpModel flushMenus."

	YellowButtonMenu := nil! !

!DumpModel class methodsFor: 'class initialization'!
initialize
	"DumpModel initialize."

	self initializeFont.
	self flushMenus! !

!DumpModel class methodsFor: 'class initialization'!
initializeFont
	"DumpModel initializeFont."

"	| defaultFontName defaultFontSize fontDescription characterAttributes textAttributes deviceFont |
	defaultFontName := #('Courier*' 'courier*' '**').
	defaultFontSize := 12.
	fontDescription := FontDescription new.
	fontDescription family: defaultFontName.
	fontDescription pixelSize: defaultFontSize.
	fontDescription boldness: 0.5.
	fontDescription italic: false.
	fontDescription outline: false.
	fontDescription shadow: false.
	fontDescription underline: false.
	fontDescription fixedWidth: true.
	fontDescription serif: false.
	fontDescription strikeout: false.
	fontDescription encodings: Locale current preferredEncodings.
	characterAttributes := CharacterAttributes newWithDefaultAttributes.
	characterAttributes setDefaultQuery: fontDescription.
	textAttributes := TextAttributes new.
	textAttributes setCharacterAttributes: characterAttributes.
	deviceFont := Screen default defaultFontPolicy findFont: fontDescription.
	textAttributes lineGrid: deviceFont height.
	textAttributes baseline: deviceFont ascent.
	TextAttributes styleNamed: #DumpDefault put: textAttributes"! !


!DumpModel class methodsFor: 'instance creation'!
bytes: aByteArray 
	^(self new) bytes: aByteArray start: 0; yourself! !

!DumpModel class methodsFor: 'instance creation'!
filename: aFilename 
	^self
		filename: aFilename
		start: nil
		stop: nil! !

!DumpModel class methodsFor: 'instance creation'!
filename: aFilename start: startAddress 
	^self
		filename: aFilename
		start: startAddress
		stop: nil! !

!DumpModel class methodsFor: 'instance creation' stamp: 'nishis 5/21/98 17:05'!
filename: aFilename start: startAddress stop: stopAddress 
	| readStream writeStream fileName fileSize startLocation stopLocation byteArray byte dir |
	self
		assert: 
			[dir := FileDirectory dirPathFor: aFilename.
			fileName := (dir isNil or: [dir size = 0]) 
				ifTrue: [aFilename asFileName]
				ifFalse: [aFilename].
			readStream := FileStream oldFileNamed: fileName.
			fileSize := readStream size.
			(readStream respondsTo: #binary)
				ifTrue: [readStream binary].
			stopAddress isNil
				ifTrue: [stopLocation := fileSize]
				ifFalse: [stopLocation := stopAddress min: fileSize].
			startAddress isNil
				ifTrue: [startLocation := 0]
				ifFalse: [startLocation := startAddress min: stopLocation].
			writeStream := ReadWriteStream on: (ByteArray new: 1024)]
		do: 
			[readStream position: startLocation.
			[readStream position < stopLocation]
				whileTrue: 
					[byte := readStream next.
					writeStream nextPut: byte].
			byteArray := writeStream contents]
		ensure: 
			[readStream close.
			writeStream close].
	^(self new) bytes: byteArray start: startLocation; yourself! !


!DumpModel class methodsFor: 'saving'!
save
	"DumpModel save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Dump.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!DumpModel class methodsFor: 'saving'!
saveClasses
	"DumpModel saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Dump*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!DumpModel class methodsFor: 'private' stamp: 'nishis 6/28/1998 04:49'!
assert: assertBlock do: doBlock ensure: ensureBlock 
	| result |
	assertBlock value.
	[result := doBlock value]
		ifError: 
			[:err :rcvr | 
			ensureBlock value.
			^result].
	ensureBlock value.
	^result! !


!DumpModel class methodsFor: 'examples' stamp: 'nishis 5/21/98 12:54'!
example1
	"DumpModel example1."

	| dumpModel |
	dumpModel := DumpModel bytes: (Compiler evaluate: '^#(
71 73 70 56 55 97 16 0 16 0 247 0 0 255 255 255 
255 255 204 255 255 153 255 255 102 255 255 51 255 255 0 255 
204 255 255 204 204 255 204 153 255 204 102 255 204 51 255 204 
0 255 153 255 255 153 204 255 153 153 255 153 102 255 153 51 
255 153 0 255 102 255 255 102 204 255 102 153 255 102 102 255 
102 51 255 102 0 255 51 255 255 51 204 255 51 153 255 51 
102 255 51 51 255 51 0 255 0 255 255 0 204 255 0 153 
255 0 102 255 0 51 255 0 0 204 255 255 204 255 204 204 
255 153 204 255 102 204 255 51 204 255 0 204 204 255 204 204 
204 204 204 153 204 204 102 204 204 51 204 204 0 204 153 255 
204 153 204 204 153 153 204 153 102 204 153 51 204 153 0 204 
102 255 204 102 204 204 102 153 204 102 102 204 102 51 204 102 
0 204 51 255 204 51 204 204 51 153 204 51 102 204 51 51 
204 51 0 204 0 255 204 0 204 204 0 153 204 0 102 204 
0 51 204 0 0 153 255 255 153 255 204 153 255 153 153 255 
102 153 255 51 153 255 0 153 204 255 153 204 204 153 204 153 
153 204 102 153 204 51 153 204 0 153 153 255 153 153 204 153 
153 153 153 153 102 153 153 51 153 153 0 153 102 255 153 102 
204 153 102 153 153 102 102 153 102 51 153 102 0 153 51 255 
153 51 204 153 51 153 153 51 102 153 51 51 153 51 0 153 
0 255 153 0 204 153 0 153 153 0 102 153 0 51 153 0 
0 102 255 255 102 255 204 102 255 153 102 255 102 102 255 51 
102 255 0 102 204 255 102 204 204 102 204 153 102 204 102 102 
204 51 102 204 0 102 153 255 102 153 204 102 153 153 102 153 
102 102 153 51 102 153 0 102 102 255 102 102 204 102 102 153 
102 102 102 102 102 51 102 102 0 102 51 255 102 51 204 102 
51 153 102 51 102 102 51 51 102 51 0 102 0 255 102 0 
204 102 0 153 102 0 102 102 0 51 102 0 0 51 255 255 
51 255 204 51 255 153 51 255 102 51 255 51 51 255 0 51 
204 255 51 204 204 51 204 153 51 204 102 51 204 51 51 204 
0 51 153 255 51 153 204 51 153 153 51 153 102 51 153 51 
51 153 0 51 102 255 51 102 204 51 102 153 51 102 102 51 
102 51 51 102 0 51 51 255 51 51 204 51 51 153 51 51 
102 51 51 51 51 51 0 51 0 255 51 0 204 51 0 153 
51 0 102 51 0 51 51 0 0 0 255 255 0 255 204 0 
255 153 0 255 102 0 255 51 0 255 0 0 204 255 0 204 
204 0 204 153 0 204 102 0 204 51 0 204 0 0 153 255 
0 153 204 0 153 153 0 153 102 0 153 51 0 153 0 0 
102 255 0 102 204 0 102 153 0 102 102 0 102 51 0 102 
0 0 51 255 0 51 204 0 51 153 0 51 102 0 51 51 
0 51 0 0 0 255 0 0 204 0 0 153 0 0 102 0 
0 51 238 0 0 221 0 0 187 0 0 170 0 0 136 0 
0 119 0 0 85 0 0 68 0 0 34 0 0 17 0 0 
0 238 0 0 221 0 0 187 0 0 170 0 0 136 0 0 
119 0 0 85 0 0 68 0 0 34 0 0 17 0 0 0 
238 0 0 221 0 0 187 0 0 170 0 0 136 0 0 119 
0 0 85 0 0 68 0 0 34 0 0 17 238 238 238 221 
221 221 187 187 187 170 170 170 136 136 136 119 119 119 85 85 
85 68 68 68 34 34 34 17 17 17 0 0 0 44 0 0 
0 0 16 0 16 0 0 8 76 0 1 8 28 72 176 160 
65 130 227 198 29 52 152 112 33 67 135 2 19 42 4 32 
241 160 196 139 21 9 22 216 200 145 227 193 142 32 15 94 
24 73 146 164 200 146 40 13 98 91 201 178 37 54 131 32 
98 202 156 9 115 166 205 131 236 114 234 204 233 144 39 0 
159 16 29 6 4 0 59)').
	dumpModel open.
	^dumpModel! !

!DumpModel class methodsFor: 'examples'!
example2
	"DumpModel example2."

	| dumpModel |
	dumpModel := DumpModel filename: 'FILE NAME'.
	dumpModel open.
	^dumpModel! !

!DumpModel class methodsFor: 'examples' stamp: 'nishis 5/21/98 22:08'!
example3
	"DumpModel example3."
	"on Mac: ':test:setlist.gif', etc"
	"on Win: 'test\setlist.gif', etc"

	| dumpModel |
	dumpModel := DumpModel filename: 'FILE NAME' start: 100 stop: 200.
	dumpModel open.
	^dumpModel! !


DumpModel initialize!
