'Goodies (11/18/2001 8:35 am)'.!


Object subclass: #HistogramFakeDialog
	instanceVariableNames: 'model list selection values view topView '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Histogram'!
!HistogramFakeDialog commentStamp: '<historical>' prior: 0!
I am pseudo Dialog class for Histogram.
	"by nishis, 1998/05/24 06:49"
!


!HistogramFakeDialog methodsFor: 'initialization' stamp: 'nishis 6/11/1998 21:51'!
initialize
	list := #().
	selection := 0! !


!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 04:42'!
list
	^list! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:22'!
list: aList
	list := aList! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:13'!
model
	^model! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:13'!
model: aModel
	model := aModel! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 04:42'!
selection
	^selection! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 6/11/1998 21:49'!
selection: index
	selection := index.
	self changed: #selection! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:08'!
values
	^values! !

!HistogramFakeDialog methodsFor: 'accessing' stamp: 'nishis 5/24/98 06:09'!
values: theValues
	values := theValues! !


!HistogramFakeDialog methodsFor: 'interface opening' stamp: 'nishis 7/19/1998 22:45'!
model: aModel choose: message fromList: aList values: theValues lines: lines cancel: cancel
	| listView |
	self list: aList.
	self values: theValues.
	self model: aModel.
	listView :=
		PluggableListView on: self
			list: #list
			selected: #selection
			changeSelected: #selection:
			menu: #menu:.
	view := listView.
	topView := StandardSystemView new
		label: message;
		minimumSize: 350@200;
		borderWidth: 1;
		addSubView: listView.
	topView controller open! !


!HistogramFakeDialog methodsFor: 'interface closing' stamp: 'nishis 7/19/1998 22:45'!
close
	topView controller closeAndUnschedule! !


!HistogramFakeDialog methodsFor: 'menu' stamp: 'nishis 6/11/1998 21:57'!
menu: aMenu
	^ aMenu addList: #(
		(Accept acceptCmd)
		(Cancel cancelCmd))! !


!HistogramFakeDialog methodsFor: 'menu commands' stamp: 'nishis 5/24/98 07:38'!
acceptCmd
	| index |
	index := view getCurrentSelectionIndex.
	index < 1 ifTrue: [^nil].
	(self model respondsTo: #showItem:) ifTrue: [self model perform: #showItem: with: (values at: index)]! !

!HistogramFakeDialog methodsFor: 'menu commands' stamp: 'nishis 7/19/1998 22:46'!
cancelCmd
	"do nothig"! !


!HistogramFakeDialog methodsFor: 'code pane menu' stamp: 'nishis 7/19/1998 22:43'!
perform: selector orSendTo: otherTarget
	"see StringHolder class>>perform:orSendTo:"
"
	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]
"
	| result |
	(self respondsTo: selector)
		ifTrue: [result := self perform: selector]
		ifFalse: [result := otherTarget perform: selector].
	self close.
	^result! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HistogramFakeDialog class
	instanceVariableNames: ''!

!HistogramFakeDialog class methodsFor: 'instance creation' stamp: 'nishis 5/24/98 06:46'!
model: aModel choose: message fromList: aList values: values lines: lines cancel: cancel
	| list |
	list := self new initialize.
	^list 
		model: aModel 
		choose: message 
		fromList: aList 
		values: values 
		lines: lines 
		cancel: cancel! !
