'Goodies (11/18/2001 8:35 am)'.!


Object subclass: #ImageProcessor
	instanceVariableNames: ''
	classVariableNames: 'Masks '
	poolDictionaries: ''
	category: 'Goodies-Images'!
!ImageProcessor commentStamp: '<historical>' prior: 0!
This class is a limited porting of 'Image Processor' by Mr. AOKI Atsushi.

Image Processor
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05

see below,
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ImagePro.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ImagePro.txt
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ImageProcessor class
	instanceVariableNames: ''!

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/18/1998 05:12'!
initializeParamsSize: size width: w height: h count: count
	"
	1	ns		-> for thinning.
	2	k		-> for thinning.
	3	ns1To8	-> for thinning.
	4	bool		-> for thinning.
			1 - 4: Browser fullOnClass: ImageProcessor class selector: #mapPeeker:i:j:params:.
	5	jsw		-> main loop checker.
			Browser fullOnClass: ImageProcessor class selector: #thinningOf2:imagePeeker:imagePoker:mapPeeker:mapPoker:block:params:.
	6	count	-> counter for interim: aBlock.
	7	width	-> original image width.
	8	height	-> original image height.
	9	delta	-> second loop direction.
			Browser fullOnClass: ImageProcessor class selector: #thinFor2:imagePeeker:imagePoker:mapPeeker:mapPoker:params:delta:block:
	"

	| paramArray |
	paramArray := Array new: size.
	paramArray at: 7 put: w.
	paramArray at: 8 put: h.
	paramArray at: 6 put: count.
	^paramArray! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/16/1998 02:48'!
makeThin: anImage 
	"
	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	MessageTally spyOn: [image := ImageProcessor makeThin: image]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	^self makeThin: anImage interim: [:image | image yourself]! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/20/1998 22:38'!
makeThin: anImage interim: aBlock
	"
	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageProcessor makeThin: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	| image map count w h paramArray mapPeeker imagePoker mapPoker |
	Cursor execute showWhile:
		[image := Form extent: anImage extent depth: 1.
		anImage displayOn: image.
		map := (Form extent: anImage extent depth: 4).
		map
			copy: (0 @ 0 extent: image extent)
			from: 0 @ 0
			in: image
			rule: Form paint.
		w := map width - 1.
		h := map height - 1.
		
		mapPeeker := BitBlt bitPeekerFromForm: map.
		imagePoker := BitBlt bitPokerToForm: image.
		mapPoker := BitBlt bitPokerToForm: map.
		
		aBlock notNil ifTrue: [count := 0].
		paramArray := self initializeParamsSize: 9 width: w height: h count: count.
		image := self thinningOf: image 
						imagePoker: imagePoker 
						mapPeeker: mapPeeker 
						mapPoker: mapPoker 
						block: aBlock 
						params: paramArray].
	^image! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/18/1998 04:32'!
mapPeeker: mapPeeker i: i  j: j params: params
	| a1 a2 a3 a4 a5 a6 a7 a8 ns ns1To8 k bool |
	a1 := (mapPeeker pixelAt: i @ (j + 1)) bitInvert bitAnd: 1.
	a2 := (mapPeeker pixelAt: (i - 1) @ (j + 1)) bitInvert bitAnd: 1.
	a3 := (mapPeeker pixelAt: (i - 1) @ j) bitInvert bitAnd: 1.
	a4 := (mapPeeker pixelAt: (i - 1) @ (j - 1)) bitInvert bitAnd: 1.
	a5 := (mapPeeker pixelAt: i @ (j - 1)) bitInvert bitAnd: 1.
	a6 := (mapPeeker pixelAt: (i + 1) @ (j - 1)) bitInvert bitAnd: 1.
	a7 := (mapPeeker pixelAt: (i + 1) @ j) bitInvert bitAnd: 1.
	a8 := (mapPeeker pixelAt: (i + 1) @ (j + 1)) bitInvert bitAnd: 1.
	ns := a1 + a3 + a5 + a7.
	ns1To8 := ns + a2 + a4 + a6 + a8.
	(bool := ns1To8 <= 6)
		ifTrue: 
			[k := ns - ((a1 bitAnd: a2)
							bitAnd: a3) - ((a3 bitAnd: a4)
							bitAnd: a5) - ((a5 bitAnd: a6)
							bitAnd: a7) - ((a7 bitAnd: a8)
							bitAnd: a1)]
		ifFalse: 
			[k := nil].
	^params at: 1 put: ns; at: 2 put: k; at: 3 put: ns1To8; at: 4 put: bool! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/17/1998 20:07'!
scanFor: mapPeeker poker: mapPoker w: w h: h block: aBlock
	"loop: jsw = 1"

	Cursor wait showWhile: 
		[1 to: w - 1 do: [:x | 1 to: h - 1 do: [:y | 
			(mapPeeker pixelAt: x @ y)
				= 1 ifTrue: [(mapPeeker pixelAt: (x - 1) @ y) 
					= 0
					ifTrue: [mapPoker pixelAt: x @ y put: 3]
					ifFalse: [(mapPeeker pixelAt: x @ (y - 1))
							= 0
							ifTrue: [mapPoker pixelAt: x @ y put: 5]
							ifFalse: [(mapPeeker pixelAt: (x + 1) @ y)
									= 0
									ifTrue: [mapPoker pixelAt: x @ y put: 3]
									ifFalse: [(mapPeeker pixelAt: x @ (y + 1))
											= 0
											ifTrue: [mapPoker pixelAt: x @ y put: 5]
											ifFalse: []]]]]]]]! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/20/1998 22:37'!
thinFor: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker params: params delta: delta block: aBlock
	"loop: jsw = 0"

	| ii1 ii2 jj1 jj2 i j data jsw count |
	jsw := params at: 5.
	count := params at: 6.
	(delta = 1)
		ifTrue:  
			[ii1 := 1.
			ii2 := (params at: 7).	"width"
			jj1 := 1.
			jj2 := (params at: 8).		"height"
			data := 3]
		ifFalse: 
			[ii1 := (params at: 7) - 1.	"w - 1"
			ii2 := 0.
			jj1 := (params at: 8) - 1.	"h - 1"
			jj2 := 0.
			data := 5].
	i := ii1.
	[i ~= ii2]
		whileTrue: 
			[j := jj1.
			[j ~= jj2]
				whileTrue: 
					[(mapPeeker pixelAt: i @ j) = data
						ifTrue: 
							[jsw := 1.
							self mapPeeker: mapPeeker i: i j: j params: params.
							"ns := params at: 1.
							k := params at: 2.
							ns + a2 + a4 + a6 + a8 := params at: 3."
							"(params at: 3) <= 6"
							(params at: 4)
								ifTrue: 
									["k := array at: 2"
									(params at: 2) = 1
										ifTrue: 
											[mapPoker pixelAt: i @ j put: 0.
											imagePoker pixelAt: i @ j put: 0.
											aBlock notNil
												ifTrue: 
													[count \\ 64 = 0 ifTrue: [aBlock value: image].
													count := count + 1]]
										ifFalse: 
											[mapPoker pixelAt: i @ j put: 7]]
								ifFalse: 
									[mapPoker pixelAt: i @ j put: 7]].
					j := j + delta].
			i := i + delta].
	params at: 5 put: jsw.
	params at: 6 put: count.
	^params! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 10/20/1998 22:38'!
thinningOf: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker block: aBlock params: params 

	"thinning loop"
	| jsw delta count loop width height |
	loop := true.
	count := params at: 6.
	width := params at: 7.
	height := params at: 8.
	[loop]
		whileTrue: 
			[self scanFor: mapPeeker poker: mapPoker w: width h: height block: aBlock.
			jsw := 0.
			delta := 1.
			[delta >= -1]
				whileTrue: 
					[params at: 5 put: jsw.
					params at: 6 put: count.
					params at: 9 put: delta.
					self thinFor: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker params: params delta: delta block: aBlock.
					jsw := params at: 5.
					count := params at: 6.
					delta := delta - 2].
			loop := jsw > 0].
	aBlock notNil ifTrue: [aBlock value: image].
	^image! !

!ImageProcessor class methodsFor: 'thinning' stamp: 'nishis 8/4/1998 12:57'!
thinningTest
	"ImageProcessor thinningTest."

	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageProcessor makeThin: image. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image! !


!ImageProcessor class methodsFor: 'tracing' stamp: 'nishis 10/12/1998 03:16'!
borderFollowing: anImage
	"
	| dot image view collection aLinearFit | 
	dot := Form extent: 1 @ 1 depth: 1. 
	dot colorAt: 0 @ 0 put: Color black. 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	collection := ImageProcessor borderFollowing: image. 
	collection do: [:assoc | 
		aLinearFit := LinearFit new.
		assoc value do: [:point | aLinearFit add: point].		
		aLinearFit displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display. 
	"

	^self borderFollowing: anImage interim: [:point | point yourself]! !

!ImageProcessor class methodsFor: 'tracing' stamp: 'nishis 10/17/1998 03:06'!
borderFollowing: anImage interim: aBlock
	"
	| dot image view collection aLinearFit | 
	dot := Form extent: 1 @ 1 depth: 1. 
	dot colorAt: 0 @ 0 put: Color black. 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	collection := ImageProcessor 
		borderFollowing: image 
		interim: [:p | dot displayOn: Display at: view insetDisplayBox origin + p clippingBox: view insetDisplayBox]. 
	collection do: [:assoc | 
		aLinearFit := LinearFit new.
		aLinearFit form: ((Form extent: 1 @ 1 depth: 8) fillColor: Color red).
		assoc value do: [:point | aLinearFit add: point].		
		aLinearFit displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display. 
	"

	| temp image borders b1 b2 b3 b4 direction collection peeker poker |
	Cursor execute showWhile: [
		temp := Form extent: anImage extent depth: 1.
		anImage displayOn: temp.
		image := ColorForm extent: anImage extent + (2 @ 2) depth: 2.
		image
			copy: (1 @ 1 extent: temp extent)
			from: 0 @ 0
			in: temp
			rule: Form over.
		
		peeker := BitBlt bitPeekerFromForm: image.
		poker := BitBlt bitPokerToForm: image.

		borders := OrderedCollection new.
		0 to: image width - 1 do: [:i | 0 to: image height - 1 do: [:j | (peeker pixelAt: i @ j)
					= 1
					ifTrue: 
						[b1 := peeker pixelAt: i @ (j + 1).
						b2 := peeker pixelAt: (i - 1) @ j.
						b3 := peeker pixelAt: i @ (j - 1).
						b4 := peeker pixelAt: (i + 1) @ j.
						0 = (((b1 bitAnd: b2)
								bitAnd: b3)
								bitAnd: b4)
							ifTrue: 
								[b4 = 0
									ifTrue: ["in"
										direction := 6]
									ifFalse: [b3 = 0
											ifTrue: ["out"
												direction := 4]
											ifFalse: [b2 = 0
													ifTrue: ["out"
														direction := 2]
													ifFalse: [b1 = 0
															ifTrue: ["in"
																direction := 0]
															ifFalse: [direction := nil]]]].
								direction notNil
									ifTrue: 
										[collection := self
													borderFollowingPoint: i @ j
													direction: direction
													peeker: peeker 
													poker: poker 
													block: aBlock.
										collection isEmpty ifFalse: [borders addLast: direction -> collection]]]]]]].
	^borders! !

!ImageProcessor class methodsFor: 'tracing' stamp: 'nishis 10/17/1998 02:18'!
borderFollowingPoint: point direction: ds peeker: peeker poker: poker block: block 
	| border is iw i js jw j d n nb nc loop1 p loop2 |
	border := OrderedCollection new.
	i := iw := is := point x.
	j := jw := js := point y.
	d := ds.
	n := d + 4 bitAnd: 7.
	d := -1.
	nb := -1.
	nc := 0.
	nc := nc + (peeker pixelAt: (i - 1) @ (j - 1)).
	nc := nc + (peeker pixelAt: (i - 1) @ j).
	nc := nc + (peeker pixelAt: (i - 1) @ (j + 1)).
	nc := nc + (peeker pixelAt: i @ (j - 1)).
	nc := nc + (peeker pixelAt: i @ (j + 1)).
	nc := nc + (peeker pixelAt: (i + 1) @ (j - 1)).
	nc := nc + (peeker pixelAt: (i + 1) @ j).
	nc := nc + (peeker pixelAt: (i + 1) @ (j + 1)).
	nc > 0
		ifTrue: 
			[loop1 := true.
			[loop1]
				whileTrue: 
					[i := iw.
					j := jw.
					poker pixelAt: iw @ jw put: 3.
					p := iw @ jw - (1 @ 1).
					border addLast: p.
					block notNil ifTrue: [block value: p].
					n := n + 4 bitAnd: 7.
					loop2 := true.
					[loop2]
						whileTrue: 
							[n := n + 1 bitAnd: 7.
							iw := i + (#(0 -1 -1 -1 0 1 1 1) at: n + 1).
							jw := j + (#(1 1 0 -1 -1 -1 0 1) at: n + 1).
							loop2 := 0 = (peeker pixelAt: iw @ jw)].
					d < 0 ifTrue: [nb < 0
							ifTrue: [nb := n]
							ifFalse: [d := nb]].
					loop1 := i ~= is | (j ~= js) | (n ~= d)]]
		ifFalse: [poker pixelAt: i @ j put: 2].
	^border! !

!ImageProcessor class methodsFor: 'tracing' stamp: 'nishis 10/12/1998 03:28'!
traceBorder: anImage 
	"
	| image collection view aLinearFit | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	collection := ImageProcessor traceBorder: image. 
	view clearInside.
	collection do: [:points | 
		aLinearFit := LinearFit new.
		points do: [:point | aLinearFit add: point].		
		aLinearFit displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display. 
	"

	^self traceBorder: anImage interim: [:p | ]! !

!ImageProcessor class methodsFor: 'tracing' stamp: 'nishis 10/12/1998 03:32'!
traceBorder: anImage interim: aBlock 
	"
	| image collection view lineForm aLinearFit | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clear. 
	lineForm := (Form extent: 1 @ 1) fillBlack.
	view clearInside. 
	collection := ImageProcessor 
		traceBorder: image 
		interim: [:p | (Line from: p to: p withForm: lineForm) displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	collection do: [:points | 
		aLinearFit := LinearFit new.
		aLinearFit form: ((Form extent: 1 @ 1 depth: 8) fillColor: Color red).
		points do: [:point | aLinearFit add: point].		
		aLinearFit displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display. 
	"

	^(self borderFollowing: anImage interim: aBlock)
		collect: [:assoc | assoc value]! !

!ImageProcessor class methodsFor: 'tracing' stamp: 'nishis 10/12/1998 03:34'!
tracingTest
	"ImageProcessor tracingTest."

	| image collection view aLinearFit | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	collection := ImageProcessor traceBorder: image. 
	view clearInside.
	collection do: [:points | 
		aLinearFit := LinearFit new.
		points do: [:point | aLinearFit add: point].		
		aLinearFit displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display. 
	^collection! !


!ImageProcessor class methodsFor: 'juicing' stamp: 'nishis 10/18/1998 01:22'!
juice: anImage strongly: anInteger color: colorValue 
	"
	| image color view | 
	image := Form fromUser. 
	color := ColorSpuit request. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageProcessor 
		juice: image 
		strongly: 0.99 
		color: color. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	^self
		juice: anImage
		strongly: anInteger
		color: colorValue
		interim: [:img | img yourself]! !

!ImageProcessor class methodsFor: 'juicing' stamp: 'nishis 10/18/1998 01:20'!
juice: anImage strongly: anInteger color: colorValue interim: aBlock 
	"
	| image color view startTime | 
	image := Form fromUser. 
	color := ColorSpuit request. 
	startTime := Time now.
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageProcessor 
		juice: image 
		strongly: 0.99 
		color: color 
		interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	Transcript cr; show: (Time now asSeconds - startTime asSeconds) printString.
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	| image threshold count color bool peeker poker depth |
	Cursor execute showWhile: 
		[image := Form
					extent: anImage extent
					depth: 1.
		peeker := BitBlt bitPeekerFromForm: anImage.
		poker := BitBlt bitPokerToForm: image.
		depth := anImage depth.
		threshold := 1 - (0 max: (anInteger min: 1)).
		aBlock notNil ifTrue: [count := 1].
		0 to: anImage height - 1
			do: 
				[:y | 
				0 to: anImage width - 1
					do: 
						[:x | 
						color := Color colorFromPixelValue: (peeker pixelAt: x @ y) depth: depth.
						bool := (color red - colorValue red) abs <= threshold.
						bool := (color green - colorValue green) abs <= threshold and: [bool].
						bool := (color blue - colorValue blue) abs <= threshold and: [bool].
						bool
							ifTrue: [poker
									pixelAt: x @ y
									put: 1]
							ifFalse: [poker
									pixelAt: x @ y
									put: 0]].
				aBlock notNil
					ifTrue: 
						[count \\ 16 = 0 ifTrue: [aBlock value: image].
						count := count + 1]].
		aBlock notNil ifTrue: [aBlock value: image]].
	^image! !


!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 01:37'!
flushMasks
	"ImageProcessor flushMasks."

	Masks := nil! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 01:42'!
halftone: halftoneScale 
	"ImageProcessor halftone: 0.5."
	"
	| view | 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	0 to: 1 by: 0.01 do: [:n | 
		Transcript cr; show: (n roundTo: 0.01) printString. 
		(ImageProcessor halftone: n) displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	"

	| scale index |
	scale := halftoneScale.
	scale := scale max: 0.
	scale := scale min: 1.
	index := (self masks size - 1 * scale) rounded + 1.
	^self maskAt: index! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 22:14'!
image: anImage halftone: halftoneScale 
	"ImageProcessor image: Form fromUser halftone: 0.5."
	"ImageProcessor show: (ImageProcessor image: Form fromUser halftone: 0.5)."
	"ImageProcessor show: (ImageProcessor image: (Form fromDisplay: (0 @ 0 extent: 100 @ 100)) halftone: 0.5)."

	anImage depth > 8 
		ifTrue: [^self imageOver256: anImage halftone: halftoneScale].
	^self imageUnder256: anImage halftone: halftoneScale! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 22:12'!
imageOver256: anImage halftone: halftoneScale 
	| halftone image depth peeker poker whiteColor |
	depth := anImage depth.
	halftone := self mask: anImage boundingBox extent halftone: halftoneScale.
	image := Form extent: anImage boundingBox extent depth: depth.
	anImage displayOn: image.
	whiteColor := Color white pixelValueForDepth: image depth.
	peeker := BitBlt bitPeekerFromForm: halftone.
	poker := BitBlt bitPokerToForm: image.
	Cursor execute showWhile: 
		[1 to: image width - 1 do: [:x | 1 to: image height - 1 do: [:y | 
			(peeker pixelAt: x @ y) 
				= 0 ifTrue: [poker pixelAt: x @ y put: whiteColor]]]].
	^image! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 22:14'!
imageUnder256: anImage halftone: halftoneScale 
	| halftone image |
	halftone := self mask: anImage boundingBox extent halftone: 1.0 - halftoneScale.
	image := Form extent: anImage boundingBox extent depth: anImage depth.
	(BitBlt toForm: image)
		copy: anImage boundingBox
		from: 0 @ 0
		in: anImage
		fillColor: nil
		rule: Form paint.
	(BitBlt toForm: image)
		copy: anImage boundingBox
		from: 0 @ 0
		in: halftone
		fillColor: nil
		rule: Form erase1bitShape.
	^image! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 19:17'!
mask: extentPoint halftone: halftoneScale 
	"ImageProcessor mask: 64 @ 64 halftone: 0.5."
	"ImageProcessor show: (ImageProcessor mask: 64 @ 64 halftone: 0.5)."

	| pattern image |
	pattern := self halftone: halftoneScale.
	image := Form
				extent: extentPoint
				depth: pattern depth.
	self
		tile: image boundingBox
		from: 0 @ 0
		in: pattern
		rule: Form over
		on: image.
	^image! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 01:37'!
maskAt: indexInteger 
	"ImageProcessor maskAt: 33."
	"ImageProcessor show: (ImageProcessor maskAt: 33)."

	| index |
	index := indexInteger.
	index := (index max: 1) asInteger.
	index := (index min: self masks size) asInteger.
	^self masks at: index! !

!ImageProcessor class methodsFor: 'halftone' stamp: 'nishis 10/18/1998 01:37'!
masks
	"ImageProcessor masks."
	"ImageProcessor flushMasks."

	| map masks mask count x y poker |
	Masks notNil ifTrue: [^Masks].
	map := #(1 33 9 41 3 35 11 43 59 17 49 25 57 19 51 27 13 45 5 37 15 47 7 39 55 29 61 21 53 31 63 23 4 36 12 44 2 34 10 42 58 20 52 28 60 18 50 26 16 48 8 40 14 46 6 38 54 32 64 24 56 30 62 22).
	masks := OrderedCollection new: 65.
	0 to: 64
		do: 
			[:index | 
			mask := Form
						extent: 16 @ 16
						depth: 1.
			poker := BitBlt bitPokerToForm: mask.
			index > 0
				ifTrue: 
					[count := 0.
					map
						do: 
							[:each | 
							each <= index
								ifTrue: 
									[x := count \\ 8.
									y := count // 8.
									poker
										pixelAt: x @ y
										put: 1.
									poker
										pixelAt: (x + 8) @ y
										put: 1.
									poker
										pixelAt: x @ (y + 8)
										put: 1.
									poker
										pixelAt: (x + 8) @ (y + 8)
										put: 1].
							count := count + 1]].
			"mask palette: CoveragePalette monoMaskPalette."
			masks add: mask].
	Masks := masks.
	^Masks! !


!ImageProcessor class methodsFor: 'histogram' stamp: 'nishis 11/2/1998 23:06'!
colorHistogram: anImage 
	"
	| image view histogram point color value | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	histogram := ImageProcessor colorHistogram: image. 
	point := 0 @ 0. 
	point := view insetDisplayBox topLeft.
	histogram do: [:assoc | 
		color := assoc key. 
		value := (assoc value * 400) rounded. 
		(Quadrangle region: (point extent: value @ 3) borderWidth: 1 borderColor: Color black insideColor: color) display.
		point := point + (0 @ 5)]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^histogram
	"

	| image dictionary index histogram color value pair cx cy dx dy colorMap peeker |
	Cursor execute showWhile: 
		[image := ColorForm extent: anImage extent depth: 8.
		anImage displayOn: image.
		colorMap := image colors.
		peeker := BitBlt bitPeekerFromForm: image.
		dictionary := Dictionary new.
		0 to: image height - 1 do: [:y | 0 to: image width - 1
				do: 
					[:x | 
					index := "colorMap at: "((peeker pixelAt: x @ y) bitAnd: 16rFF) + 1.
					(dictionary includesKey: index)
						ifTrue: [dictionary at: index put: 1 + (dictionary at: index)]
						ifFalse: [dictionary at: index put: 1]]].
		histogram := SortedCollection new: dictionary size.
		histogram
			sortBlock: 
				[:x :y | 
				dx := self distanceFrom: Color black to: (cx := x key).
				dy := self distanceFrom: Color black to: (cy := y key).
				cx = cy
					ifTrue: [(cx red < cy red and: [cx green < cy green])
							and: [cx blue < cy blue]]
					ifFalse: [dx < dy]].
		dictionary
			associationsDo: 
				[:assoc | 
				color := colorMap at: assoc key.
				value := assoc value / (image width * image height).
				pair := Association key: color value: value asFloat.
				histogram add: pair].
		histogram := histogram asArray].
	^histogram! !

!ImageProcessor class methodsFor: 'histogram' stamp: 'nishis 10/26/1998 13:34'!
distanceFrom: fromColor to: toColor
	| r g b |
	r := toColor red - fromColor red.
	g := toColor green - fromColor green.
	b := toColor blue - fromColor blue.
	^((r * r) + (g * g) + (b * b)) sqrt! !

!ImageProcessor class methodsFor: 'histogram' stamp: 'nishis 11/2/1998 23:06'!
grayHistogram: anImage 
	"
	| image view histogram point color value |
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	histogram := ImageProcessor grayHistogram: image. 
	point := view insetDisplayBox topLeft.
	histogram do: [:assoc | 
		color := assoc key. 
		value := (assoc value * 400) rounded. 
		(Quadrangle region: (point extent: value @ 3) 
				borderWidth: 1 
				borderColor: Color black 
				insideColor: color) display.
		point := point + (0 @ 5)]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^histogram
	"

	| image dictionary index histogram color value pair grayScale colorMap peeker dx cx dy cy |
	Cursor execute showWhile: 
		[grayScale := Form extent: anImage extent depth: 32.
		anImage displayOn: grayScale.
		grayScale := grayScale asGrayScale.
		image := ColorForm extent: anImage extent depth: 8.
		grayScale displayOn: image.
		colorMap := image colors.
		peeker := BitBlt bitPeekerFromForm: image.
		dictionary := Dictionary new.
		0 to: image height - 1 do: [:y | 0 to: image width - 1
				do: 
					[:x | 
					index := ((peeker pixelAt: x @ y) bitAnd: 16rFF) + 1.
					(dictionary includesKey: index)
						ifTrue: [dictionary at: index put: 1 + (dictionary at: index)]
						ifFalse: [dictionary at: index put: 1]]].
		histogram := SortedCollection new: dictionary size.
		histogram
			sortBlock: 
				[:x :y | 
				dx := self distanceFrom: Color black to: (cx := x key).
				dy := self distanceFrom: Color black to: (cy := y key).
				cx = cy
					ifTrue: [(cx red < cy red and: [cx green < cy green])
							and: [cx blue < cy blue]]
					ifFalse: [dx < dy]].
		dictionary
			associationsDo: 
				[:assoc | 
				color := colorMap at: assoc key.
				value := assoc value / (image width * image height).
				pair := Association key: color value: value asFloat.
				histogram add: pair].
		histogram := histogram asArray].
	^histogram! !


!ImageProcessor class methodsFor: 'spectrum' stamp: 'nishis 11/2/1998 23:07'!
xSpectrum: anImage 
	"
	| image view spectrum x y value | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	spectrum := ImageProcessor xSpectrum: image. 
	y := view insetDisplayBox topLeft y. 
	spectrum do: [:assoc | 
		x := assoc key + view insetDisplayBox topLeft x. 
		value := (assoc value * 100) rounded. 
		(Quadrangle region: (x @ y extent: 1 @ value) borderWidth: 1 borderColor: Color black insideColor: Color black) display]. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^spectrum
	"

	| image dictionary  spectrum color key value pair colorMap peeker |
	Cursor execute showWhile: 
		[image := ColorForm extent: anImage extent depth: 8.
		anImage displayOn: image.
		colorMap := image colors.
		peeker := BitBlt bitPeekerFromForm: image.
		dictionary := Dictionary new.
		0 to: image width - 1 
			do: 
				[:x | 
				key := x.
				value := 0.
				0 to: image height - 1
					do: 
						[:y | 
						color := colorMap at: ((peeker pixelAt: x @ y) bitAnd: 16rFF) + 1.
						value := value + (1 - color brightness)].
				(dictionary includesKey: key)
					ifTrue: [value := value + (dictionary at: key)].
				dictionary at: key put: value].
		spectrum := SortedCollection new: dictionary size.
		dictionary
			associationsDo: 
				[:assoc | 
				value := assoc value / image height.
				pair := Association key: assoc key value: value asFloat.
				spectrum add: pair].
		spectrum := spectrum asArray].
	^spectrum! !

!ImageProcessor class methodsFor: 'spectrum' stamp: 'nishis 11/2/1998 23:08'!
ySpectrum: anImage 
	"
	| image view spectrum x y value | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	spectrum := ImageProcessor ySpectrum: image. 
	x := view insetDisplayBox topLeft x.
	spectrum do: [:assoc | 
		y := assoc key + view insetDisplayBox topLeft y. 
		value := (assoc value * 100) rounded. 
		(Quadrangle region: (x @ y extent: value @ 1) borderWidth: 1 borderColor: Color black insideColor: Color black) display].
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^spectrum
	"

	| image dictionary  spectrum color key value pair colorMap peeker |
	Cursor execute showWhile: 
		[image := ColorForm extent: anImage extent depth: 8.
		anImage displayOn: image.
		colorMap := image colors.
		peeker := BitBlt bitPeekerFromForm: image.
		dictionary := Dictionary new.
		0 to: image height - 1
			do: 
				[:y | 
				key := y.
				value := 0.
				0 to: image width - 1
					do: 
						[:x | 
						color := colorMap at: ((peeker pixelAt: x @ y) bitAnd: 16rFF) + 1.
						value := value + (1 - color brightness)].
				(dictionary includesKey: key)
					ifTrue: [value := value + (dictionary at: key)].
				dictionary at: key put: value].
		spectrum := SortedCollection new: dictionary size.
		dictionary
			associationsDo: 
				[:assoc | 
				value := assoc value / image width.
				pair := Association key: assoc key value: value asFloat.
				spectrum add: pair].
		spectrum := spectrum asArray].
	^spectrum! !


!ImageProcessor class methodsFor: 'documentation' stamp: 'nishis 8/4/1998 12:46'!
readMe
"
This class is a limited porting of 'ImageProcessor' by Mr. AOKI Atsushi.

Image Processor
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05

see below,
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ImagePro.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/ImagePro.txt
"! !


!ImageProcessor class methodsFor: 'viewing' stamp: 'nishis 10/19/1998 03:55'!
show: anImage 
	"ImageProcessor show: Form fromUser."

	ImageProcessor show: anImage label: 'Image'.
	^anImage! !

!ImageProcessor class methodsFor: 'viewing' stamp: 'nishis 10/19/1998 03:55'!
show: anImage label: label 
	"ImageProcessor show: Form fromUser label: 'user image'."

	| topView aView extent |
	topView := StandardSystemView new.
	topView model: anImage.
	topView label: label.
	extent := 64 @ 64 max: (anImage extent min: Display boundingBox extent - 60 asPoint).
	topView minimumSize: extent.
	aView := FormView new.
	aView model: anImage.
	aView window: (0 @ 0 extent: anImage extent + (4@4)).
		"compensate for borders.  Should be window:viewport:"
	aView borderWidthLeft: 2 right: 2 top: 2 bottom: 2.
	topView addSubView: aView.
	topView controller open.
	^anImage! !


!ImageProcessor class methodsFor: 'saving' stamp: 'nishis 10/18/1998 21:04'!
save
	"ImageProcessor save."

	| fileName classCollection aStream timeStamp |
	fileName := 'ImgPrLtd.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today printString, ' ' , Time now printString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (String cr, 
							self comment asString, String cr) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr.
					aStream cr]].
	aStream close.
	^classCollection! !

!ImageProcessor class methodsFor: 'saving' stamp: 'nishis 10/18/1998 21:03'!
saveClasses
	"ImageProcessor saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*ImageProcessor*').
	classCollection := (SystemOrganization superclassOrder: self category).
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!ImageProcessor class methodsFor: 'private' stamp: 'nishis 11/1/1998 01:25'!
brightnessAt: aPoint from: image peeker: peeker
	^(self colorAt: aPoint from: image peeker: peeker) brightness! !

!ImageProcessor class methodsFor: 'private' stamp: 'nishis 10/25/1998 11:18'!
colorAt: aPoint from: image peeker: peeker
	^Color colorFromPixelValue: (peeker pixelAt: aPoint) depth: image depth! !

!ImageProcessor class methodsFor: 'private' stamp: 'nishis 10/17/1998 19:27'!
displayProgress: message at: aPoint from: minVal to: maxVal during: workBlock 

	"see below
	Browser fullOnClass: String selector: #displayProgressAt:from:to:during:.
	"

	| delta savedArea captionText textFrame barFrame outerFrame result range lastW w |
	(message = '') ifTrue: [^workBlock value: [:val | ]].
	barFrame := aPoint - (75@10) corner: aPoint + (75@10).
	captionText := DisplayText text: message asText allBold.
	captionText
		foregroundColor: Color black
		backgroundColor: Color white.
	textFrame := captionText boundingBox insetBy: -4.
	textFrame := textFrame align: textFrame bottomCenter
					with: barFrame topCenter + (0@2).
	outerFrame := barFrame merge: textFrame.
	delta := outerFrame amountToTranslateWithin: Display boundingBox.
	barFrame := barFrame translateBy: delta.
	textFrame := textFrame translateBy: delta.
	outerFrame := outerFrame translateBy: delta.
	savedArea := Form fromDisplay: outerFrame.
	Display fillBlack: barFrame; fillWhite: (barFrame insetBy: 2).
	Display fillBlack: textFrame; fillWhite: (textFrame insetBy: 2).
	captionText displayOn: Display at: textFrame topLeft + (4@4).
	range := maxVal = minVal ifTrue: [1] ifFalse: [maxVal - minVal].  "Avoid div by 0"
	lastW := 0.
	result := workBlock value:  "Supply the bar-update block for evaluation in the work block"
		[:barVal |
		w _ ((barFrame width-4) asFloat * ((barVal-minVal) asFloat / range min: 1.0)) asInteger.
		w ~= lastW ifTrue: [
			Display fillGray: (barFrame topLeft + (2@2) extent: w@16).
			Display fillWhite: (barFrame topLeft + (w+2@2) extent: (barFrame width-4-w)@16).
			lastW := w]].
	savedArea displayOn: Display at: outerFrame topLeft.
	^ result! !

!ImageProcessor class methodsFor: 'private' stamp: 'nishis 10/18/1998 02:52'!
tile: destRectangle from: sourcePt in: sourceForm rule: combinationRule on: destForm

	| x y point |
	x := (destRectangle width / sourceForm width) ceiling.
	y := (destRectangle height / sourceForm height) ceiling.
	(x < 0 or: [y < 0]) ifTrue: [^destForm].
	1 to: x do: [:i | 1 to: y do: [:j | 
			point := ((i - 1) * (sourceForm width)) @ ((j - 1) * (sourceForm height)).
			destForm
				copy: (sourceForm boundingBox translateBy: point)
				from: sourcePt
				in: sourceForm
				rule: combinationRule]].
	^destForm! !


!ImageProcessor class methodsFor: 'thinning2' stamp: 'nishis 10/18/1998 05:43'!
initializeParamsSize2: size width: w height: h count: count origin: origin corner: corner
	"
	1	ns		-> for thinning.
	2	k		-> for thinning.
	3	ns1To8	-> for thinning.
	4	bool		-> for thinning.
			1 - 4: Browser fullOnClass: ImageProcessor class selector: #mapPeeker:i:j:params:.
	5	jsw		-> main loop checker.
			Browser fullOnClass: ImageProcessor class selector: #thinningOf2:imagePeeker:imagePoker:mapPeeker:mapPoker:block:params:.
	6	count	-> counter for interim: aBlock.
	7	width	-> original image width.
	8	height	-> original image height.
	9	delta	-> second loop direction.
			Browser fullOnClass: ImageProcessor class selector: #thinFor2:imagePeeker:imagePoker:mapPeeker:mapPoker:params:delta:block:
	10	origin	-> origin of scanning rectangle. (variable)
	11	corner	-> corner of scanning rectangle. (variable)
	"

	| paramArray |
	paramArray := Array new: size.
	paramArray at: 7 put: w.
	paramArray at: 8 put: h.
	paramArray at: 6 put: count.
	paramArray at: 10 put: origin.
	paramArray at: 11 put: corner.
	^paramArray! !

!ImageProcessor class methodsFor: 'thinning2' stamp: 'nishis 10/17/1998 21:23'!
makeThin2: anImage 
	"
	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	MessageTally spyOn: [image := ImageProcessor makeThin2: image]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	^self makeThin2: anImage interim: [:image | image yourself]! !

!ImageProcessor class methodsFor: 'thinning2' stamp: 'nishis 10/20/1998 22:40'!
makeThin2: anImage interim: aBlock
	"
	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageProcessor makeThin2: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	| image map count w h paramArray mapPeeker imagePoker mapPoker |
	Cursor execute showWhile:
		[image := Form extent: anImage extent depth: 1.
		anImage displayOn: image.
		map := (Form extent: anImage extent depth: 4).
		map
			copy: (0 @ 0 extent: image extent)
			from: 0 @ 0
			in: image
			rule: Form paint.
		w := map width - 1.
		h := map height - 1.
		
		mapPeeker := BitBlt bitPeekerFromForm: map.
		imagePoker := BitBlt bitPokerToForm: image.
		mapPoker := BitBlt bitPokerToForm: map.
		
		aBlock notNil ifTrue: [count := 0].
		paramArray := self initializeParamsSize2: 11 width: w height: h count: count origin: 1 @ 1 corner: w @ h.
		image := self thinningOf2: image 
						imagePoker: imagePoker 
						mapPeeker: mapPeeker 
						mapPoker: mapPoker 
						block: aBlock 
						params: paramArray].
	^image! !

!ImageProcessor class methodsFor: 'thinning2' stamp: 'nishis 10/18/1998 05:50'!
scanFor2: mapPeeker poker: mapPoker params: params block: aBlock 
	"loop: jsw = 1"

	| maxX minX maxY minY w h |
	maxX := (params at: 10) x.
	maxY := (params at: 10) y.
	minX := (params at: 11) x.
	minY := (params at: 11) y.
	w := (params at: 11) x.
	h := (params at: 11) y.
	Cursor wait showWhile: 
		[(params at: 10) x to: w - 1 do: [:x | (params at: 10) y to: h - 1 do: [:y | 
		(mapPeeker pixelAt: x @ y)
			= 1 ifTrue: [(mapPeeker pixelAt: (x - 1) @ y) 
				= 0
				ifTrue: [mapPoker pixelAt: x @ y put: 3.
						minX := minX min: x.
						minY := minY min: y.
						maxX := maxX max: x+1.
						maxY := maxY max: y+1]
				ifFalse: [(mapPeeker pixelAt: x @ (y - 1))
						= 0
						ifTrue: [mapPoker pixelAt: x @ y put: 5.
								minX := minX min: x.
								minY := minY min: y.
								maxX := maxX max: x+1.
								maxY := maxY max: y+1]
						ifFalse: [(mapPeeker pixelAt: (x + 1) @ y)
								= 0
								ifTrue: [mapPoker pixelAt: x @ y put: 3.
										minX := minX min: x.
										minY := minY min: y.
										maxX := maxX max: x+1.
										maxY := maxY max: y+1]
								ifFalse: [(mapPeeker pixelAt: x @ (y + 1))
										= 0
										ifTrue: [mapPoker pixelAt: x @ y put: 5.
												minX := minX min: x.
												minY := minY min: y.
												maxX := maxX max: x+1.
												maxY := maxY max: y+1]
										ifFalse: []]]]]]]].
	params at: 10 put: minX @ minY.
	params at: 11 put: maxX @ maxY! !

!ImageProcessor class methodsFor: 'thinning2' stamp: 'nishis 10/20/1998 22:39'!
thinFor2: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker params: params delta: delta block: aBlock 
	"loop: jsw = 0"

	| ii1 ii2 jj1 jj2 i j data jsw aCount |
	jsw := params at: 5.
		aCount := params at: 6.
		(delta = 1)
			ifTrue:  
				[ii1 := (params at: 10) x.
				ii2 := (params at: 11) x.	"width"
				jj1 := (params at: 10) y.
				jj2 := (params at: 11) y.		"height"
				data := 3]
			ifFalse: 
				[ii1 := (params at: 11) x - 1.	"w - 1"
				ii2 := (params at: 10) x - 1.
				jj1 := (params at: 11) y - 1.	"h - 1"
				jj2 := (params at: 10) y - 1.
				data := 5].
		i := ii1.
		[i ~= ii2]
			whileTrue: 
				[j := jj1.
				[j ~= jj2]
					whileTrue: 
						[(mapPeeker pixelAt: i @ j) = data
							ifTrue: 
								[jsw := 1.
								self mapPeeker: mapPeeker i: i j: j params: params.
								(params at: 4)
									ifTrue: 
										[(params at: 2) = 1
											ifTrue: 
												[mapPoker pixelAt: i @ j put: 0.
												imagePoker pixelAt: i @ j put: 0.
												aBlock notNil
													ifTrue: 
														[aCount \\ 64 = 0 ifTrue: [aBlock value: image].
														aCount := aCount + 1]]
											ifFalse: 
												[mapPoker pixelAt: i @ j put: 7]]
									ifFalse: 
										[mapPoker pixelAt: i @ j put: 7]].
						j := j + delta].
				i := i + delta].
	params at: 5 put: jsw.
	params at: 6 put: aCount.
	^params! !

!ImageProcessor class methodsFor: 'thinning2' stamp: 'nishis 10/20/1998 22:40'!
thinningOf2: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker block: aBlock params: params 

	"thinning loop"
	| jsw delta count loop |
	loop := true.
	count := params at: 6.	"count."
	[loop]
		whileTrue: 
			[self scanFor2: mapPeeker poker: mapPoker params: params block: aBlock.
			jsw := 0.
			delta := 1.
			(((params at: 11) x <= (params at: 10) x) or: [(params at: 11) y <= (params at: 10) y]) 
				ifTrue: [delta := -2. jsw := 0].
			[delta >= -1]
				whileTrue: 
					[params at: 5 put: jsw.
					params at: 6 put: count.
					params at: 9 put: delta.
					self thinFor2: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker params: params delta: delta block: aBlock.
					jsw := params at: 5.
					count := params at: 6.
					delta := delta - 2].
			loop := jsw > 0].
	aBlock notNil ifTrue: [aBlock value: image].
	^image! !


!ImageProcessor class methodsFor: 'thinningVerbose' stamp: 'nishis 10/17/1998 21:23'!
makeThinVerbose: anImage 
	"
	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	MessageTally spyOn: [image := ImageProcessor makeThinVerbose: image]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox. 
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	^self makeThinVerbose: anImage interim: [:image | image yourself]! !

!ImageProcessor class methodsFor: 'thinningVerbose' stamp: 'nishis 10/20/1998 22:41'!
makeThinVerbose: anImage interim: aBlock
	"
	| image view | 
	image := Form fromUser. 
	view := ScheduledControllers activeController view. 
	view clearInside. 
	image := ImageProcessor makeThinVerbose: image interim: [:img | img displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox]. 
	image displayOn: Display at: view insetDisplayBox origin clippingBox: view insetDisplayBox.
	Cursor crossHair showWhile: [Sensor waitClickButton]. 
	view display.
	^image
	"

	| image map count w h paramArray mapPeeker imagePoker mapPoker |
	Cursor execute showWhile:
		[image := Form extent: anImage extent depth: 1.
		anImage displayOn: image.
		map := (Form extent: anImage extent depth: 4).
		map
			copy: (0 @ 0 extent: image extent)
			from: 0 @ 0
			in: image
			rule: Form paint.
		w := map width - 1.
		h := map height - 1.
		
		mapPeeker := BitBlt bitPeekerFromForm: map.
		imagePoker := BitBlt bitPokerToForm: image.
		mapPoker := BitBlt bitPokerToForm: map.
		
		aBlock notNil ifTrue: [count := 0].
		paramArray := self initializeParamsSize2: 11 width: w height: h count: count origin: 1 @ 1 corner: w @ h.
		image := self thinningOfVerbose: image 
						imagePoker: imagePoker 
						mapPeeker: mapPeeker 
						mapPoker: mapPoker 
						block: aBlock 
						params: paramArray].
	^image! !

!ImageProcessor class methodsFor: 'thinningVerbose' stamp: 'nishis 10/18/1998 05:06'!
scanForVerbose: mapPeeker poker: mapPoker params: params block: aBlock message: message
	"loop: jsw = 1"

	| maxX minX maxY minY w h start |
	maxX := (params at: 10) x.
	maxY := (params at: 10) y.
	minX := (params at: 11) x.
	minY := (params at: 11) y.
	w := (params at: 11) x.
	h := (params at: 11) y.
	start := (params at: 10) x.
	Cursor wait showWhile: 
		"[self displayProgress: ' scanning... ' at: Sensor cursorPoint from: start to: w during: "
		[self displayProgress: message at: Sensor cursorPoint from: start to: w during: 
			[:bar |  (params at: 10) x to: w - 1 do: [:x | (params at: 10) y to: h - 1 do: [:y | 
			(mapPeeker pixelAt: x @ y)
				= 1 ifTrue: [(mapPeeker pixelAt: (x - 1) @ y) 
					= 0
					ifTrue: [mapPoker pixelAt: x @ y put: 3.
							minX := minX min: x.
							minY := minY min: y.
							maxX := maxX max: x+1.
							maxY := maxY max: y+1]
					ifFalse: [(mapPeeker pixelAt: x @ (y - 1))
							= 0
							ifTrue: [mapPoker pixelAt: x @ y put: 5.
									minX := minX min: x.
									minY := minY min: y.
									maxX := maxX max: x+1.
									maxY := maxY max: y+1]
							ifFalse: [(mapPeeker pixelAt: (x + 1) @ y)
									= 0
									ifTrue: [mapPoker pixelAt: x @ y put: 3.
											minX := minX min: x.
											minY := minY min: y.
											maxX := maxX max: x+1.
											maxY := maxY max: y+1]
									ifFalse: [(mapPeeker pixelAt: x @ (y + 1))
											= 0
											ifTrue: [mapPoker pixelAt: x @ y put: 5.
													minX := minX min: x.
													minY := minY min: y.
													maxX := maxX max: x+1.
													maxY := maxY max: y+1]
											ifFalse: []]]]]].
		 	bar value: x]]].
	params at: 10 put: minX @ minY.
	params at: 11 put: maxX @ maxY! !

!ImageProcessor class methodsFor: 'thinningVerbose' stamp: 'nishis 10/20/1998 22:40'!
thinForVerbose: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker params: params delta: delta block: aBlock message: message
	"loop: jsw = 0"

	| ii1 ii2 jj1 jj2 i j data jsw aCount w |
	w := (params at: 11) x.
	self displayProgress: message at: Sensor cursorPoint from: (params at: 10) x to: w during: 
		[:bar | 
		jsw := params at: 5.
		aCount := params at: 6.
		(delta = 1)
			ifTrue:  
				[ii1 := (params at: 10) x.
				ii2 := (params at: 11) x.	"width"
				jj1 := (params at: 10) y.
				jj2 := (params at: 11) y.		"height"
				data := 3]
			ifFalse: 
				[ii1 := (params at: 11) x - 1.	"w - 1"
				ii2 := (params at: 10) x - 1.
				jj1 := (params at: 11) y - 1.	"h - 1"
				jj2 := (params at: 10) y - 1.
				data := 5].
		i := ii1.
		[i ~= ii2]
			whileTrue: 
				[j := jj1.
				bar value: i.
				[j ~= jj2]
					whileTrue: 
						[(mapPeeker pixelAt: i @ j) = data
							ifTrue: 
								[jsw := 1.
								self mapPeeker: mapPeeker i: i j: j params: params.
								(params at: 4)
									ifTrue: 
										[(params at: 2) = 1
											ifTrue: 
												[mapPoker pixelAt: i @ j put: 0.
												imagePoker pixelAt: i @ j put: 0.
												aBlock notNil
													ifTrue: 
														[aCount \\ 64 = 0 ifTrue: [aBlock value: image].
														aCount := aCount + 1]]
											ifFalse: 
												[mapPoker pixelAt: i @ j put: 7]]
									ifFalse: 
										[mapPoker pixelAt: i @ j put: 7]].
						j := j + delta].
				i := i + delta]].
	params at: 5 put: jsw.
	params at: 6 put: aCount.
	^params! !

!ImageProcessor class methodsFor: 'thinningVerbose' stamp: 'nishis 10/20/1998 22:41'!
thinningOfVerbose: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker block: aBlock params: params 

	"thinning loop"
	| jsw delta count loop |
	loop := true.
	count := params at: 6.	"count."
	[loop]
		whileTrue: 
			[self scanForVerbose: mapPeeker poker: mapPoker params: params block: aBlock message: ' scanning... '.
			jsw := 0.
			delta := 1.
			(((params at: 11) x <= (params at: 10) x) or: [(params at: 11) y <= (params at: 10) y]) 
				ifTrue: [delta := -2. jsw := 0].
			[delta >= -1]
				whileTrue: 
					[params at: 5 put: jsw.
					params at: 6 put: count.
					params at: 9 put: delta.
					self thinForVerbose: image imagePoker: imagePoker mapPeeker: mapPeeker mapPoker: mapPoker params: params delta: delta block: aBlock message: ' thinning... '.
					jsw := params at: 5.
					count := params at: 6.
					delta := delta - 2].
			loop := jsw > 0].
	aBlock notNil ifTrue: [aBlock value: image].
	^image! !
