'Goodies (11/18/2001 8:35:02 am)'.!


Array variableSubclass: #LispScannerTable
	instanceVariableNames: ''
	classVariableNames: 'ScanningTable '
	poolDictionaries: ''
	category: 'Goodies-Lisp'!

!LispScannerTable methodsFor: 'accessing'!
at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^#xSymbol]
				ifFalse: [^#xBinary]]
		ifFalse: [^super at: index]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LispScannerTable class
	instanceVariableNames: ''!

!LispScannerTable class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!LispScannerTable class methodsFor: 'copyright'!
system
	^'Goodies'! !

!LispScannerTable class methodsFor: 'copyright'!
version
	^'003'! !


!LispScannerTable class methodsFor: 'table access'!
scannerTable
	| newTable |
	ScanningTable isNil
		ifTrue: 
			[newTable := self new: 256 withAll: #xBinary.
			newTable atAll: #(9 10 11 12 13 32) put: #xDelimiter.
			newTable atAll: ($0 asInteger to: $9 asInteger)
				put: #xDigit.
			newTable atAll: ($A asInteger to: $Z asInteger)
				put: #xSymbol.
			newTable atAll: ($a asInteger to: $z asInteger)
				put: #xSymbol.
			128 to: 256 do: [:i | newTable at: i put: #xSymbol].
			newTable at: $' asInteger put: #quote.
			newTable at: $" asInteger put: #xDoubleQuote.
			newTable at: ${ asInteger put: #xBrace.
			newTable at: $+ asInteger put: #xSign.
			newTable at: $- asInteger put: #xSign.
			newTable at: $< asInteger put: #xSymbol.
			newTable at: $> asInteger put: #xSymbol.
			newTable at: $= asInteger put: #xSymbol.
			newTable at: $~ asInteger put: #xSymbol.
			newTable at: $* asInteger put: #xSymbol.
			newTable at: $/ asInteger put: #xSymbol.
			newTable at: $_ asInteger put: #xSymbol.
			newTable at: $: asInteger put: #xSymbol.
			newTable at: $, asInteger put: #xSymbol.
			newTable at: $\ asInteger put: #xSymbol.
			newTable at: $% asInteger put: #xComment.
			newTable at: $( asInteger put: #leftParenthesis.
			newTable at: $) asInteger put: #rightParenthesis.
			newTable at: $[ asInteger put: #leftParenthesis.
			newTable at: $] asInteger put: #rightParenthesis.
			newTable at: $. asInteger put: #period.
			newTable at: $` asInteger put: #quote.
			newTable at: $!! asInteger put: #eof.
			ScanningTable := newTable].
	^ScanningTable! !
