'Goodies (11/18/2001 8:35:02 am)'.!


Object subclass: #Encyclopedia
	instanceVariableNames: 'classCollection sourceInclusion '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Encyclopedia'!
!Encyclopedia commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Encyclopedia
Goodies for Squeak 2.0
	(Encyclopedia methodsFor: 'html methods'
	methodHtmlForClass: aClass selector: aSymbol on: aStream 
	fixed by the Most Revd AOKI Atsushi, Fri, 10 Apr 1998 17:12:35 +0900)

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Encyclopedia
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (C) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Encyclo.st


Summary:

This goodies makes html files of the classes you want to get 
from virtual image.  So you can browse it with WebBrowser 
(NetscapeNavigator, InternetExplorer etc).  Each html file 
contains suitable links, anchors.  It is an Encyclopedia 
(handbook) including table of contents, index file.


Installing:

FileIn this goodies and makes a class "Encyclopedia" in a 
category "Goodies-Encyclopedia". 

When you want to restore your image, please remove this class 
"Encyclopedia" from your system.  Image will be restored.


how to use:

Making an Encyclopedia which target is all classes exist on 
your image: do it the program below

| collection encyclopedia |
collection := IdentitySet new.
Smalltalk 
    allBehaviorsDo: 
        [:aClass | 
        aClass isMeta ifFalse: [collection add: aClass]].
encyclopedia := Encyclopedia classes: collection.
encyclopedia generate.
^encyclopedia

It takes a long time to finish.  When all is over, the files 
are placed in current directory like that

Encyclopedia/
    images/
        dot1.gif
           :
        dot9.gif
        index.gif
        xrefs.gif
    index.htm
    htmls/
        classname.htm files many as number of classes 
        exist on your image
    xrefs.htm
    xrefA.htm
        :
    xrefZ.htm

Open "index.htm" in Encyclopedia directory with WebBrowser 
(NetscapeNavigator, InternetExplorer etc).

Also, you can include source program within the Encyclopedia.
For example, you can get an Encyclopedia which is classes 
under Number within each source program, do it below.

| encyclopedia |
encyclopedia := Encyclopedia classes: Number withAllSubclasses.
encyclopedia sourceInclusion: true.
encyclopedia generate.
^encyclopedia

You can browse the source program with WebBrowser insted of 
using SystemBrowser on Smalltalk.


*** caution!! ***

When you do it which target is all classes exist on your image 
like example4 or example8, you will be warned that "Space is low".
In that case, please 6MB or more plus for your VM memory.  At 
default, VM memory size is 7205KB.  So it should be assigned at 
13312KB or more is better.

Some examples take very long time to finish.  For example, 
example4: about 21 min
example8: about 32 min
to complete.  There are 521 classes, 12072 methods on 
PowerMacintosh 8500/120 with 750/233 Processor Card.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Encyclo.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Encyclo.txt
QƂĂB


*** ӎ ***

 4, 8 SNXΏۂɂ̂́Ar "Space is low" x
oāA֐i߂ȂƂ܂B̏ꍇ́AƂ肠A
Œ 6MB ȏ㑝₷Ɠ悤ɂȂ܂B

܂A 4, 8 SNXΏۂɂ̂́A܂łɂ
Ԃ|܂B521 ̃NXA12072 ̃\bhC[W
点Ă݂ƂA
example4:  21 
example8:  32 
v܂B
PowerMacintosh 8500/120 with 750/233 Processor Card.

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!Encyclopedia methodsFor: 'accessing'!
classCollection
	classCollection isNil ifTrue: [classCollection := IdentitySet new].
	^classCollection! !

!Encyclopedia methodsFor: 'accessing'!
sourceInclusion
	^sourceInclusion = true! !

!Encyclopedia methodsFor: 'accessing'!
sourceInclusion: aBoolean 
	sourceInclusion := aBoolean = true! !


!Encyclopedia methodsFor: 'generation' stamp: 'nishis 4/2/98 21:50'!
generate
	| aCollection |
	Cursor wait showWhile: [aCollection := self classCollection asSortedCollection: [:c1 :c2 | c1 name < c2 name]].
	aCollection
		do: 
			[:each | 
			Transcript cr; show: each name asString.
			self generateHtmlForClass: each].
	self generateGifs.
	self generateIndex.
	self generateXrefs.
	^self! !

!Encyclopedia methodsFor: 'generation' stamp: 'nishis 6/11/1998 22:39'!
generateGifs
	"Encyclopedia new generateGifs."

	| aCollection readStream writeStream fileName gifData writeBlock |
	aCollection := Dictionary new.
	aCollection add: self fileNameIndexGif -> self indexGifData.
	aCollection add: self fileNameXrefsGif -> self xrefsGifData.
	aCollection add: self fileNameDot1Gif -> self dot1GifData.
	aCollection add: self fileNameDot2Gif -> self dot2GifData.
	aCollection add: self fileNameDot3Gif -> self dot3GifData.
	aCollection add: self fileNameDot4Gif -> self dot4GifData.
	aCollection add: self fileNameDot5Gif -> self dot5GifData.
	aCollection add: self fileNameDot6Gif -> self dot6GifData.
	aCollection add: self fileNameDot7Gif -> self dot7GifData.
	aCollection add: self fileNameDot8Gif -> self dot8GifData.
	aCollection add: self fileNameDot9Gif -> self dot9GifData.
	writeBlock := 
			[: aReadStream : aWriteStream | 
					[aReadStream atEnd]
						whileFalse: [aWriteStream nextPut: aReadStream next]].
	aCollection
		keysDo:
			[:each | 
			fileName := each.
			gifData := aCollection at: fileName.
			readStream := ReadStream on: gifData.
			writeStream := (FileStream fileNamed: self directoryNameForImages , fileName) binary.
			Cursor write
					showWhile: 
						[writeBlock value: readStream value: writeStream].
			writeStream close.].
	^self! !

!Encyclopedia methodsFor: 'generation' stamp: 'nishis 6/11/1998 22:39'!
generateHtmlForClass: aClass 
	| fileName aStream |
	fileName := self directoryNameForHtmls , (self htmlFileNameFor: aClass name).
	aStream := FileStream fileNamed: fileName.
	Cursor write
			showWhile: 
				[self headerHtmlForClass: aClass on: aStream.
				self definitionHtmlForClass: aClass on: aStream.
				self variablesHtmlForClass: aClass on: aStream.
				self methodsHtmlForClass: aClass on: aStream.
				self footerHtmlForClass: aClass on: aStream].
	aStream close.
	^self! !

!Encyclopedia methodsFor: 'generation' stamp: 'nishis 6/11/1998 22:51'!
generateIndex
	"Encyclopedia new generateIndex."

	| aDictionary directoryName aStream sortedCollection aCollection flag line tokens kind char value it |
	aDictionary := Dictionary new.
	directoryName := self directoryNameForHtmls.
	self htmlFileNames
		do: 
			[:each | 
			aStream := FileStream oldFileNamed: (directoryName , each).
			Cursor read
				showWhile: 
					[flag := false.
					[aStream atEnd not and: [flag = false]]
						whileTrue: 
							[line := self getLine: aStream.
							tokens := self separate: line dividers: self separators.
							(tokens size >= 4 and: ['A' = (tokens at: 1) and: ['NAME' = (tokens at: 2)]])
								ifTrue: 
									[kind := tokens at: 3.
									kind = 'Class'
										ifTrue: 
											[it := tokens at: 4.
											char := it first asUppercase.
											value := aDictionary at: char ifAbsent: [SortedCollection new].
											value add: it -> each.
											aDictionary at: char put: value.
											Transcript cr; show: it , '(' , each , ')'.
											flag := true]]]].
				aStream close].
	sortedCollection := (self associations: aDictionary) asSortedCollection.
	aCollection := OrderedCollection new: sortedCollection size.
	sortedCollection do: [:assoc | assoc key isLetter ifTrue: [aCollection add: assoc]].
	sortedCollection do: [:assoc | assoc key isLetter ifFalse: [aCollection add: assoc]].
	aStream := FileStream fileNamed: (self directoryNameForEncyclopedia , 'index' , self htmlFileExtension).
	Cursor write showWhile: [self htmlForIndex: aCollection on: aStream].
	aStream close! !

!Encyclopedia methodsFor: 'generation' stamp: 'nishis 6/11/1998 22:40'!
generateXrefs
	"Encyclopedia new generateXrefs."
	"This is a first part of 'generateXrefs (2 parts)."
	"Why I must divide this, see the last of source."

	| aDictionary directoryName aStream kind key char dictionary value line tokens |
	aDictionary := Dictionary new.
	directoryName := self directoryNameForHtmls.
	self htmlFileNames
		do: 
			[:each | 
			Transcript cr; show: each.
			aStream := FileStream oldFileNamed: (directoryName , each).
			Cursor read showWhile: [[aStream atEnd not]
					whileTrue: 
						[line := self getLine: aStream.
						tokens := self separate: line dividers: self separators.
						(tokens size >= 4 and: ['A' = (tokens at: 1) and: ['NAME' = (tokens at: 2)]])
							ifTrue: 
								[kind := tokens at: 3.
								(((((((kind = 'Class' or: [kind = 'Category'])
									or: [kind = 'InstanceVariable'])
									or: [kind = 'ClassInstanceVariable'])
									or: [kind = 'ClassVariable'])
									or: [kind = 'PoolVariable'])
									or: [kind = 'InstanceMethod'])
									or: [kind = 'ClassMethod'])
									ifTrue: 
										[kind := kind asSymbol.
										key := tokens at: 4.
										char := key first asUppercase.
										dictionary := aDictionary at: char ifAbsent: [Dictionary new].
										value := dictionary at: key ifAbsent: [SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key]].
										value add: kind -> each.
										dictionary at: key put: value.
										aDictionary at: char put: dictionary]]]].
			aStream close].
"
The Walkback says:
	<<Cannot compile - stack including temps is too deep>>
	CompileMethod(Object)>>error:
	CompileMethod>>needsFrameSize:
	MethodNode>>generate:
	Encyclopedia class(ClassDescription)>>compile:notifying:trailer:ifFail:elseSetSalectorAndNode:
	Encyclopedia class(ClassDescription)>>compile:classified:withStamp:notifying:

	So I divide this method into 2.
	Original source code is stored at <<generateXrefsInOne>>
"
	self generateXrefsIntoFileForm: (self associations: aDictionary) asSortedCollection.
	^self! !

!Encyclopedia methodsFor: 'generation' stamp: 'nishis 6/28/1998 05:28'!
generateXrefsInOne
	"this method should be never called."
	"Encyclopedia new generateXrefs."

	| aDictionary directoryName aStream sortedCollection fileName aCollection file associations kind key char dictionary value line tokens |
	true ifTrue: [^ self error: 'generateXrefsInOne: should be never called.'].
	aDictionary := Dictionary new.
	directoryName := self directoryNameForHtmls.
	self htmlFileNames
		do: 
			[:each | 
			Transcript cr; show: each.
			aStream := FileStream oldFileNamed: (directoryName , each).
			Cursor read showWhile: [[aStream atEnd not]
					whileTrue: 
						[line := self getLine: aStream.
						tokens := self separate: line dividers: self separators.
						(tokens size >= 4 and: ['A' = (tokens at: 1) and: ['NAME' = (tokens at: 2)]])
							ifTrue: 
								[kind := tokens at: 3.
								(((((((kind = 'Class' or: [kind = 'Category'])
									or: [kind = 'InstanceVariable'])
									or: [kind = 'ClassInstanceVariable'])
									or: [kind = 'ClassVariable'])
									or: [kind = 'PoolVariable'])
									or: [kind = 'InstanceMethod'])
									or: [kind = 'ClassMethod'])
									ifTrue: 
										[kind := kind asSymbol.
										key := tokens at: 4.
										char := key first asUppercase.
										dictionary := aDictionary at: char ifAbsent: [Dictionary new].
										value := dictionary at: key ifAbsent: [SortedCollection sortBlock: [:a1 :a2 | a1 key < a2 key]].
										value add: kind -> each.
										dictionary at: key put: value.
										aDictionary at: char put: dictionary]]]]
			aStream close].
	sortedCollection := (self associations: aDictionary) asSortedCollection.
	aDictionary := Dictionary new.
	sortedCollection do: [:assoc | assoc key isLetter
			ifTrue: 
				[file := 'xrefs' , (String with: assoc key) , self htmlFileExtension.
				associations := aDictionary at: file ifAbsent: [OrderedCollection new].
				associations add: assoc.
				aDictionary at: file put: associations]].
	sortedCollection do: [:assoc | assoc key isLetter
			ifFalse: 
				[file := 'xrefs' , self htmlFileExtension.
				associations := aDictionary at: file ifAbsent: [OrderedCollection new].
				associations add: assoc.
				aDictionary at: file put: associations]].
	sortedCollection := (self associations: aDictionary) asSortedCollection.
	sortedCollection
		do: 
			[:assoc | 
			fileName := assoc key.
			aCollection := assoc value.
			Transcript cr; show: fileName.
			aStream := FileStream fileNamed: (self directoryNameForEncyclopedia , fileName) .
			Cursor write showWhile: [self
					htmlForXrefs: aCollection
					all: sortedCollection
					on: aStream].
			aStream close].
	^self! !

!Encyclopedia methodsFor: 'generation' stamp: 'nishis 6/11/1998 22:40'!
generateXrefsIntoFileForm: aSortedCollection
	"Encyclopedia new generateXrefs."
	"This is a second part of 'generateXrefs' (and last)."

	| aDictionary aStream sortedCollection fileName aCollection file associations |
	sortedCollection := aSortedCollection.
	aDictionary := Dictionary new.
	sortedCollection do: [:assoc | assoc key isLetter
			ifTrue: 
				[file := 'xrefs' , (String with: assoc key) , self htmlFileExtension.
				associations := aDictionary at: file ifAbsent: [OrderedCollection new].
				associations add: assoc.
				aDictionary at: file put: associations]].
	sortedCollection do: [:assoc | assoc key isLetter
			ifFalse: 
				[file := 'xrefs' , self htmlFileExtension.
				associations := aDictionary at: file ifAbsent: [OrderedCollection new].
				associations add: assoc.
				aDictionary at: file put: associations]].
	sortedCollection := (self associations: aDictionary) asSortedCollection.
	sortedCollection
		do: 
			[:assoc | 
			fileName := assoc key.
			aCollection := assoc value.
			Transcript cr; show: fileName.
			aStream := FileStream fileNamed: (self directoryNameForEncyclopedia , fileName) .
			Cursor write showWhile: [self
					htmlForXrefs: aCollection
					all: sortedCollection
					on: aStream].
			aStream close].
	^self! !


!Encyclopedia methodsFor: 'upgrading'!
classNameFromChunk: aChunk 
	| className aStream line tokens |
	className := nil.
	(aChunk isNil or: [aChunk isEmpty])
		ifTrue: [^className].
	aStream := ReadStream on: aChunk asString.
	[aStream atEnd]
		whileFalse: 
			[line := self getLine: aStream.
			tokens := self separate: line dividers: self separators.
			((tokens size >= 4 and: ['A' = (tokens at: 1) and: ['NAME' = (tokens at: 2)]])
				and: ['Class' = (tokens at: 3)])
				ifTrue: [className := tokens at: 4]].
	^className! !

!Encyclopedia methodsFor: 'upgrading'!
dictionaryFromChunk: aChunk tag: tagString 
	| aDictionary chunkStream aStream line tokens tag |
	aDictionary := Dictionary new.
	(aChunk isNil or: [aChunk isEmpty])
		ifTrue: [^aDictionary].
	chunkStream := nil.
	aStream := ReadStream on: aChunk asString.
	[aStream atEnd]
		whileFalse: 
			[line := self getLine: aStream.
			tokens := self separate: line dividers: self separatorsForChunks.
			(((tokens size = 4 and: ['<!!--' = (tokens at: 1) and: ['-->' = (tokens at: 4)]])
				and: ['{' = (tokens at: 3)])
				and: [tagString ~= (tokens at: 2)])
				ifTrue: 
					[tag := tokens at: 2.
					chunkStream := WriteStream on: String new].
			(((tokens size = 4 and: ['<!!--' = (tokens at: 1) and: ['-->' = (tokens at: 4)]])
				and: ['}' = (tokens at: 2)])
				and: [tag = (tokens at: 3)])
				ifTrue: 
					[chunkStream nextPutAll: line.
					aDictionary at: tag put: chunkStream contents.
					chunkStream := nil].
			chunkStream notNil ifTrue: [chunkStream nextPutAll: line]].
	^aDictionary! !

!Encyclopedia methodsFor: 'upgrading'!
upgrade
	| aCollection |
	Cursor wait showWhile: [aCollection := self classCollection asSortedCollection: [:c1 :c2 | c1 name < c2 name]].
	aCollection
		do: 
			[:each | 
			Transcript cr; show: each name asString.
			self upgradeHtmlForClass: each].
	self generateGifs.
	self generateIndex.
	self generateXrefs.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeCategoryHtmlForClass: aClass chunk: chunkTable on: aStream 
	self categoryHtmlForClass: aClass on: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeClassCommentHtmlForClass: aClass chunk: chunkTable on: aStream 
	| aChunk |
	aChunk := chunkTable at: '(comment)'.
	aStream nextPutAll: aChunk.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeClassNameHtmlForClass: aClass chunk: chunkTable on: aStream 
	self classNameHtmlForClass: aClass on: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeClassVariablesHtmlForClass: aClass chunk: chunkTable on: aStream 
	| aDictionary |
	aDictionary := self dictionaryFromChunk: (chunkTable at: '(class_variables)')
				tag: '(class_variables)'.
	self classVariablesHtmlForClass: aClass headerOn: aStream.
	aClass classVarNames asSortedCollection do: [:aSymbol | (aDictionary includesKey: aSymbol asString)
			ifTrue: [aStream nextPutAll: (aDictionary at: aSymbol asString)]
			ifFalse: [self
					classVariablesHtmlForClass: aClass
					variable: aSymbol
					on: aStream]].
	self classVariablesHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeFooterHtmlForClass: aClass chunk: chunkTable on: aStream 
	self footerHtmlForClass: aClass on: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeHeaderHtmlForClass: aClass chunk: chunkTable on: aStream 
	self headerHtmlForClass: aClass on: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading' stamp: 'nishis 6/11/1998 22:50'!
upgradeHtmlForClass: aClass 
	| fileName chunkTable aStream chunkStream className line tokens tag |
	fileName := self directoryNameForHtmls , (self htmlFileNameFor: aClass name).
	(FileDirectory default fileExists: fileName) 
		ifFalse: 
			[^self generateHtmlForClass: aClass].
	chunkTable := Dictionary new.
	chunkTable add: '(class_name)' -> nil.
	chunkTable add: '(comment)' -> nil.
	chunkTable add: '(category)' -> nil.
	chunkTable add: '(inheritance)' -> nil.
	chunkTable add: '(instance_variables)' -> nil.
	chunkTable add: '(class_instance_variables)' -> nil.
	chunkTable add: '(class_variables)' -> nil.
	chunkTable add: '(pool_variables)' -> nil.
	chunkTable add: '(instance_methods)' -> nil.
	chunkTable add: '(class_methods)' -> nil.
	aStream := FileStream oldFileNamed: fileName.
	chunkStream := nil.
	Cursor read showWhile: [[aStream atEnd not]
			whileTrue: 
				[line := self getLine: aStream.
				tokens := self separate: line dividers: self separatorsForChunks.
				(((tokens size = 4 and: ['<!!--' = (tokens at: 1) and: ['-->' = (tokens at: 4)]])
					and: ['{' = (tokens at: 3)])
					and: [chunkTable includesKey: (tokens at: 2)])
					ifTrue: 
						[tag := tokens at: 2.
						chunkStream := WriteStream on: String new].
				(((tokens size = 4 and: ['<!!--' = (tokens at: 1) and: ['-->' = (tokens at: 4)]])
					and: ['}' = (tokens at: 2)])
					and: [tag = (tokens at: 3)])
					ifTrue: 
						[chunkStream nextPutAll: line.
						chunkTable at: tag put: chunkStream contents.
						chunkStream := nil].
				chunkStream notNil ifTrue: [chunkStream nextPutAll: line]]].
	aStream close.
	className := self classNameFromChunk: (chunkTable at: '(class_name)').
	className notNil
		ifTrue: 
			[chunkTable at: '(class_name)' put: className.
			Cursor write showWhile: [FileDirectory default copyFileNamed: fileName toFileNamed: (fileName , '.bak')].
			aStream := FileStream fileNamed: fileName" asFilename writeStream".
			Cursor write showWhile: [self
					upgradeHtmlForClass: aClass
					chunks: chunkTable
					on: aStream].
			aStream close].
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeHtmlForClass: aClass chunks: chunkTable on: aStream 
	self
		upgradeHeaderHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeClassNameHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeClassCommentHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeCategoryHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeInheritanceHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeInstanceVariablesHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeInstanceVariablesHtmlForClass: aClass class
		chunk: chunkTable
		on: aStream.
	self
		upgradeClassVariablesHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradePoolVariablesHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeInstanceMethodsHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	self
		upgradeInstanceMethodsHtmlForClass: aClass class
		chunk: chunkTable
		on: aStream.
	self
		upgradeFooterHtmlForClass: aClass
		chunk: chunkTable
		on: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeInheritanceHtmlForClass: aClass chunk: chunkTable on: aStream 
	self inheritanceHtmlForClass: aClass on: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeInstanceMethodsHtmlForClass: aClass chunk: chunkTable on: aStream 
	| aDictionary |
	aClass isMeta
		ifTrue: [aDictionary := self dictionaryFromChunk: (chunkTable at: '(class_methods)')
						tag: '(class_methods)']
		ifFalse: [aDictionary := self dictionaryFromChunk: (chunkTable at: '(instance_methods)')
						tag: '(instance_methods)'].
	self instanceMethodsHtmlForClass: aClass headerOn: aStream.
	aClass selectors asSortedCollection do: [:aSymbol | (aDictionary includesKey: aSymbol asString)
			ifTrue: [aStream nextPutAll: (aDictionary at: aSymbol asString)]
			ifFalse: [self
					methodHtmlForClass: aClass
					selector: aSymbol
					on: aStream]].
	self instanceMethodsHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading'!
upgradeInstanceVariablesHtmlForClass: aClass chunk: chunkTable on: aStream 
	| aDictionary |
	aClass isMeta
		ifTrue: [aDictionary := self dictionaryFromChunk: (chunkTable at: '(class_instance_variables)')
						tag: '(class_instance_variables)']
		ifFalse: [aDictionary := self dictionaryFromChunk: (chunkTable at: '(instance_variables)')
						tag: '(instance_variables)'].
	self instanceVariablesHtmlForClass: aClass headerOn: aStream.
	aClass instVarNames asSortedCollection do: [:aString | (aDictionary includesKey: aString asString)
			ifTrue: [aStream nextPutAll: (aDictionary at: aString asString)]
			ifFalse: [self
					instanceVariablesHtmlForClass: aClass
					variable: aString
					on: aStream]].
	self instanceVariablesHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'upgrading' stamp: 'nishis 4/4/98 18:25'!
upgradePoolVariablesHtmlForClass: aClass chunk: chunkTable on: aStream 
	| aDictionary key value |
	aDictionary := self dictionaryFromChunk: (chunkTable at: '(pool_variables)')
				tag: '(pool_variables)'.
	self poolVariablesHtmlForClass: aClass headerOn: aStream.
	aClass sharedPools do: [:each | (self associations: each) asSortedCollection
			do: 
				[:assoc | 
				key := assoc key.
				value := assoc value.
				(aDictionary includesKey: key asString)
					ifTrue: [aStream nextPutAll: (aDictionary at: key asString)]
					ifFalse: [self
							poolVariablesHtmlForClass: aClass
							key: key
							value: value
							on: aStream]]].
	self poolVariablesHtmlForClass: aClass footerOn: aStream.
	^self! !


!Encyclopedia methodsFor: 'html header and footer'!
footerHtmlForClass: aClass on: aStream 
	aStream nextPutAll: '<P>'.
	aStream cr.
	self htmlForLineOn: aStream.
	self htmlForIndexButton: aClass on: aStream.
	self htmlForXrefsButton: aClass on: aStream.
	self htmlForEndingOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html header and footer'!
headerHtmlForClass: aClass on: aStream 
	self htmlForTitle: aClass name on: aStream.
	self htmlForIndexButton: aClass on: aStream.
	self htmlForXrefsButton: aClass on: aStream.
	self htmlForDateOn: aStream.
	self htmlForLineOn: aStream.
	^self! !


!Encyclopedia methodsFor: 'html definition'!
categoryHtmlForClass: aClass on: aStream 
	aStream nextPutAll: '<!!-- (category) { -->'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<A NAME="Category('.
	aStream nextPutAll: aClass category asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<I>category:</I>'.
	aStream cr.
	aStream nextPutAll: '<DL>'.
	aStream cr.
	aStream nextPutAll: '<DD><B>'.
	aStream cr.
	self htmlForString: aClass category on: aStream.
	aStream cr.
	aStream nextPutAll: '</B></DD>'.
	aStream cr.
	self htmlForXrefsAnchor: aClass category on: aStream.
	aStream nextPutAll: '</DL>'.
	aStream cr.
	aStream nextPutAll: '<!!-- } (category) -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html definition'!
classCommentHtmlForClass: aClass on: aStream 
	| comment |
	aStream nextPutAll: '<!!-- (comment) { -->'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<A NAME="Comment('.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	comment := aClass comment.
	(comment isNil or: [comment isEmpty])
		ifFalse: 
			[self htmlForString: comment on: aStream.
			aStream cr].
	aStream nextPutAll: '<!!-- } (comment) -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html definition'!
classNameHtmlForClass: aClass on: aStream 
	aStream nextPutAll: '<!!-- (class_name) { -->'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<A NAME="Class('.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<H2>'.
	self htmlForString: aClass name on: aStream.
	aStream nextPutAll: '</H2>'.
	aStream cr.
	aStream nextPutAll: '<!!-- } (class_name) -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html definition'!
definitionHtmlForClass: aClass on: aStream 
	self classNameHtmlForClass: aClass on: aStream.
	self classCommentHtmlForClass: aClass on: aStream.
	self categoryHtmlForClass: aClass on: aStream.
	self inheritanceHtmlForClass: aClass on: aStream.
	^self! !

!Encyclopedia methodsFor: 'html definition' stamp: 'nishis 4/2/98 11:44'!
hierarchyHtmlForClass: aClass on: aStream 
	| superclasses |
	superclasses := aClass allSuperclasses reversed.
	superclasses
		do: 
			[:each | 
			aStream nextPutAll: '<DL>'.
			aStream cr.
			self
				htmlForClassAnchor: each
				base: aClass
				on: aStream.
			aStream cr].
	self
		subclassesHtmlForClass: aClass
		base: aClass
		on: aStream.
	superclasses size
		timesRepeat: 
			[aStream nextPutAll: '</DL>'.
			aStream cr].
	^self! !

!Encyclopedia methodsFor: 'html definition'!
inheritanceHtmlForClass: aClass on: aStream 
	aStream nextPutAll: '<!!-- (inheritance) { -->'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<A NAME="Inheritance('.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<I>inheritance:</I>'.
	aStream cr.
	aStream nextPutAll: '<DL>'.
	aStream cr.
	self hierarchyHtmlForClass: aClass on: aStream.
	aStream nextPutAll: '</DL>'.
	aStream cr.
	aStream nextPutAll: '<!!-- } (inheritance) -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html definition' stamp: 'nishis 4/5/98 03:21'!
subclassesHtmlForClass: aClass base: baseClass on: aStream 
	| subclasses |
	aStream nextPutAll: '<DL>'.
	aStream cr.
	self
		htmlForClassAnchor: aClass
		base: baseClass
		on: aStream.
	aStream cr.
	subclasses := aClass subclasses.
	aClass == Class
		ifTrue: 
			[aStream cr; nextPutAll: '... all the Metaclasses ...'.
			subclasses := subclasses reject: [:sub | sub isMeta]].
	"Non so pi cosa son, cosa faccio - Cherubino"
	"(subclasses asSortedStrings: do: [:p :x :y | (p collate: x name to: y name)
			<= 0])"
	(subclasses asSortedCollection: [:x :y | x name <= y name])
		do: [:sub | self
				subclassesHtmlForClass: sub
				base: baseClass
				on: aStream].
	aStream nextPutAll: '</DL>'.
	aStream cr.
	^self! !


!Encyclopedia methodsFor: 'html variables'!
classVariablesHtmlForClass: aClass footerOn: aStream 
	aStream nextPutAll: '</UL>'.
	aStream cr.
	aStream nextPutAll: '<!!-- } (class_variables) -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
classVariablesHtmlForClass: aClass headerOn: aStream 
	aStream nextPutAll: '<!!-- (class_variables) { -->'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<A NAME="ClassVariables('.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<I>class variables:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
classVariablesHtmlForClass: aClass on: aStream 
	self classVariablesHtmlForClass: aClass headerOn: aStream.
	aClass classVarNames asSortedCollection do: [:aSymbol | self
			classVariablesHtmlForClass: aClass
			variable: aSymbol
			on: aStream].
	self classVariablesHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
classVariablesHtmlForClass: aClass variable: aSymbol on: aStream 
	| value |
	aStream nextPutAll: '<!!-- '.
	aStream nextPutAll: aSymbol asString.
	aStream nextPutAll: ' { -->'.
	aStream cr.
	aStream nextPutAll: '<A NAME="'.
	aStream nextPutAll: 'ClassVariable('.
	aStream nextPutAll: aSymbol asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<LI><B>'.
	self htmlForString: aSymbol on: aStream.
	aStream nextPutAll: '</B>'.
	value := aClass classPool at: aSymbol asSymbol.
	aStream space.
	aStream nextPutAll: '<I>'.
	value isLiteral
		ifTrue: [self htmlForString: value printString on: aStream]
		ifFalse: [self htmlForString: value class name asString on: aStream].
	aStream nextPutAll: '</I>'.
	aStream cr.
	self htmlForXrefsAnchor: aSymbol on: aStream.
	aStream nextPutAll: '<!!-- } '.
	aStream nextPutAll: aSymbol asString.
	aStream nextPutAll: ' -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
instanceVariablesHtmlForClass: aClass footerOn: aStream 
	aStream nextPutAll: '</UL>'.
	aStream cr.
	aClass isMeta
		ifTrue: [aStream nextPutAll: '<!!-- } (class_instance_variables) -->']
		ifFalse: [aStream nextPutAll: '<!!-- } (instance_variables) -->'].
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
instanceVariablesHtmlForClass: aClass headerOn: aStream 
	aClass isMeta
		ifTrue: [aStream nextPutAll: '<!!-- (class_instance_variables) { -->']
		ifFalse: [aStream nextPutAll: '<!!-- (instance_variables) { -->'].
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aClass isMeta
		ifTrue: 
			[aStream nextPutAll: '<A NAME="ClassInstanceVariables('.
			aStream nextPutAll: aClass soleInstance name asString]
		ifFalse: 
			[aStream nextPutAll: '<A NAME="InstanceVariables('.
			aStream nextPutAll: aClass name asString].
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aClass isMeta
		ifTrue: [aStream nextPutAll: '<I>class instance variables:</I>']
		ifFalse: [aStream nextPutAll: '<I>instance variables:</I>'].
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
instanceVariablesHtmlForClass: aClass on: aStream 
	self instanceVariablesHtmlForClass: aClass headerOn: aStream.
	aClass instVarNames asSortedCollection do: [:aString | self
			instanceVariablesHtmlForClass: aClass
			variable: aString
			on: aStream].
	self instanceVariablesHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
instanceVariablesHtmlForClass: aClass variable: aString on: aStream 
	| collection index |
	aStream nextPutAll: '<!!-- '.
	aStream nextPutAll: aString asString.
	aStream nextPutAll: ' { -->'.
	aStream cr.
	aStream nextPutAll: '<A NAME="'.
	aClass isMeta
		ifTrue: [aStream nextPutAll: 'ClassInstanceVariable(']
		ifFalse: [aStream nextPutAll: 'InstanceVariable('].
	aStream nextPutAll: aString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<LI><B>'.
	self htmlForString: aString on: aStream.
	aStream nextPutAll: '</B>'.
	collection := Set new.
	index := aClass allInstVarNames findFirst: [:each | each = aString].
	index > 0 ifTrue: [aClass allInstancesDo: [:each | collection add: (each instVarAt: index) class name]].
	collection isEmpty
		ifFalse: 
			[aStream space.
			aStream nextPutAll: '<I>'].
	collection := collection asSortedCollection.
	collection
		do: 
			[:each | 
			self htmlForString: each on: aStream.
			each = collection last ifFalse: [aStream nextPutAll: ' | ']].
	collection isEmpty ifFalse: [aStream nextPutAll: '</I>'].
	aStream cr.
	self htmlForXrefsAnchor: aString on: aStream.
	aStream nextPutAll: '<!!-- } '.
	aStream nextPutAll: aString asString.
	aStream nextPutAll: ' -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
poolVariablesHtmlForClass: aClass footerOn: aStream 
	aStream nextPutAll: '</UL>'.
	aStream cr.
	aStream nextPutAll: '<!!-- } (pool_variables) -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
poolVariablesHtmlForClass: aClass headerOn: aStream 
	aStream nextPutAll: '<!!-- (pool_variables) { -->'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<A NAME="PoolVariables('.
	aStream nextPutAll: aClass name asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<I>pool variables:</I>'.
	aStream cr.
	aStream nextPutAll: '<UL>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
poolVariablesHtmlForClass: aClass key: key value: value on: aStream 
	aStream nextPutAll: '<!!-- '.
	aStream nextPutAll: key asString.
	aStream nextPutAll: ' { -->'.
	aStream cr.
	aStream nextPutAll: '<A NAME="'.
	aStream nextPutAll: 'PoolVariable('.
	aStream nextPutAll: key asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aStream nextPutAll: '<LI><B>'.
	self htmlForString: key on: aStream.
	aStream nextPutAll: '</B>'.
	aStream space.
	aStream nextPutAll: '<I>'.
	value isLiteral
		ifTrue: [self htmlForString: value printString on: aStream]
		ifFalse: [self htmlForString: value class name on: aStream].
	aStream nextPutAll: '</I>'.
	aStream cr.
	self htmlForXrefsAnchor: key on: aStream.
	aStream nextPutAll: '<!!-- } '.
	aStream nextPutAll: key asString.
	aStream nextPutAll: ' -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html variables' stamp: 'nishis 4/3/98 03:53'!
poolVariablesHtmlForClass: aClass on: aStream 
	| key value |
	self poolVariablesHtmlForClass: aClass headerOn: aStream.
	aClass sharedPools do: [:each | (self associations: each) asSortedCollection
			do: 
				[:assoc | 
				key := assoc key.
				value := assoc value.
				self
					poolVariablesHtmlForClass: aClass
					key: key
					value: value
					on: aStream]].
	self poolVariablesHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html variables'!
variablesHtmlForClass: aClass on: aStream 
	self instanceVariablesHtmlForClass: aClass on: aStream.
	self instanceVariablesHtmlForClass: aClass class on: aStream.
	self classVariablesHtmlForClass: aClass on: aStream.
	self poolVariablesHtmlForClass: aClass on: aStream.
	^self! !


!Encyclopedia methodsFor: 'html methods'!
instanceMethodsHtmlForClass: aClass footerOn: aStream 
	aStream nextPutAll: '</OL>'.
	aStream cr.
	aClass isMeta
		ifTrue: [aStream nextPutAll: '<!!-- } (class_methods) -->']
		ifFalse: [aStream nextPutAll: '<!!-- } (instance_methods) -->'].
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html methods'!
instanceMethodsHtmlForClass: aClass headerOn: aStream 
	aClass isMeta
		ifTrue: [aStream nextPutAll: '<!!-- (class_methods) { -->']
		ifFalse: [aStream nextPutAll: '<!!-- (instance_methods) { -->'].
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aClass isMeta
		ifTrue: 
			[aStream nextPutAll: '<A NAME="ClassMethods('.
			aStream nextPutAll: aClass soleInstance name asString]
		ifFalse: 
			[aStream nextPutAll: '<A NAME="InstanceMethods('.
			aStream nextPutAll: aClass name asString].
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '</A>'.
	aStream cr.
	aClass isMeta
		ifTrue: [aStream nextPutAll: '<I>class methods:</I>']
		ifFalse: [aStream nextPutAll: '<I>instance methods:</I>'].
	aStream cr.
	aStream nextPutAll: '<OL>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html methods'!
instanceMethodsHtmlForClass: aClass on: aStream 
	self instanceMethodsHtmlForClass: aClass headerOn: aStream.
	aClass selectors asSortedCollection do: [:aSymbol | self
			methodHtmlForClass: aClass
			selector: aSymbol
			on: aStream].
	self instanceMethodsHtmlForClass: aClass footerOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html methods' stamp: 'nishis 4/11/98 01:14'!
methodHtmlForClass: aClass selector: aSymbol on: aStream
	"fixed by the Most Revd AOKI Atsushi, Fri, 10 Apr 1998 17:12:35 +0900"

	| source parser pattern collection string comments start |
	source := aClass sourceCodeAt: aSymbol.
	parser := aClass parserClass new.
	parser parseSelector: source.
	pattern := source copyFrom: 1 to: parser endOfLastToken.
	[pattern last isSeparator]
		whileTrue: [pattern := pattern copyFrom: 1 to: pattern size - 1].
	aStream nextPutAll: '<!!!!-- '.
	aStream nextPutAll: aSymbol asString.
	aStream nextPutAll: ' { -->'.
	aStream cr.
	aStream nextPutAll: '<A NAME="'.
	aClass isMeta
		ifTrue: [aStream nextPutAll: 'ClassMethod(']
		ifFalse: [aStream nextPutAll: 'InstanceMethod('].
	aStream nextPutAll: aSymbol asString.
	aStream nextPutAll: ')">'.
	aStream cr.
	aStream nextPutAll: '<LI>'.
	aSymbol numArgs = 0
		ifTrue:
			[aStream nextPutAll: '<B>'.
			self htmlForString: pattern on: aStream.
			aStream nextPutAll: '</B>']
		ifFalse:
			[collection := Scanner new scanTokens: pattern.
			1
				to: collection size
				by: 2
				do:
					[:index |
					"Why are you picked up, 'Doit'?"
					index > 1 ifTrue: [aStream space].
					aStream nextPutAll: '<B>'.
					self htmlForString: (collection at: index)
						on: aStream.
					aStream nextPutAll: '</B>'.
					aStream space.
					aStream nextPutAll: (collection at: index + 1 ifAbsent: [String with: Character space])]].
	string := (aClass organization categoryOfElement: aSymbol) asString.
	aStream nextPutAll: ' <I>[' , string , ']</I>'.
	aStream space.
	self htmlForXrefsAnchor: aSymbol on: aStream.
	aStream nextPutAll: '<BR>'.
	aStream cr.
	self sourceInclusion
		ifTrue:
			[start := parser endOfLastToken + 1.
			[start <= source size and: [(source at: start) ~= Character cr]]
				whileTrue: [start := start + 1].
			source := source copyFrom: start to: source size.
			aStream nextPutAll: '<PRE>'.
			self htmlForSource: source on: aStream.
			aStream nextPutAll: '</PRE>'.
			aStream cr]
		ifFalse:
			[comments := Parser new parseMethodComment: source setPattern: [:x | ].
			comments isEmpty
				ifFalse:
					[self htmlForString: comments first asString on: aStream.
					aStream cr]].
	aStream nextPutAll: '<!!!!-- } '.
	aStream nextPutAll: aSymbol asString.
	aStream nextPutAll: ' -->'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html methods'!
methodsHtmlForClass: aClass on: aStream 
	self instanceMethodsHtmlForClass: aClass on: aStream.
	self instanceMethodsHtmlForClass: aClass class on: aStream.
	^self! !


!Encyclopedia methodsFor: 'html index' stamp: 'nishis 4/2/98 11:42'!
htmlForIndex: charCollection character: aChar on: aStream 
	| sortedCollection aCollection |
	sortedCollection := charCollection asSortedCollection.
	aCollection := OrderedCollection new: charCollection size.
	sortedCollection do: [:each | each isLetter ifTrue: [aCollection add: each]].
	sortedCollection do: [:each | each isLetter ifFalse: [aCollection add: each]].
	aStream nextPutAll: '<FONT SIZE=-1>'.
	aStream cr.
	aCollection
		do: 
			[:each | 
			each = aChar
				ifTrue: 
					[aStream nextPutAll: '<FONT SIZE=+1><B>'.
					aStream nextPut: each.
					aStream nextPutAll: '</B></FONT>']
				ifFalse: 
					[aStream nextPutAll: '<A HREF="#'.
					aStream nextPut: each.
					aStream nextPutAll: '">'.
					aStream nextPut: each.
					aStream nextPutAll: '</A>'].
			aCollection last = each ifFalse: [aStream nextPutAll: ' | '].
			aStream cr].
	aStream nextPutAll: '</FONT>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html index'!
htmlForIndex: aCollection on: aStream 
	| charCollection aChar assocCollection className fileName |
	charCollection := OrderedCollection new.
	aCollection
		collect: 
			[:pair | 
			aChar := pair key.
			charCollection add: aChar].
	self htmlForTitle: 'Class Library Index' on: aStream.
	self htmlForXrefsButton: nil on: aStream.
	self htmlForDateOn: aStream.
	self htmlForLineOn: aStream.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<H2>Class Library Index</H2>'.
	aStream cr.
	aCollection
		do: 
			[:pair | 
			aChar := pair key.
			assocCollection := pair value.
			aStream nextPutAll: '<P>'.
			aStream cr.
			aStream nextPutAll: '<A NAME="'.
			aStream nextPut: aChar.
			aStream nextPutAll: '">'.
			aStream cr.
			self
				htmlForIndex: charCollection
				character: aChar
				on: aStream.
			aStream nextPutAll: '<P>'.
			aStream cr.
			aStream nextPutAll: '<OL>'.
			aStream cr.
			assocCollection
				do: 
					[:each | 
					className := each key.
					fileName := each value.
					aStream nextPutAll: '<A NAME="'.
					aStream nextPutAll: className asString.
					aStream nextPutAll: '">'.
					aStream cr.
					aStream nextPutAll: '<LI>'.
					aStream nextPutAll: '<A HREF="'.
					aStream nextPutAll: self baseNameForHtmls.
					aStream nextPutAll: '/'.
					aStream nextPutAll: fileName.
					aStream nextPutAll: '">'.
					self htmlForString: className on: aStream.
					aStream nextPutAll: '</A>'.
					aStream cr].
			aStream nextPutAll: '</OL>'.
			aStream cr].
	aStream nextPutAll: '<P>'.
	aStream cr.
	self htmlForLineOn: aStream.
	self htmlForXrefsButton: nil on: aStream.
	self htmlForEndingOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html index'!
htmlForIndexButton: aClass on: aStream 
	aClass isNil
		ifTrue: 
			[aStream nextPutAll: '<A HREF="index'.
			aStream nextPutAll: self htmlFileExtension.
			aStream nextPutAll: '"><IMG SRC="'.
			aStream nextPutAll: self baseNameForImages.
			aStream nextPutAll: '/'.
			aStream nextPutAll: self fileNameIndexGif.
			aStream nextPutAll: '" ALT="index" ALIGN="top"></A>'.
			aStream cr]
		ifFalse: 
			[aStream nextPutAll: '<A HREF="../index'.
			aStream nextPutAll: self htmlFileExtension.
			aStream nextPutAll: '#'.
			aStream nextPutAll: aClass name asString.
			aStream nextPutAll: '"><IMG SRC="../'.
			aStream nextPutAll: self baseNameForImages.
			aStream nextPutAll: '/'.
			aStream nextPutAll: self fileNameIndexGif.
			aStream nextPutAll: '" ALT="index" ALIGN="top"></A>'.
			aStream cr].
	^self! !


!Encyclopedia methodsFor: 'html xrefs' stamp: 'nishis 4/3/98 03:54'!
htmlForXrefs: aCollection all: sortedCollection on: aStream 
	| charCollection assocCollection aChar aDictionary keyword kind file string |
	charCollection := OrderedCollection new.
	sortedCollection
		do: 
			[:pair | 
			assocCollection := pair value.
			assocCollection
				do: 
					[:assoc | 
					aChar := assoc key.
					charCollection add: aChar]].
	self htmlForTitle: 'Cross References' on: aStream.
	self htmlForIndexButton: nil on: aStream.
	self htmlForDateOn: aStream.
	self htmlForLineOn: aStream.
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<H2>Cross References</H2>'.
	aStream cr.
	aCollection
		do: 
			[:pair | 
			aChar := pair key.
			aDictionary := pair value.
			aStream nextPutAll: '<P>'.
			aStream cr.
			aStream nextPutAll: '<A NAME="'.
			aStream nextPut: aChar.
			aStream nextPutAll: '">'.
			aStream cr.
			self
				htmlForXrefs: charCollection
				character: aChar
				on: aStream.
			aStream nextPutAll: '<P>'.
			aStream cr.
			aStream nextPutAll: '<OL>'.
			aStream cr.
			(self associations: aDictionary) asSortedCollection
				do: 
					[:assoc | 
					keyword := assoc key.
					aStream nextPutAll: '<A NAME="'.
					aStream nextPutAll: keyword.
					aStream nextPutAll: '">'.
					aStream cr.
					aStream nextPutAll: '<LI>'.
					aStream nextPutAll: keyword.
					aStream cr.
					assoc value
						do: 
							[:each | 
							kind := each key.
							file := each value.
							aStream nextPutAll: '<A HREF="'.
							aStream nextPutAll: self baseNameForHtmls.
							aStream nextPutAll: '/'.
							aStream nextPutAll: file.
							aStream nextPutAll: '#'.
							string := kind asString , '(' , keyword , ')'.
							aStream nextPutAll: string.
							aStream nextPutAll: '">'.
							aStream nextPutAll: (self htmlForDot: kind).
							aStream nextPutAll: '</A>'.
							aStream cr]].
			aStream nextPutAll: '</OL>'.
			aStream cr].
	aStream nextPutAll: '<P>'.
	aStream cr.
	aStream nextPutAll: '<HR>'.
	aStream cr.
	aStream nextPutAll: '<DL>'.
	aStream cr.
	aStream nextPutAll: 'Notes:'.
	aStream cr.
	aStream nextPutAll: '<DL><TT>'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #Class) , ' class'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #Category) , ' category'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #InstanceVariable) , ' instance variable'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #ClassInstanceVariable) , ' class instance variable'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #ClassVariable) , ' class variable'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #PoolVariable) , ' pool variable'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #InstanceMethod) , ' instance method'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: #ClassMethod) , ' class method'.
	aStream cr.
	aStream nextPutAll: '<DT>' , (self htmlForDot: nil) , ' unknown'.
	aStream cr.
	aStream nextPutAll: '</TT></DL>'.
	aStream cr.
	aStream nextPutAll: '</DL>'.
	aStream cr.
	aStream nextPutAll: '<P>'.
	aStream cr.
	self htmlForLineOn: aStream.
	self htmlForIndexButton: nil on: aStream.
	self htmlForEndingOn: aStream.
	^self! !

!Encyclopedia methodsFor: 'html xrefs' stamp: 'nishis 4/2/98 11:42'!
htmlForXrefs: charCollection character: aChar on: aStream 
	| sortedCollection aCollection |
	sortedCollection := charCollection asSortedCollection.
	aCollection := OrderedCollection new: charCollection size.
	sortedCollection do: [:each | each isLetter ifTrue: [aCollection add: each]].
	sortedCollection do: [:each | each isLetter ifFalse: [aCollection add: each]].
	aStream nextPutAll: '<FONT SIZE=-1>'.
	aStream cr.
	aCollection
		do: 
			[:each | 
			each = aChar
				ifTrue: 
					[aStream nextPutAll: '<FONT SIZE=+1><B>'.
					aStream nextPut: each.
					aStream nextPutAll: '</B></FONT>']
				ifFalse: 
					[aStream nextPutAll: '<A HREF="xrefs'.
					each isLetter ifTrue: [aStream nextPut: each].
					aStream nextPutAll: self htmlFileExtension.
					aStream nextPutAll: '">'.
					aStream nextPut: each.
					aStream nextPutAll: '</A>'].
			aCollection last = each ifFalse: [aStream nextPutAll: ' | '].
			aStream cr].
	aStream nextPutAll: '</FONT>'.
	aStream cr! !

!Encyclopedia methodsFor: 'html xrefs' stamp: 'nishis 4/2/98 11:42'!
htmlForXrefsAnchor: aString on: aStream 
	aStream nextPutAll: '<A HREF="../xrefs'.
	aString asString first isLetter ifTrue: [aStream nextPut: aString asString first asUppercase].
	aStream nextPutAll: self htmlFileExtension.
	aStream nextPutAll: '#'.
	aStream nextPutAll: aString asString.
	aStream nextPutAll: '"><IMG SRC="../'.
	aStream nextPutAll: self baseNameForImages.
	aStream nextPutAll: '/'.
	aStream nextPutAll: self fileNameXrefsGif.
	aStream nextPutAll: '" ALT="xrefs" ALIGN="top"></A>'.
	aStream cr! !

!Encyclopedia methodsFor: 'html xrefs' stamp: 'nishis 4/2/98 11:41'!
htmlForXrefsButton: aClass on: aStream 
	aClass isNil
		ifTrue: 
			[aStream nextPutAll: '<A HREF="xrefs'.
			aStream nextPutAll: self htmlFileExtension.
			aStream nextPutAll: '"><IMG SRC="'.
			aStream nextPutAll: self baseNameForImages.
			aStream nextPutAll: '/'.
			aStream nextPutAll: self fileNameXrefsGif.
			aStream nextPutAll: '" ALT="xrefs" ALIGN="top"></A>'.
			aStream cr]
		ifFalse: 
			[aStream nextPutAll: '<A HREF="../xrefs'.
			aClass name first isLetter ifTrue: [aStream nextPut: aClass name first asUppercase].
			aStream nextPutAll: self htmlFileExtension.
			aStream nextPutAll: '#'.
			aStream nextPutAll: aClass name asString.
			aStream nextPutAll: '"><IMG SRC="../'.
			aStream nextPutAll: self baseNameForImages.
			aStream nextPutAll: '/'.
			aStream nextPutAll: self fileNameXrefsGif.
			aStream nextPutAll: '" ALT="xrefs" ALIGN="top"></A>'.
			aStream cr].
	^self! !


!Encyclopedia methodsFor: 'html support'!
htmlForClassAnchor: aClass base: baseClass on: aStream 
	| string |
	aClass = baseClass
		ifTrue: 
			[aStream nextPutAll: '<B>'.
			self htmlForString: aClass name on: aStream.
			aStream nextPutAll: '</B>']
		ifFalse: [(self classCollection includes: aClass)
				ifTrue: 
					[string := self htmlFileNameFor: aClass name.
					aStream nextPutAll: '<A HREF="'.
					aStream nextPutAll: string.
					aStream nextPutAll: '">'.
					self htmlForString: aClass name on: aStream.
					aStream nextPutAll: '</A>']
				ifFalse: [self htmlForString: aClass name on: aStream]].
	^self! !

!Encyclopedia methodsFor: 'html support'!
htmlForDateOn: aStream 
	aStream nextPutAll: self dateAndTimeString.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html support'!
htmlForDot: kind 
	| string1 string2 string3 |
	string1 := '<IMG SRC="' , self baseNameForImages , '/'.
	string2 := '" ALT="'.
	string3 := '" ALIGN="bottom">'.
	kind = #Class ifTrue: [^string1 , self fileNameDot1Gif , string2 , '@' , string3].
	kind = #Category ifTrue: [^string1 , self fileNameDot2Gif , string2 , '#' , string3].
	kind = #InstanceVariable ifTrue: [^string1 , self fileNameDot3Gif , string2 , '+' , string3].
	kind = #ClassInstanceVariable ifTrue: [^string1 , self fileNameDot4Gif , string2 , '-' , string3].
	kind = #ClassVariable ifTrue: [^string1 , self fileNameDot5Gif , string2 , '=' , string3].
	kind = #PoolVariable ifTrue: [^string1 , self fileNameDot6Gif , string2 , '%' , string3].
	kind = #InstanceMethod ifTrue: [^string1 , self fileNameDot7Gif , string2 , '*' , string3].
	kind = #ClassMethod ifTrue: [^string1 , self fileNameDot8Gif , string2 , '$' , string3].
	^string1 , self fileNameDot9Gif , string2 , '$' , string3! !

!Encyclopedia methodsFor: 'html support'!
htmlForEndingOn: aStream 
	aStream nextPutAll: '<!!-- This Document was generated by ' , self class name , '. -->'.
	aStream cr.
	aStream nextPutAll: '<!!-- ' , self class name , ' was developed by AOKI Atsushi. -->'.
	aStream cr.
	aStream nextPutAll: '</BODY>'.
	aStream cr.
	aStream nextPutAll: '</HTML>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html support'!
htmlForLineOn: aStream 
	aStream nextPutAll: '<HR>'.
	aStream cr.
	^self! !

!Encyclopedia methodsFor: 'html support' stamp: 'nishis 4/2/98 23:34'!
htmlForSource: aString on: aStream 
	| readStream aCharacter |
	readStream := ReadStream on: aString asString.
	[readStream atEnd]
		whileFalse: 
			[aCharacter := readStream next.
			aCharacter = Character linefeed
				ifTrue: [aCharacter := Character cr]
				ifFalse: [aCharacter = Character cr ifTrue: [readStream peek = Character linefeed ifTrue: [readStream next]]].
			aCharacter notNil ifTrue: [aCharacter = Character cr
					ifTrue: [aStream nextPut: aCharacter]
					ifFalse: [aCharacter = $<
							ifTrue: [aStream nextPutAll: '&lt;']
							ifFalse: [aCharacter = $>
									ifTrue: [aStream nextPutAll: '&gt;']
									ifFalse: ["Object errorSignal handle: [:exception | aStream nextPut: Character space]
											do: [aStream nextPut: aCharacter]"  aStream nextPut: aCharacter]]]]].
	^self! !

!Encyclopedia methodsFor: 'html support' stamp: 'nishis 4/2/98 23:29'!
htmlForString: aString on: aStream 
	| readStream aCharacter |
	readStream := ReadStream on: aString asString.
	[readStream atEnd]
		whileFalse: 
			[aCharacter := readStream next.
			aCharacter = Character linefeed
				ifTrue: [aCharacter := Character cr]
				ifFalse: [aCharacter = Character cr ifTrue: [readStream peek = Character linefeed ifTrue: [readStream next]]].
			aCharacter notNil ifTrue: [aCharacter = Character cr
					ifTrue: 
						[aStream nextPutAll: '<BR>'.
						aStream nextPut: aCharacter]
					ifFalse: [aCharacter = $<
							ifTrue: [aStream nextPutAll: '&lt;']
							ifFalse: [aCharacter = $>
									ifTrue: [aStream nextPutAll: '&gt;']
									ifFalse: ["Object errorSignal handle: [:exception | aStream nextPut: Character space]
											do: [aStream nextPut: aCharacter]"  aStream nextPut: aCharacter]]]]].
	^self! !

!Encyclopedia methodsFor: 'html support'!
htmlForTitle: aTitle on: aStream 
	aStream nextPutAll: '<HTML>'.
	aStream cr.
	aStream nextPutAll: '<HEAD>'.
	aStream cr.
	aStream nextPutAll: '<TITLE>'.
	self htmlForString: aTitle asString on: aStream.
	aStream nextPutAll: '</TITLE>'.
	aStream cr.
	aStream nextPutAll: '</HEAD>'.
	aStream cr.
	aStream nextPutAll: '<BODY BGCOLOR="#FFFFFF">'.
	aStream cr.
	^self! !


!Encyclopedia methodsFor: 'string and character'!
dateAndTimeString
	"Encyclopedia new dateAndTimeString."

	| stream |
	stream := WriteStream on: String new.
	stream nextPutAll: self dateString.
	stream space.
	stream nextPutAll: self timeString.
	^stream contents! !

!Encyclopedia methodsFor: 'string and character'!
dateString
	"Encyclopedia new dateString."

	| stream string |
	stream := WriteStream on: String new.
	string := Date today year printString.
	stream nextPutAll: string.
	stream nextPutAll: '/'.
	string := Date today monthIndex printString.
	2 - string size timesRepeat: [stream nextPutAll: '0'].
	stream nextPutAll: string.
	stream nextPutAll: '/'.
	string := Date today dayOfMonth printString.
	2 - string size timesRepeat: [stream nextPutAll: '0'].
	stream nextPutAll: string.
	^stream contents! !

!Encyclopedia methodsFor: 'string and character' stamp: 'nishis 4/2/98 11:13'!
getChar: aStream 
	| char |
	aStream atEnd
		ifTrue: [char := nil]
		ifFalse: 
			[char := aStream next.
			char = Character linefeed
				ifTrue: [char := Character cr]
				ifFalse: [char = Character cr ifTrue: [aStream peek = Character linefeed ifTrue: [aStream next]]]].
	^char! !

!Encyclopedia methodsFor: 'string and character'!
getLine: aStream 
	| stream char |
	stream := WriteStream on: (String new: 128).
	char := self getChar: aStream.
	[char notNil and: [char ~= Character cr]]
		whileTrue: 
			[stream nextPut: char.
			char := self getChar: aStream].
	(char notNil and: [char = Character cr])
		ifTrue: [stream nextPut: char].
	^stream contents! !

!Encyclopedia methodsFor: 'string and character'!
separate: separateCollection dividers: dividerCollection 
	"Encyclopedia new separate: #(a b c d e f g h) dividers: #(d f)."

	| indexCollection index intervalCollection s e result |
	indexCollection := OrderedCollection new.
	indexCollection add: 0.
	index := 1.
	separateCollection
		do: 
			[:each | 
			(dividerCollection includes: each)
				ifTrue: [indexCollection add: index].
			index := index + 1].
	indexCollection add: separateCollection size + 1.
	intervalCollection := OrderedCollection new.
	1 to: indexCollection size - 1
		do: 
			[:i | 
			s := indexCollection at: i.
			e := indexCollection at: i + 1.
			intervalCollection add: (s + 1 to: e - 1)].
	result := OrderedCollection new.
	intervalCollection do: [:interval | interval size > 0 ifTrue: [result add: (separateCollection copyFrom: interval first to: interval last)]].
	^result! !

!Encyclopedia methodsFor: 'string and character' stamp: 'nishis 4/2/98 11:14'!
separators
	"Encyclopedia new separators."

	| stream |
	stream := WriteStream on: (String new: 10).
	stream nextPut: Character space.
	stream nextPut: Character tab.
	stream nextPut: Character cr.
	stream nextPut: Character linefeed.
	stream nextPutAll: '<'.
	stream nextPutAll: '>'.
	stream nextPutAll: '='.
	stream nextPutAll: '"'.
	stream nextPutAll: '('.
	stream nextPutAll: ')'.
	^stream contents! !

!Encyclopedia methodsFor: 'string and character' stamp: 'nishis 4/2/98 11:14'!
separatorsForChunks
	"Encyclopedia new separatorsForChunks."

	| stream |
	stream := WriteStream on: (String new: 4).
	stream nextPut: Character space.
	stream nextPut: Character tab.
	stream nextPut: Character cr.
	stream nextPut: Character linefeed.
	^stream contents! !

!Encyclopedia methodsFor: 'string and character'!
stringMatch: string and: pattern 
	"Encyclopedia new stringMatch: ' Aoki' and: 'Ju*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!Encyclopedia methodsFor: 'string and character'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !

!Encyclopedia methodsFor: 'string and character'!
timeString
	"Encyclopedia new timeString."

	| stream string |
	stream := WriteStream on: String new.
	string := Time now hours printString.
	2 - string size timesRepeat: [stream nextPutAll: '0'].
	stream nextPutAll: string.
	stream nextPutAll: ':'.
	string := Time now minutes printString.
	2 - string size timesRepeat: [stream nextPutAll: '0'].
	stream nextPutAll: string.
	^stream contents! !


!Encyclopedia methodsFor: 'file and directory'!
baseNameForEncyclopedia
	"Encyclopedia new baseNameForEncyclopedia."

	^'Encyclopedia' copy! !

!Encyclopedia methodsFor: 'file and directory'!
baseNameForHtmls
	"Encyclopedia new baseNameForHtmls."

	^'htmls' copy! !

!Encyclopedia methodsFor: 'file and directory'!
baseNameForImages
	"Encyclopedia new baseNameForImages."

	^'images' copy! !

!Encyclopedia methodsFor: 'file and directory' stamp: 'nishis 6/12/1998 00:16'!
directoryNameForEncyclopedia
	"Encyclopedia new directoryNameForEncyclopedia."

	| aString directoryName |
	aString := self baseNameForEncyclopedia.
	directoryName := FileDirectory default.
	(directoryName directoryNames includes: aString)
		ifFalse: [directoryName createDirectory: aString].
	^directoryName pathName , (String with: FileDirectory pathNameDelimiter), 
					aString , (String with: FileDirectory pathNameDelimiter) ! !

!Encyclopedia methodsFor: 'file and directory' stamp: 'nishis 6/12/1998 00:16'!
directoryNameForHtmls
	"Encyclopedia new directoryNameForHtmls."

	| aString directoryName pathname |
	aString := self baseNameForHtmls.
	pathname := self directoryNameForEncyclopedia.
	pathname last = FileDirectory pathNameDelimiter
		ifTrue: [pathname := pathname truncateTo: (pathname size - 1)].
	directoryName := FileDirectory on: pathname.
	(directoryName directoryNames includes: aString)
		ifFalse: [directoryName createDirectory: aString].
	^directoryName pathName , (String with: FileDirectory pathNameDelimiter), 
					aString , (String with: FileDirectory pathNameDelimiter)! !

!Encyclopedia methodsFor: 'file and directory' stamp: 'nishis 6/12/1998 00:16'!
directoryNameForImages
	"Encyclopedia new directoryNameForImages."

	| aString directoryName pathname |
	aString := self baseNameForImages.
	pathname := self directoryNameForEncyclopedia.
	pathname last = FileDirectory pathNameDelimiter
		ifTrue: [pathname := pathname truncateTo: (pathname size - 1)].
	directoryName := FileDirectory on: pathname.
	(directoryName directoryNames includes: aString)
		ifFalse: [directoryName createDirectory: aString].
	^directoryName pathName , (String with: FileDirectory pathNameDelimiter), 
					aString , (String with: FileDirectory pathNameDelimiter)! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot1Gif
	"Encyclopedia new fileNameDot1Gif."

	^'dot1.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot2Gif
	"Encyclopedia new fileNameDot2Gif."

	^'dot2.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot3Gif
	"Encyclopedia new fileNameDot3Gif."

	^'dot3.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot4Gif
	"Encyclopedia new fileNameDot4Gif."

	^'dot4.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot5Gif
	"Encyclopedia new fileNameDot5Gif."

	^'dot5.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot6Gif
	"Encyclopedia new fileNameDot6Gif."

	^'dot6.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot7Gif
	"Encyclopedia new fileNameDot7Gif."

	^'dot7.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot8Gif
	"Encyclopedia new fileNameDot8Gif."

	^'dot8.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameDot9Gif
	"Encyclopedia new fileNameDot9Gif."

	^'dot9.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameIndexGif
	"Encyclopedia new fileNameIndexGif."

	^'index.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
fileNameXrefsGif
	"Encyclopedia new fileNameXrefsGif."

	^'xrefs.gif' copy! !

!Encyclopedia methodsFor: 'file and directory'!
htmlFileExtension
	"Encyclopedia new htmlFileExtension."

	^'.htm' copy! !

!Encyclopedia methodsFor: 'file and directory'!
htmlFileNameFor: aString 
	"Encyclopedia new htmlFileNameFor: '1234567890123456789012345678901234567890'."

	| limit string filename half |
	limit := 30.
	string := aString asString , self htmlFileExtension.
	string size > limit
		ifTrue: 
			[filename := string copyFrom: string size - limit + 1 to: string size.
			half := 12.
			1 to: half do: [:index | filename at: index put: (string at: index)].
			filename at: half + 1 put: $_]
		ifFalse: [filename := string].
	^filename! !

!Encyclopedia methodsFor: 'file and directory' stamp: 'nishis 4/2/98 11:10'!
htmlFileNames
	"Encyclopedia new htmlFileNames."

	| directory contents string pattern |
	directory := self directoryNameForHtmls.
	Cursor wait
		showWhile: 
			[contents := (FileDirectory on: directory) fileNames.
			contents := contents
						select: 
							[:each | 
							string := each collect: [:char | char asLowercase].
							pattern := '*' , self htmlFileExtension collect: [:char | char asLowercase].
							self stringMatch: string and: pattern].
			contents := contents asSortedCollection].
	^contents asArray! !


!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:39'!
dot1GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		255 0 0 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:48'!
dot2GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		255 170 0 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:48'!
dot3GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		170 255 0 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:48'!
dot4GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		0 255 0 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:48'!
dot5GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		0 255 170 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:48'!
dot6GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		0 170 255 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:48'!
dot7GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		0 0 255 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:49'!
dot8GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		170 0 255 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:49'!
dot9GifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 4 0 4 0 145 0 0 255 255 255
		255 0 170 0 0 0 0 0 0 44 0 0 0 0 4 0
		4 0 0 2 4 140 143 25 5 0 59 
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:49'!
indexGifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 18 0 8 0 179 0 0 255 255 255
		255 255 0 204 204 204 136 136 136 85 85 85 0 153 153 0
		153 102 0 153 51 0 0 0 0 0 0 0 0 0 0 0
		0 0 0 0 0 0 0 0 0 0 0 0 0 44 0 0
		0 0 18 0 8 0 0 4 25 176 200 73 171 173 230 220
		93 66 224 150 231 129 211 33 126 100 135 142 36 90 152 105
		26 1 0 59
	)') first! !

!Encyclopedia methodsFor: 'gif image date' stamp: 'nishis 4/2/98 21:49'!
xrefsGifData
	^(Parser new scanTokens: '#(
		71 73 70 56 55 97 18 0 8 0 162 0 0 255 255 255
		255 255 0 204 204 204 136 136 136 85 85 85 0 153 153 0
		153 51 0 0 0 44 0 0 0 0 18 0 8 0 0 3
		23 88 186 220 174 38 72 105 30 147 11 91 21 42 15 155
		67 133 89 71 158 161 246 36 0 59
	)') first! !


!Encyclopedia methodsFor: 'private' stamp: 'nishis 4/2/98 23:24'!
associations: aCollection
	"added nishis 4/2/98 23:24"
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: aCollection size.
	aCollection associationsDo: [:association | anOrderedCollection add: association].
	^ anOrderedCollection! !

!Encyclopedia methodsFor: 'private' stamp: 'nishis 4/2/98 00:51'!
setClasses: collectionOfClasses 
	collectionOfClasses do: [:each | (each isKindOf: Behavior) ifTrue: [each isMeta
				ifTrue: [self classCollection add: each soleInstance]
				ifFalse: [self classCollection add: each]]].
	^self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Encyclopedia class
	instanceVariableNames: ''!

!Encyclopedia class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!Encyclopedia class methodsFor: 'copyright'!
system
	^'Goodies'! !

!Encyclopedia class methodsFor: 'copyright'!
version
	^'003'! !


!Encyclopedia class methodsFor: 'instance creation'!
class: aClass 
	^self classes: (Array with: aClass)! !

!Encyclopedia class methodsFor: 'instance creation'!
classes: classCollection 
	^(self new) setClasses: classCollection; yourself! !


!Encyclopedia class methodsFor: 'saving' stamp: 'nishis 6/28/1998 05:29'!
save
	"Encyclopedia save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Encyclo.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!Encyclopedia class methodsFor: 'saving'!
saveClasses
	"Encyclopedia saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Encyclopedia*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!Encyclopedia class methodsFor: 'examples'!
example1
	"Encyclopedia example1."

	| encyclopedia |
	encyclopedia := Encyclopedia class: Text.
	encyclopedia generate.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example2
	"Encyclopedia example2."

	| encyclopedia |
	encyclopedia := Encyclopedia classes: (Array with: Point with: Rectangle).
	encyclopedia generate.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example3
	"Encyclopedia example3."

	| encyclopedia |
	encyclopedia := Encyclopedia classes: Number withAllSubclasses.
	encyclopedia sourceInclusion: true.
	encyclopedia generate.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example4
	"Encyclopedia example4."

	| collection encyclopedia |
	collection := IdentitySet new.
	Smalltalk allBehaviorsDo: [:aClass | aClass isMeta ifFalse: [collection add: aClass]].
	encyclopedia := Encyclopedia classes: collection.
	encyclopedia generate.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example5
	"Encyclopedia example5."

	| encyclopedia |
	encyclopedia := Encyclopedia class: Text.
	encyclopedia upgrade.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example6
	"Encyclopedia example6."

	| encyclopedia |
	encyclopedia := Encyclopedia classes: (Array with: Point with: Rectangle).
	encyclopedia upgrade.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example7
	"Encyclopedia example7."

	| encyclopedia |
	encyclopedia := Encyclopedia classes: Number withAllSubclasses.
	encyclopedia sourceInclusion: true.
	encyclopedia upgrade.
	^encyclopedia! !

!Encyclopedia class methodsFor: 'examples'!
example8
	"Encyclopedia example8."

	| collection encyclopedia |
	collection := IdentitySet new.
	Smalltalk allBehaviorsDo: [:aClass | aClass isMeta ifFalse: [collection add: aClass]].
	encyclopedia := Encyclopedia classes: collection.
	encyclopedia upgrade.
	^encyclopedia! !
