'Goodies (11/18/2001 8:35:04 am)'.!


Object subclass: #SourceCodeSaver
	instanceVariableNames: 'name categories filter footer directory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Tools'!
!SourceCodeSaver commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Source Code Saver
Goodies for Squeak 1.31, Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Source Code Saver
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/SrcSaver.st

Summary:

The more making many classes, the harder are the problems of 
saving them or etc.  And what is the order to read in your 
system.  Also there is a case of the limitation of the length 
of filename (8+3, 31 chars etc), that doesn't allow a class 
name to filename.  This SourceCodeSaver goodies solves these 
problems at simple way.


Installing:

FileIn this goodies and makes a class "SourceCodeSaver" in a 
category "Goodies-Tools". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"SourceCodeSaver" from your system, simply.


how to use:

The instance of the class SourceCodeSaver decides the classes 
to be saved by gathering on a given pattern (category) and 
passing through a given filter.  If you send a message "save", 
you can get these classes to be saved and a file to be used 
installing and a catalog file which decides the order to fileIn.

For example, 

| aSourceCodeSaver |
aSourceCodeSaver :=
    SourceCodeSaver
        name: 'Name001'
        categories: #('Goodies*')
        filter: [:aClass | aClass name = SourceCodeSaver name].
aSourceCodeSaver save.

Above, it point the category pattern matching "Goodies*".  
Each of these classes is evaluated by aBlockContext filter, 
picking up each value is true.  In this example, the one only 
class "SourceCodeSaver" will be selected.

After above, he instance of the class SourceCodeSaver receives 
a message "save", saves the files to be saved below in the 
directory "Name001".

Name001:
    Install.st
    Src00000.st
    Src00001.st

The first "Install.st" is for installing.  For fileIn, you 
fileIn this file only.  The second "Src00000.st" is a catalog 
file for fileIn.  The third "Src00001.st" is a source code 
of SourceCodeSaver.  If there are more classes, produced 
Src?????.st incrementally.  Src00000.st gives the information 
of class-to-Src?????.st, one-to-one.

For fileIn, you fileIn this file only, again.  FileIn this 
file only from fileList etc, all of the rest will be installed.  
FileIn follows the superclass order.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/SrcSaver.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/SrcSaver.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!SourceCodeSaver methodsFor: 'accessing'!
categories
	^categories! !

!SourceCodeSaver methodsFor: 'accessing' stamp: 'nishis 3/29/98 10:31'!
directory
	"SourceCodeSaver example3."
	| saveDirectory localName directories defaultDirectory |
	directory isNil
		ifTrue: 
			[saveDirectory := FileDirectory on: self class defaultDirectoryName , self name.
			localName := self name.
			defaultDirectory := FileDirectory default copy.
			directories := localName findTokens: FileDirectory pathNameDelimiter asString.
			directories 
				do:
					[: subDirectory | 
					(defaultDirectory includesKey: subDirectory)
						ifFalse: [defaultDirectory createDirectory: subDirectory].
					defaultDirectory := FileDirectory on: 
							(defaultDirectory pathName, 
							(String with: FileDirectory pathNameDelimiter), 
							subDirectory)].
			directory := saveDirectory].
	^directory! !

!SourceCodeSaver methodsFor: 'accessing' stamp: 'nishis 3/29/98 09:55'!
directory1
	"SourceCodeSaver example3."
	| saveDirectory localName |
	directory isNil
		ifTrue: 
			[saveDirectory := FileDirectory on: self class defaultDirectoryName , self name.
			localName := self name.
self halt.
			(FileDirectory default includesKey: localName)
				ifFalse: 
					[FileDirectory default createDirectory: localName].
			directory := saveDirectory].
	^directory! !

!SourceCodeSaver methodsFor: 'accessing'!
filter
	^filter! !

!SourceCodeSaver methodsFor: 'accessing'!
footer
	^footer! !

!SourceCodeSaver methodsFor: 'accessing'!
footer: aString 
	footer := aString! !

!SourceCodeSaver methodsFor: 'accessing'!
name
	^name! !

!SourceCodeSaver methodsFor: 'accessing' stamp: 'nishis 3/29/98 10:31'!
name: nameString categories: stringArray filter: filterBlock 
	name := nameString asString.
	categories := (stringArray collect: [:each | each asString]) asArray.
	filter := filterBlock.
	^self! !


!SourceCodeSaver methodsFor: 'classes'!
allClassNames
	^self allClasses collect: [:each | each name]! !

!SourceCodeSaver methodsFor: 'classes' stamp: 'nishis 3/29/98 05:11'!
allClasses
	| rootClasses allClasses blockClosure |
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	blockClosure := [:each | ((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: [allClasses add: each]].
	rootClasses
		do: 
			[:root | 
			blockClosure value: root.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each]]].
	^allClasses asArray! !

!SourceCodeSaver methodsFor: 'classes'!
allNumberOfClasses
	^self allClasses size! !

!SourceCodeSaver methodsFor: 'classes'!
classNames
	^self classes collect: [:each | each name]! !

!SourceCodeSaver methodsFor: 'classes' stamp: 'nishis 6/1/98 03:54'!
classes
	| blockClosure rootClasses allClasses patterns |
	self categories isNil ifTrue: [^Array new].
	blockClosure := 
			[:each :classes | 
			((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: 
					[patterns := self categories select: [:pattern | self class stringMatch: each category asString and: pattern].
					(patterns isEmpty not and: [self filter value: each])
						ifTrue: [classes add: each]]].
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	rootClasses
		do: 
			[:root | 
			blockClosure value: root value: allClasses.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each value: allClasses]]].
	^(ChangeSet superclassOrder: allClasses) asArray
	"^allClasses asArray"! !

!SourceCodeSaver methodsFor: 'classes'!
numberOfClasses
	^self classes size! !


!SourceCodeSaver methodsFor: 'messages'!
messages
	| instanceMessages classMessages |
	instanceMessages := Set new.
	classMessages := Set new.
	self classes
		do: 
			[:each | 
			instanceMessages addAll: each selectors.
			classMessages addAll: each class selectors].
	instanceMessages := instanceMessages asSortedCollection.
	classMessages := classMessages asSortedCollection.
	^Array with: instanceMessages with: classMessages! !

!SourceCodeSaver methodsFor: 'messages'!
numberOfMessages
	^self messages collect: [:each | each size]! !


!SourceCodeSaver methodsFor: 'methods' stamp: 'nishis 7/19/1998 22:48'!
methods
	| instanceMethods classMethods |
	instanceMethods := Bag new.
	classMethods := Bag new.
	self classes
		do: 
			[:each | 
			instanceMethods addAll: each selectors.
			classMethods addAll: each class selectors].
	instanceMethods := instanceMethods asSortedCollection.
	classMethods := classMethods asSortedCollection.
	^Array with: instanceMethods with: classMethods! !

!SourceCodeSaver methodsFor: 'methods' stamp: 'nishis 7/19/1998 22:48'!
numberOfMethods
	^self methods collect: [:each | each size]! !


!SourceCodeSaver methodsFor: 'saving' stamp: 'nishis 3/29/98 11:46'!
save
	Cursor write
			showWhile:[self saveWithCursorWrite]! !

!SourceCodeSaver methodsFor: 'saving'!
savePrefix
	^'Src' copy! !

!SourceCodeSaver methodsFor: 'saving' stamp: 'nishis 6/28/1998 05:20'!
saveWithCursorWrite
	| savingClasses separatorString extensionString saveDirectory baseString fileNames fileNo fileName writeStream stream filename localName privateSaveInstallBlock |
	savingClasses := self classes.
	savingClasses isEmpty ifTrue: [^nil].
	savingClasses size > 1
		ifTrue: [Transcript cr; cr; show: self name , ': saving ' , savingClasses size printString , ' classes ...']
		ifFalse: [Transcript cr; cr; show: self name , ': saving ' , savingClasses size printString , ' class ...'].
	separatorString := String with: FileDirectory pathNameDelimiter.
	extensionString := '.st'.
	saveDirectory := self directory.
	(saveDirectory containingDirectory includesKey: saveDirectory pathParts last)
		ifTrue: [saveDirectory fileNames
				do: 
					[:each | 
					localName := self name , separatorString , each.
					filename := self class defaultDirectoryName , localName.
					(FileDirectory on: self class defaultDirectoryName, self name) 						deleteFileNamed: each 
						ifAbsent: []]]
		ifFalse: 
			[saveDirectory containingDirectory 
					createDirectory: saveDirectory pathParts last].
	baseString := String new.
	8 - self savePrefix size timesRepeat: [baseString := baseString , '0'].
	fileNames := OrderedCollection new.
	fileNo := 1.
	savingClasses
		do: 
			[:each | 
			stream := WriteStream on: (String new: 12).
			stream nextPutAll: self savePrefix.
			baseString size - fileNo printString size timesRepeat: [stream nextPutAll: '0'].
			stream nextPutAll: fileNo printString.
			stream nextPutAll: extensionString.
			fileNames add: stream contents.
			filename := self class defaultDirectoryName , self name.
			filename := filename , separatorString , stream contents.
			filename := FileStream fileNamed: filename.
			self privateSaveClass: each into: filename.
			filename close.
			Transcript show: ' -> ' , stream contents.
			fileNo := fileNo + 1].
	fileName := self class defaultDirectoryName , self name.
	fileName := fileName , separatorString , self savePrefix , baseString , extensionString.
	Transcript cr; show: self name , ' -> ' , self savePrefix , baseString , extensionString.
	writeStream := (FileStream fileNamed: fileName).
	self
		privateSaveInstallation: savingClasses
		into: writeStream
		files: fileNames.
	writeStream close.
	fileName := self class defaultDirectoryName , self name.
	fileName := fileName , separatorString , 'Install' , extensionString.
	Transcript cr; show: 'All ' , self name , ' -> ' , 'Install' , extensionString.
	fileNames := Array with: self savePrefix , baseString , extensionString.
	writeStream := FileStream fileNamed: fileName.
	privateSaveInstallBlock := [self privateSaveInstall: fileNames into: writeStream].
	privateSaveInstallBlock ifError: [:err :rcvr | writeStream close].
	writeStream closed ifFalse: [writeStream close].
	Transcript cr; show: '... done at ' , Date today printString , ' ' , Time now printString! !


!SourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 06:44'!
privateSaveCategories: allClasses into: aStream 
	(allClasses collect: [:each | each category]) asSet asSortedCollection
		do: 
			[:each | 
			aStream nextPutAll: '(SystemOrganization categories includes: '.
			aStream nextPutAll: each asString printString.
			aStream nextPutAll: ' asSymbol'.
			aStream nextPutAll: ')'.
			aStream cr.
			aStream tab.
			aStream nextPutAll: 'ifFalse: ['.
			aStream nextPutAll: 'SystemOrganization addCategory: '.
			aStream nextPutAll: each asString printString.
			aStream nextPutAll: ' asSymbol'.
			aStream nextPutAll: '].'.
			aStream nextChunkPut: String new.
			aStream cr].
	aStream cr.
	aStream cr.
	^aStream! !

!SourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 10:33'!
privateSaveClass: aClass into: aFile 
	self privateSaveHeaderInto: aFile.
	aClass fileOutOn: aFile! !

!SourceCodeSaver methodsFor: 'private'!
privateSaveDefinitions: allClasses into: aStream 
	allClasses
		do: 
			[:each | 
			aStream nextPutAll: each definition.
			aStream nextPutAll: '.'.
			aStream nextChunkPut: String new.
			aStream cr.
			aStream cr].
	aStream cr.
	^aStream! !

!SourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 11:23'!
privateSaveFileInProgram: fileNames into: aStream 
	| limit count index collection segment |
	limit := 100.
	count := fileNames size // limit.
	fileNames size \\ limit = 0 ifFalse: [count := count + 1].
	index := 1.
	collection := OrderedCollection new: count.
	count
		timesRepeat: 
			[segment := OrderedCollection new: limit.
			1 to: limit
				do: 
					[:n | 
					index <= fileNames size ifTrue: [segment add: (fileNames at: index)].
					index := index + 1].
			collection add: segment].
	collection
		do: 
			[:names | 
			aStream nextPutAll: '| separatorString directoryString |'.
			aStream cr.
			aStream nextPutAll: '#('.
			aStream cr.
			names
				do: 
					[:each | 
					each printOn: aStream.
					aStream cr].
			aStream nextPutAll: ')'.
			aStream cr.
			aStream tab.
			aStream nextPutAll: ' do:'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: '[:aString |'.
			aStream cr.
"
			aStream tab; tab.
			aStream nextPutAll: '| separatorString directoryString |'.
			aStream cr.
"
			aStream tab; tab.
			aStream nextPutAll: 'separatorString := String with: FileDirectory pathNameDelimiter'.
			aStream nextPutAll: '.'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: 'directoryString := FileDirectory default pathName'.
			aStream nextPutAll: '.'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: 'directoryString last = FileDirectory pathNameDelimiter'.
			aStream cr.
			aStream tab; tab; tab.
			aStream nextPutAll: 'ifTrue: [directoryString := directoryString , '.
			aStream nextPutAll: self name printString.
			aStream nextPutAll: ' , separatorString]'.
			aStream cr.
			aStream tab; tab; tab.
			aStream nextPutAll: 'ifFalse: [directoryString := directoryString , separatorString , '.
			aStream nextPutAll: self name printString.
			aStream nextPutAll: ' , separatorString]'.
			aStream nextPutAll: '.'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: '(FileStream oldFileNamed: directoryString , aString)'.
			aStream nextPutAll: ' fileIn].'.
			aStream nextChunkPut: String new.
			aStream cr.
			aStream cr].
	^aStream! !

!SourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 05:43'!
privateSaveHeaderInto: aStream 
	| header |
	header := WriteStream on: (String new: 128).
	header nextPutAll: self name.
	header space.
	header nextPutAll: '('.
	header nextPutAll: Date today mmddyyyy.
	header space.
	header nextPutAll: Time now asString.
	header nextPutAll: ')'.
	aStream nextPutAll: header contents printString.
	aStream nextPutAll: '.'.
	aStream nextChunkPut: String new.
	aStream cr.
	aStream cr.
	aStream cr.
	^aStream! !

!SourceCodeSaver methodsFor: 'private'!
privateSaveInstall: fileNames into: aStream 
	self privateSaveHeaderInto: aStream.
	self privateSaveFileInProgram: fileNames into: aStream! !

!SourceCodeSaver methodsFor: 'private'!
privateSaveInstallation: allClasses into: aStream files: fileNames 
	| collection key value |
	self privateSaveHeaderInto: aStream.
	collection := SortedCollection new: allClasses size.
	allClasses with: fileNames
		do: 
			[:aClass :fileName | 
			key := aClass name.
			value := fileName.
			collection add: key -> value].
	collection
		do: 
			[:association | 
			aStream nextPutAll: association storeString.
			aStream nextPutAll: '.'.
			aStream nextChunkPut: String new.
			aStream cr].
	aStream cr.
	aStream cr.
	self privateSaveCategories: allClasses into: aStream.
	self privateSaveDefinitions: allClasses into: aStream.
	self privateSaveFileInProgram: fileNames into: aStream.
	aStream cr.
	self footer isNil
		ifFalse: 
			[aStream nextChunkPut: self footer.
			aStream cr].
	^aStream! !

!SourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 05:11'!
privateValues
	^ self class privateValues
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SourceCodeSaver class
	instanceVariableNames: ''!

!SourceCodeSaver class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!SourceCodeSaver class methodsFor: 'copyright'!
system
	^'Goodies'! !

!SourceCodeSaver class methodsFor: 'copyright'!
version
	^'003'! !


!SourceCodeSaver class methodsFor: 'instance creation'!
name: nameString categories: symbolArray 
	^super new
		name: nameString
		categories: symbolArray
		filter: [:aClass | true]! !

!SourceCodeSaver class methodsFor: 'instance creation'!
name: nameString categories: stringArray filter: filterBlock 
	^super new
		name: nameString
		categories: stringArray
		filter: filterBlock! !


!SourceCodeSaver class methodsFor: 'utilities' stamp: 'nishis 3/29/98 11:17'!
defaultDirectoryName
	"SourceCodeSaver defaultDirectoryName."

	| directoryName |
	directoryName := FileDirectory default pathName.
	directoryName last = FileDirectory pathNameDelimiter 
		ifFalse: 
			[directoryName := directoryName, (String with: FileDirectory pathNameDelimiter)].
	^directoryName! !

!SourceCodeSaver class methodsFor: 'utilities'!
stringMatch: string and: pattern 
	"SourceCodeSaver stringMatch: ' Aoki' and: '*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!SourceCodeSaver class methodsFor: 'utilities'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !


!SourceCodeSaver class methodsFor: 'saving' stamp: 'nishis 6/28/1998 04:53'!
save
	"SourceCodeSaver save."

	| fileName classCollection aStream timeStamp saveBlock |
	fileName := 'SrcSaver.st'.
	classCollection := self saveClasses.
	FileDirectory default
			deleteFileNamed: fileName asFileName
			ifAbsent: [].
	aStream := FileStream fileNamed: fileName asFileName.
	aStream reset.
	saveBlock := [Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy , ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr]]].
	saveBlock ifError: [:err :rcvr | aStream close].
	aStream closed ifFalse: [aStream close].
	^classCollection! !

!SourceCodeSaver class methodsFor: 'saving' stamp: 'nishis 3/29/98 04:28'!
saveClasses
	"SourceCodeSaver saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*SourceCodeSaver*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!SourceCodeSaver class methodsFor: 'for goodies'!
goodiesClasses
	"SourceCodeSaver goodiesClasses."

	| sourceCodeSaver |
	sourceCodeSaver := SourceCodeSaver
				name: 'Goodies'
				categories: #('Goodies-*')
				filter: [:aClass | true].
	^sourceCodeSaver classes! !

!SourceCodeSaver class methodsFor: 'for goodies' stamp: 'nishis 3/29/98 11:18'!
goodiesPropagateCopyright
	"SourceCodeSaver goodiesPropagateCopyright."

	| copyright organizer top stream categories |
	copyright := self copyright.
	self goodiesClasses do: [:each | each = self
			ifFalse: 
				[organizer := each class organization.
				categories := organizer categories.
				categories isEmpty
					ifTrue: [top := nil]
					ifFalse: 
						[top := categories first.
						top = #copyright ifTrue: [categories size >= 2
								ifTrue: [top := categories at: 2]
								ifFalse: [top := nil]]].
				organizer addCategory: #copyright before: top.
				stream := WriteStream on: String new.
				stream nextPutAll: '!!'.
				stream nextPutAll: each name asString.
				stream nextPutAll: ' class methodsFor: '.
				stream nextPutAll: 'copyright' printString.
				stream nextPutAll: '!!'.
				stream cr.
				stream cr.
				stream nextPutAll: 'copyright'.
				stream cr.
				stream tab.
				stream nextPutAll: '^'.
				stream nextPutAll: copyright printString.
				stream nextPutAll: '!!'.
				stream cr.
				stream cr.
				stream nextPutAll: 'system'.
				stream cr.
				stream tab.
				stream nextPutAll: '^'.
				stream nextPutAll: self system printString.
				stream nextPutAll: '!!'.
				stream cr.
				stream cr.
				stream nextPutAll: 'version'.
				stream cr.
				stream tab.
				stream nextPutAll: '^'.
				stream nextPutAll: self version printString.
				stream nextPutAll: '!!'.
				stream nextPutAll: ' !!'.
				stream cr.
				(ReadWriteStream on: stream contents) fileIn]]! !

!SourceCodeSaver class methodsFor: 'for goodies'!
goodiesSave
	"SourceCodeSaver goodiesSave."

	self goodiesClasses do: [:aClass | (aClass class includesSelector: #save)
			ifTrue: [aClass save]]! !


!SourceCodeSaver class methodsFor: 'examples'!
example1
	"SourceCodeSaver example1."

	| sourceCodeSaver |
	sourceCodeSaver := SourceCodeSaver
				name: 'Name001'
				categories: #('Goodies-Tools')
				filter: [:aClass | aClass name = SourceCodeSaver name].
	sourceCodeSaver save.
	^sourceCodeSaver! !

!SourceCodeSaver class methodsFor: 'examples'!
example2
	"SourceCodeSaver example2."

	| sourceCodeSaver |
	sourceCodeSaver := SourceCodeSaver
				name: 'Name001'
				categories: #('Goodies-Tools')
				filter: [:aClass | aClass name = SourceCodeSaver name].
	Transcript cr; show: 'classes: '.
	Transcript space; show: sourceCodeSaver numberOfClasses printString.
	Transcript cr; show: 'instance messages & class messages: '.
	Transcript space; show: sourceCodeSaver numberOfMessages printString.
	^sourceCodeSaver! !

!SourceCodeSaver class methodsFor: 'examples' stamp: 'nishis 3/29/98 11:35'!
example3
	"SourceCodeSaver example3."

	| sourceCodeSaver |
	sourceCodeSaver := SourceCodeSaver
				name: 'Name003:subDirectory'
				categories: #('Goodies-Tools')
				filter: [:aClass | aClass name = SourceCodeSaver name].
	sourceCodeSaver save.
	^sourceCodeSaver! !

!SourceCodeSaver class methodsFor: 'examples' stamp: 'nishis 3/30/98 03:32'!
example4
	"SourceCodeSaver example4."

	| sourceCodeSaver |
	sourceCodeSaver := SourceCodeSaver
				name: 'Name004'
				categories: #('Music*').
	sourceCodeSaver save.
	^sourceCodeSaver! !

!SourceCodeSaver class methodsFor: 'examples' stamp: 'nishis 3/30/98 03:33'!
example5
	"SourceCodeSaver example5."

	| sourceCodeSaver |
	sourceCodeSaver := SourceCodeSaver
				name: 'Name005'
				categories: #('Morphic*').
	Transcript cr; show: 'classes: '.
	Transcript space; show: sourceCodeSaver numberOfClasses printString.
	Transcript cr; show: 'instance messages & class messages: '.
	Transcript space; show: sourceCodeSaver numberOfMessages printString.
	^sourceCodeSaver! !


!SourceCodeSaver class methodsFor: 'private' stamp: 'nishis 3/29/98 05:11'!
privateValues
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: Smalltalk size.
	Smalltalk do: [:value | anOrderedCollection add: value].
	^anOrderedCollection! !
