'Goodies (11/18/2001 8:35:05 am)'.!


MethodNodeEnumerator subclass: #ProgramScanner
	instanceVariableNames: 'assignmentNodes blockNodes cascadeNodes literalNodes messageNodes methodNodes returnNodes statementNodes variableNodes tempVariableNodes '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Metrics'!
!ProgramScanner commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Program Scanner 
Goodies for Squeak 1.31, 2.0

Broken English description

This goodies is a modification for Squeak.
It is subclass of MethodNodeEnumerator.
Originally written by Mr. AOKI Atsushi, for VisualWorks 2.5.

from Atsushi AOKI, "Smalltalk Idioms", SRC, 1997, Tokyo, ISBN4-915778-81-9 C3055 P4500E.
Original Category as "SmalltalkIdioms-Metrics".

This goodies makes classes below in a category 
"Goodies-Metrics". 

ProgramScanner

and a category 
"Goodies-Support"

MethodNodeEnumerator

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@nifty.ne.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 01:08'!
binarySelectors
	^self messageNodes 
			select: [:node | node precedence = 2] 
			thenCollect: [:node | node selector key]! !

!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 01:08'!
keywordSelectors
	^self messageNodes 
			select: [:node | node precedence = 3] 
			thenCollect: [:node | node selector key]! !

!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 01:07'!
messageSelectors
	^self messageNodes collect: [:node | node selector key]! !

!ProgramScanner methodsFor: 'accessing'!
numberOfAssignments
	^self assignmentNodes size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfBlocks
	^self blockNodes size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfCascades
	^self cascadeNodes size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfLiterals
	^self literalNodes size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfMessages
	^self messageNodes size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfReturns
	^self returnNodes size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfStatements
	^self statementNodes size! !

!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 01:05'!
numberOfTemporaryVariables
	^self temporaryVariables size! !

!ProgramScanner methodsFor: 'accessing'!
numberOfVariables
	^self variables size! !

!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 01:05'!
temporaryVariables
	| set |
	set := Set new.
	set addAll: (self tempVariableNodes select: [:node | node isArg not]).
	^set! !

!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 01:07'!
unarySelectors
	^self messageNodes 
			select: [:node | node precedence = 1] 
			thenCollect: [:node | node selector key]! !

!ProgramScanner methodsFor: 'accessing' stamp: 'nishis 6/20/1998 00:23'!
variables
	| set |
	set := Set new.
	self variableNodes do: [:node | set add: node name].
	self tempVariableNodes do: [:node | set add: node name].
	^set! !


!ProgramScanner methodsFor: 'enumerating'!
doAssignment: aNode variable: variable value: value 
	assignmentNodes add: aNode.
	self doNode: variable.
	self doNode: value! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:28'!
doBlock: aNode arguments: arguments statements: statements
	blockNodes add: aNode.
	statementNodes addAll: statements.
	self doNodes: arguments.
	self doNodes: statements
! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:16'!
doBrace: aNode elements: elements
	self doNodes: elements! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:16'!
doCascade: aNode receiver: receiver messages: messages
	cascadeNodes add: aNode.
	self doNode: receiver.
	self doNodes: messages! !

!ProgramScanner methodsFor: 'enumerating'!
doLiteral: aNode value: value 
	literalNodes add: aNode.
	^aNode! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 6/21/1998 08:28'!
doMessage: aNode receiver: receiver selector: selector arguments: arguments 
	messageNodes add: aNode.
	self doNode: receiver.
	self doNodes: arguments! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 7/3/1998 00:22'!
doMethod: aNode arguments: arguments block: block temporaries: temporaries
	methodNodes add: aNode.
	self doNodes: arguments.
	self doNodes: temporaries.
	^self doNode: block! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 7/2/1998 22:17'!
doReturn: aNode value: value
	returnNodes add: aNode.
	self doNode: value! !

!ProgramScanner methodsFor: 'enumerating' stamp: 'nishis 6/19/1998 18:46'!
doTempVariable: aNode name: nameString 
	tempVariableNodes add: aNode.
	^aNode! !

!ProgramScanner methodsFor: 'enumerating'!
doVariable: aNode name: nameString 
	variableNodes add: aNode.
	^aNode! !


!ProgramScanner methodsFor: 'node accessing'!
assignmentNodes
	^assignmentNodes! !

!ProgramScanner methodsFor: 'node accessing'!
blockNodes
	^blockNodes! !

!ProgramScanner methodsFor: 'node accessing'!
cascadeNodes
	^cascadeNodes! !

!ProgramScanner methodsFor: 'node accessing'!
literalNodes
	^literalNodes! !

!ProgramScanner methodsFor: 'node accessing'!
messageNodes
	^messageNodes! !

!ProgramScanner methodsFor: 'node accessing'!
methodNodes
	^methodNodes! !

!ProgramScanner methodsFor: 'node accessing' stamp: 'nishis 6/20/1998 04:37'!
parameterNodes
	^tempVariableNodes asSet! !

!ProgramScanner methodsFor: 'node accessing'!
returnNodes
	^returnNodes! !

!ProgramScanner methodsFor: 'node accessing'!
statementNodes
	^statementNodes! !

!ProgramScanner methodsFor: 'node accessing' stamp: 'nishis 6/19/1998 18:45'!
tempVariableNodes
	^tempVariableNodes! !

!ProgramScanner methodsFor: 'node accessing'!
variableNodes
	^variableNodes! !


!ProgramScanner methodsFor: 'private' stamp: 'nishis 6/20/1998 04:37'!
setNode: programNode 
	assignmentNodes := OrderedCollection new.
	blockNodes := OrderedCollection new.
	cascadeNodes := OrderedCollection new.
	literalNodes := OrderedCollection new.
	messageNodes := OrderedCollection new.
	methodNodes := OrderedCollection new.
	returnNodes := OrderedCollection new.
	statementNodes := OrderedCollection new.
	variableNodes := OrderedCollection new.
	tempVariableNodes := OrderedCollection new.
	programNode isNil ifFalse: [self nodeDo: programNode]! !


!ProgramScanner methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: self class name asString.
	aStream nextPutAll: ' ('.
	aStream cr.
	aStream tab; nextPutAll: 'assignments: '.
	aStream nextPutAll: self numberOfAssignments printString.
	aStream cr.
	aStream tab; nextPutAll: 'blocks: '.
	aStream nextPutAll: self numberOfBlocks printString.
	aStream cr.
	aStream tab; nextPutAll: 'cascades: '.
	aStream nextPutAll: self numberOfCascades printString.
	aStream cr.
	aStream tab; nextPutAll: 'literals: '.
	aStream nextPutAll: self numberOfLiterals printString.
	aStream cr.
	aStream tab; nextPutAll: 'messages: '.
	aStream nextPutAll: self numberOfMessages printString.
	aStream cr.
	aStream tab; nextPutAll: 'returns: '.
	aStream nextPutAll: self numberOfReturns printString.
	aStream cr.
	aStream tab; nextPutAll: 'statements: '.
	aStream nextPutAll: self numberOfStatements printString.
	aStream cr.
	aStream tab; nextPutAll: 'temporaries: '.
	aStream nextPutAll: self numberOfTemporaryVariables printString.
	aStream cr.
	aStream tab; nextPutAll: 'variables: '.
	aStream nextPutAll: self numberOfVariables printString.
	aStream cr.
	aStream nextPutAll: ')'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ProgramScanner class
	instanceVariableNames: ''!

!ProgramScanner class methodsFor: 'copyright' stamp: 'nishis 6/19/1998 16:36'!
copyright
	^'Copyright (C) 1997 AOKI Atsushi, All Rights Reserved.'! !

!ProgramScanner class methodsFor: 'copyright' stamp: 'nishis 6/19/1998 16:34'!
system
	^'Goodies'! !

!ProgramScanner class methodsFor: 'copyright' stamp: 'nishis 6/19/1998 16:34'!
version
	^'001'! !


!ProgramScanner class methodsFor: 'instance creation' stamp: 'nishis 6/21/1998 06:42'!
class: aClass selector: aSelector 
	| aMethod |
	aMethod := aClass compiledMethodAt: aSelector.
	^self method: aMethod class: aClass! !

!ProgramScanner class methodsFor: 'instance creation' stamp: 'nishis 6/21/1998 07:12'!
method: aMethod 
	^self method: aMethod class: aMethod who first! !

!ProgramScanner class methodsFor: 'instance creation' stamp: 'nishis 6/21/1998 18:29'!
method: aMethod class: aClass
	| homeMethod methodClass sourceCode rootNode selector |
	homeMethod := aMethod.
	methodClass := aClass.
	sourceCode := homeMethod getSourceFromFile.
	sourceCode isNil ifTrue: 
		[selector := methodClass 
				selectorAtMethod: homeMethod
				setClass: [:mc | methodClass := mc].
		sourceCode := (methodClass decompilerClass new
				decompile: selector
				in: methodClass 
				method: homeMethod) decompileString].
	(sourceCode isNil or: [methodClass isNil])
		ifTrue: [^(self node: nil) "selectors"].
	rootNode := (methodClass compilerClass new) 
					parse: sourceCode 
					in: methodClass 
					notifying: nil.
	^self node: rootNode
! !

!ProgramScanner class methodsFor: 'instance creation'!
node: programNode 
	^(self new) setNode: programNode; yourself! !


!ProgramScanner class methodsFor: 'saving' stamp: 'nishis 6/30/1998 14:29'!
save
	"ProgramScanner save."

	| fileName classCollection aStream timeStamp |
	fileName := 'PrgScanr.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today printString, ' ' , Time now printString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (String cr, 
							self comment asString, String cr) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr.
					aStream cr]].
	aStream close.
	^classCollection! !

!ProgramScanner class methodsFor: 'saving' stamp: 'nishis 7/3/1998 00:34'!
saveClasses
	"ProgramScanner saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('ProgramScanner').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	classCollection addFirst: MethodNodeEnumerator.
	classCollection := ChangeSet superclassOrder: classCollection.
	^classCollection! !


!ProgramScanner class methodsFor: 'utilities' stamp: 'nishis 6/29/1998 04:21'!
methodsInClasses
	"ProgramScanner methodsInClasses."
	| total block count max min selectors selectorsOfABehavior |
	max := SmallInteger minVal.
	min := SmallInteger maxVal.
	total := 0.
	block := [:class | 
		selectors := class selectors size.
		total := total + selectors].
	count := 0.
	Smalltalk allBehaviorsDo: 
		[:behavior | 
		behavior isMeta 
			ifFalse: 
				[selectors := 0.
				selectorsOfABehavior := 0.
				block value: behavior.
				selectorsOfABehavior := selectors.
				block value: behavior class.
				selectorsOfABehavior := selectorsOfABehavior + selectors.
				max := max max: selectorsOfABehavior.
				min := min min: selectorsOfABehavior.
				count := count + 1]].
	^Array with: max with: min with: (total / count) rounded! !


!ProgramScanner class methodsFor: 'examples' stamp: 'nishis 6/29/1998 04:14'!
example
	"ProgramScanner example."

	| aClass aSelector programScanner |
	aClass := String.
	aSelector := #storeOn:.
	programScanner := ProgramScanner class: aClass selector: aSelector.
	Transcript cr; show: programScanner printString.
	Transcript cr; show: 'number of message selectors: ', 
			programScanner messageSelectors size printString.
	Transcript cr; show: 'methods in classes (max min average): ', 
			ProgramScanner methodsInClasses printString.
	^programScanner! !

!ProgramScanner class methodsFor: 'examples' stamp: 'nishis 6/19/1998 16:42'!
example1
	"ProgramScanner example1."

	| aClass aSelector programScanner |
	aClass := Object.
	aSelector := #printOn:.
	programScanner := ProgramScanner class: aClass selector: aSelector.
	Transcript cr; show: programScanner printString.
	^programScanner! !

!ProgramScanner class methodsFor: 'examples'!
example2
	"ProgramScanner example2."

	| aClass aSelector programScanner |
	aClass := Collection class.
	aSelector := #with:with:with:.
	programScanner := ProgramScanner class: aClass selector: aSelector.
	Transcript cr; show: programScanner printString.
	^programScanner! !

!ProgramScanner class methodsFor: 'examples' stamp: 'nishis 6/20/1998 04:04'!
example3
	"ProgramScanner example3."

	| aClass aSelector programScanner |
	aClass := Number.
	aSelector := #floor.
	programScanner := ProgramScanner class: aClass selector: aSelector.
	Transcript cr; show: programScanner printString.
	Transcript cr; show: programScanner messageSelectors printString.
	^programScanner! !

!ProgramScanner class methodsFor: 'examples' stamp: 'nishis 6/27/1998 02:37'!
example4
	"ProgramScanner example4."
	"Time millisecondsToRun: [ProgramScanner example4]."

	| total block scanner |
	total := 0.
	block := [:class | class selectors
				do: 
					[:selector | 
					scanner := ProgramScanner class: class selector: selector.
					total := total + scanner numberOfMessages]].
	block value: Point.
	block value: Point class.
	^total! !

!ProgramScanner class methodsFor: 'examples' stamp: 'nishis 6/30/1998 23:20'!
example5
	"ProgramScanner example5."
	"Transcript cr; show: (Time millisecondsToRun: [ProgramScanner example5]) printString."
"using instVarAt: 1315844"
"using instVarNamed: 1476741"

	| total block count scanner |
	total := 0.
	block := [:class | class selectors
				do: 
					[:selector | 
					scanner := ProgramScanner class: class selector: selector.
					total := total + scanner numberOfMessages]].
	count := 0.
	Cursor execute showWhile: 
		[Smalltalk allBehaviorsDo: [:behavior | 
			behavior isMeta
				ifFalse: 
					[Transcript cr; show: behavior printString.
					block value: behavior.
					block value: behavior class.
					count := count + 1]]].
	^(total / count) rounded! !

!ProgramScanner class methodsFor: 'examples' stamp: 'nishis 6/29/1998 04:49'!
example6
	"ProgramScanner example6."

	| programScanner |
	programScanner := ProgramScanner method: [#('a' 'b' 'c' 'd' 'e') select: [:each | each > 'c']] method. 
	Transcript cr; show: programScanner printString.
	^programScanner! !
