'Goodies (11/18/2001 8:35:11 am)'.!


StringHolder subclass: #PluggableStringHolderModel
	instanceVariableNames: 'selectionMenu '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pluggable-Support'!
!PluggableStringHolderModel commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
PluggableStringHolderModel (Pluggable-StringHolderMVC)
Goodies for Squeak 1.31
This goodies for Squeak from Mr. AOKI
!


!PluggableStringHolderModel methodsFor: 'initialize-release'!
defaultBackgroundColor
	^#white! !


!PluggableStringHolderModel methodsFor: 'accessing' stamp: 'nishis 4/26/98 21:06'!
textCollector
	^Transcript! !


!PluggableStringHolderModel methodsFor: 'pluggable messages'!
menu
	| collection |
	selectionMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'find...' -> #find.
			collection add: 'find again' -> #findAgain.
			collection add: 'set search string' -> #setSearchString.
			collection add: nil.
			collection add: 'do again' -> #again.
			collection add: 'undo' -> #undo.
			collection add: nil.
			collection add: 'copy' -> #copySelection.
			collection add: 'cut' -> #cut.
			collection add: 'paste' -> #paste.
			collection add: nil.
			collection add: 'do it' -> #doIt.
			collection add: 'print it' -> #printIt.
			collection add: 'inspect it' -> #inspectIt.
			collection add: nil.
			collection add: 'accept' -> #accept.
			collection add: 'cancel' -> #cancel.
			collection add: nil.
			collection add: 'doSomething' -> #doSomething.
			collection add: 'doSomething:' -> #doSomething:.
			collection add: 'doSomething:with:' -> #doSomething:with:.
			collection add: 'doSomething:with:with:' -> #doSomething:with:with:.
			selectionMenu := self makeSelectionMenu: collection].
	^selectionMenu! !


!PluggableStringHolderModel methodsFor: 'menu messages'!
doSomething
	self textCollector cr; show: thisContext printString! !

!PluggableStringHolderModel methodsFor: 'menu messages'!
doSomething: selectedString
	self textCollector cr; show: thisContext printString.
	self textCollector cr; tab; show: '1st argument is ' , selectedString printString! !

!PluggableStringHolderModel methodsFor: 'menu messages'!
doSomething: selectedString with: wholeString
	self textCollector cr; show: thisContext printString.
	self textCollector cr; tab; show: '1st argument is ' , selectedString printString.
	self textCollector cr; tab; show: '2nd argument is ' , wholeString printString! !

!PluggableStringHolderModel methodsFor: 'menu messages'!
doSomething: selectedString with: wholeString with: aController
	self textCollector cr; show: thisContext printString.
	self textCollector cr; tab; show: '1st argument is ' , selectedString printString.
	self textCollector cr; tab; show: '2nd argument is ' , wholeString printString.
	self textCollector cr; tab; show: '3rd argument is ' , aController printString! !


!PluggableStringHolderModel methodsFor: 'private'!
makeSelectionMenu: aCollection
	| labels lines selectors |
	aCollection isEmpty ifTrue: [^nil].
	labels := OrderedCollection new.
	lines := OrderedCollection new.
	selectors := OrderedCollection new.
	aCollection do: [:association |
		association isNil
			ifTrue: [lines add: labels size]
			ifFalse:
				[labels add: association key.
				selectors add: association value]].
	^SelectionMenu 
		labelList: labels asArray
		lines: lines asArray
		selections: selectors asArray! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PluggableStringHolderModel class
	instanceVariableNames: ''!

!PluggableStringHolderModel class methodsFor: 'examples'!
example1
	"PluggableStringHolderModel example1."

	| aPluggableStringHolderModel aPluggableStringHolderView aStandardSystemView |
	aPluggableStringHolderModel := PluggableStringHolderModel new.
	aPluggableStringHolderView := PluggableStringHolderView
			on: aPluggableStringHolderModel
			aspect: #contents
			change: #contents:
			menu: #menu.
	aPluggableStringHolderView borderWidth: 1.
	aStandardSystemView := StandardSystemView new.
	aStandardSystemView borderWidth: 1.
	aStandardSystemView model: aPluggableStringHolderModel.
	aStandardSystemView addSubView: aPluggableStringHolderView.
	aStandardSystemView label: 'Pluggable String Holder'.
	aStandardSystemView minimumSize: 100 @ 50.
	aStandardSystemView controller open! !
