'Goodies (11/18/2001 8:35:18 am)'.!


PrologString subclass: #PrologVariable
	instanceVariableNames: ''
	classVariableNames: 'PrologVariableCounter PrologVariableTable '
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologVariable commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologVariable methodsFor: 'testing'!
isPrologVariable
	^true! !


!PrologVariable methodsFor: 'printing'!
printPrologOn: aStream 
	(self asString at: 1)
		= $~
		ifTrue: [aStream nextPut: $~]
		ifFalse: [aStream nextPutAll: self asString]! !

!PrologVariable methodsFor: 'printing'!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologVariable class
	instanceVariableNames: ''!

!PrologVariable class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologVariable class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologVariable class methodsFor: 'copyright'!
version
	^'003'! !


!PrologVariable class methodsFor: 'class initialization'!
initialize
	"PrologVariable initialize"

	self setZero.
	PrologVariableTable := Dictionary new! !


!PrologVariable class methodsFor: 'instance creation'!
install: aString 
	| variable key |
	variable := PrologVariableTable at: aString ifAbsent: [nil].
	variable == nil
		ifTrue: 
			[key := aString.
			variable := self fromString: aString.
			PrologVariableTable at: key put: variable].
	^variable! !

!PrologVariable class methodsFor: 'instance creation'!
readFrom: aStream 
	| map buffer char |
	map := PrologCharMap variableMap.
	buffer := WriteStream on: (String new: 20).
	char := aStream peek.
	(char ~~ nil and: [char = $~])
		ifTrue: 
			[aStream next.
			self countUp.
			^self install: '~' , PrologVariableCounter printString].
	[char ~~ nil and: [map at: char asInteger]]
		whileTrue: 
			[buffer nextPut: aStream next.
			char := aStream peek].
	^self install: buffer contents! !


!PrologVariable class methodsFor: 'private'!
countUp
	PrologVariableCounter := PrologVariableCounter + 1! !

!PrologVariable class methodsFor: 'private'!
setZero
	PrologVariableCounter := 0! !


PrologVariable initialize!
