'Goodies (11/18/2001 8:35:18 am)'.!


Object subclass: #CursorAnimator
	instanceVariableNames: 'cursors tick '
	classVariableNames: 'ClockCursors HandCursors '
	poolDictionaries: ''
	category: 'Goodies-Progress'!
!CursorAnimator commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Cursor Animator
Goodies for Squeak 2.3 bata

Broken English description

Cursor Animator
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CursAnim.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CursAnim.txt


Summary:

Here are many cases that notify the condition of progressing 
such as progress dialog, etc.  But in Smalltalk, it is shown 
by changing mouse cursor conventionally.  This mouse cursor 
animation goodies is based on it.


Installing:

FileIn this goodies and makes a class "CursorAnimator" in a 
category "Goodies-Progress". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"CursorAnimator" from your system, simply.


how to use:

Here are 2 sample animation for long task.

"living watch"
| cursorAnimator |
cursorAnimator := CursorAnimator clockCursors.
cursorAnimator showWhile: ["long task"].

"hand counting"
| cursorAnimator |
cursorAnimator := CursorAnimator handCursors.
cursorAnimator showWhile: ["long task"].

Using is same as Cursor write showWhile: [].  But the receiver 
of it is the instance of CursorAnimator.

Here is a sample that shows all cursors in your image with 
animation.

| cursorAnimator cursorCollection |
cursorAnimator := CursorAnimator new.
cursorCollection := OrderedCollection new.
" ***** VisualWorks 2.5 and VisualWave 1.0 *****
#(
#blank #bottomLeft #bull #caret #compactMemory 
#corner #crossHair #database #down #execute 
#garbage #hand #marker #normal #origin 
#quickGarbage #read #scroll #square #thumbsDown 
#thumbsUp #topRight #up #wait #write
)
"
#(
	#blank #bottomLeft #bottomRight #corner #crossHair
	#down #execute #marker #menu #move #normal
	#origin #read #rightArrow #square #topLeft #topRight
	#up #wait #write
)
    do: [:s | cursorCollection add: (Cursor perform: s)].
cursorAnimator cursors: cursorCollection.
cursorAnimator tick: 500.
cursorAnimator showWhile: [(Delay forSeconds: 20) wait].

See the second line from last.  The instance of cursorAnimator 
knows from "tick:" message when changes its mouse cursor.  
This unit is milliseconds.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CursAnim.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CursAnim.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!CursorAnimator methodsFor: 'accessing'!
cursors
	cursors isNil ifTrue: [cursors := OrderedCollection new].
	^cursors! !

!CursorAnimator methodsFor: 'accessing'!
cursors: cursorCollection 
	cursors := cursorCollection asOrderedCollection! !

!CursorAnimator methodsFor: 'accessing' stamp: 'nishis 5/17/98 16:33'!
tick
	tick isNil ifTrue: [tick := 250].
	^tick! !

!CursorAnimator methodsFor: 'accessing'!
tick: milliseconds 
	tick := 10 max: (milliseconds min: 10000)! !


!CursorAnimator methodsFor: 'animation' stamp: 'nishis 5/17/98 16:49'!
showWhile: aBlock 
	(self cursors size = 1)
		ifTrue: [^self showWhileWithNoAmination: aBlock].
	^self showWhile: aBlock interim: nil! !

!CursorAnimator methodsFor: 'animation' stamp: 'nishis 1/4/1999 10:07'!
showWhile: aBlock interim: interimBlock 
	| cursor process result index |
	cursor := Cursor currentCursor.
	process := [
			[index := 1.
			[true]
				whileTrue: 
					[(Delay forMilliseconds: self tick) wait.
					interimBlock notNil ifTrue: [interimBlock value].
					index <= self cursors size
						ifTrue: 
							[(self cursors at: index) show.
							index := index + 1.
							index > cursors size ifTrue: [index := 1]]]] 
				ifError: [:err :rcvr | cursor show]] newProcess.
	process priority: Processor userInterruptPriority.
	process resume.
	[result := aBlock value.
	cursor show.
	process terminate]
		ifError: 
			[:err :rcvr | 
			cursor show.
			process terminate].
	^result! !

!CursorAnimator methodsFor: 'animation' stamp: 'nishis 5/17/98 16:56'!
showWhileWithNoAmination: aBlock 
	| cursor result |
	cursor := Cursor currentCursor.
	self cursors first show.
	result := aBlock value.
	cursor show.
	^result! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CursorAnimator class
	instanceVariableNames: ''!

!CursorAnimator class methodsFor: 'copyright' stamp: 'nishis 12/12/1998 13:57'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!CursorAnimator class methodsFor: 'copyright' stamp: 'nishis 12/12/1998 13:58'!
system
	^'Goodies'! !

!CursorAnimator class methodsFor: 'copyright' stamp: 'nishis 12/12/1998 13:58'!
version
	^'003'! !


!CursorAnimator class methodsFor: 'class initialization' stamp: 'nishis 12/12/1998 22:33'!
flushCursors
	"CursorAnimator flushCursors."

	ClockCursors := nil.
	HandCursors := nil! !

!CursorAnimator class methodsFor: 'class initialization' stamp: 'nishis 12/12/1998 22:33'!
initialize
	"CursorAnimator initialize."

	self flushCursors! !

!CursorAnimator class methodsFor: 'class initialization' stamp: 'nishis 12/12/1998 22:33'!
install
	"CursorAnimator install."

	self clockCursors.
	self handCursors! !


!CursorAnimator class methodsFor: 'instance creation' stamp: 'nishis 5/17/98 16:10'!
clockCursors
	| cursorCollection |
	cursorCollection := OrderedCollection new.
	cursorCollection add: self clockCursor0.
	cursorCollection add: self clockCursor1.
	cursorCollection add: self clockCursor2.
	cursorCollection add: self clockCursor3.
	cursorCollection add: self clockCursor4.
	cursorCollection add: self clockCursor5.
	cursorCollection add: self clockCursor6.
	cursorCollection add: self clockCursor7.
	^super new cursors: cursorCollection! !

!CursorAnimator class methodsFor: 'instance creation' stamp: 'nishis 5/17/98 16:10'!
handCursors
	| cursorCollection |
	cursorCollection := OrderedCollection new.
	cursorCollection add: self handCursor0.
	cursorCollection add: self handCursor1.
	cursorCollection add: self handCursor2.
	cursorCollection add: self handCursor3.
	cursorCollection add: self handCursor4.
	cursorCollection add: self handCursor5.
	cursorCollection add: self handCursor4.
	cursorCollection add: self handCursor3.
	cursorCollection add: self handCursor2.
	cursorCollection add: self handCursor1.
	^super new cursors: cursorCollection! !

!CursorAnimator class methodsFor: 'instance creation'!
new
	^super new cursors: OrderedCollection new! !


!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:14'!
clockCursor0
	"CursorAnimator clockCursor0."
	"
	CursorAnimator clockCursor0 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000010001000000
2r1000010001000000
2r1000010001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:14'!
clockCursor1
	"CursorAnimator clockCursor1."
	"
	CursorAnimator clockCursor1 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000101000000
2r1000001001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:15'!
clockCursor2
	"CursorAnimator clockCursor2."
	"
	CursorAnimator clockCursor2 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001111101100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:15'!
clockCursor3
	"CursorAnimator clockCursor3."
	"
	CursorAnimator clockCursor3 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001110001100000
2r1000001001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:16'!
clockCursor4
	"CursorAnimator clockCursor4."
	"
	CursorAnimator clockCursor4 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001110001100000
2r1000010001000000
2r1000010001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:16'!
clockCursor5
	"CursorAnimator clockCursor5."
	"
	CursorAnimator clockCursor5 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001110001100000
2r1000100001000000
2r1001000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:16'!
clockCursor6
	"CursorAnimator clockCursor6."
	"
	CursorAnimator clockCursor6 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1011110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:17'!
clockCursor7
	"CursorAnimator clockCursor7."
	"
	CursorAnimator clockCursor7 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1001000001000000
2r1000100001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:17'!
handCursor0
	"CursorAnimator handCursor0."
	"
	CursorAnimator handCursor0 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000110000000
2r0001101001110000
2r0010011001001000
2r0010011001001010
2r0001001001001101
2r0001001001001001
2r0110100000001001
2r1001100000000001
2r1000100000000010
2r0100000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000110000000
2r0001101111110000
2r0011111111111000
2r0011111111111010
2r0001111111111111
2r0001111111111111
2r0110111111111111
2r1111111111111111
2r1111111111111110
2r0111111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:17'!
handCursor1
	"CursorAnimator handCursor1."
	"
	CursorAnimator handCursor1 show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000110000000
2r0001101001110000
2r0010011001001000
2r0010011001001010
2r0001001001001101
2r0001001001001001
2r0000100000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000110000000
2r0001101111110000
2r0011111111111000
2r0011111111111010
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor2
	"CursorAnimator handCursor2."
	"
	CursorAnimator handCursor2 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000110000000
2r0000001001110000
2r0000001001001000
2r0000001001001010
2r0000111001001101
2r0001001001001001
2r0001000000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000110000000
2r0000001111110000
2r0000001111111000
2r0000001111111010
2r0000111111111111
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor3
	"CursorAnimator handCursor3."
	"
	CursorAnimator handCursor3 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000000000000
2r0000000000110000
2r0000000001001000
2r0000000001001010
2r0000110111001101
2r0001001001001001
2r0001000000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000000000000
2r0000000000110000
2r0000000001111000
2r0000000001111010
2r0000110111111111
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor4
	"CursorAnimator handCursor4."
	"
	CursorAnimator handCursor4 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000010
2r0000110110110101
2r0001001001001001
2r0001000000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000010
2r0000110110110111
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!CursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor5
	"CursorAnimator handCursor5."
	"
	CursorAnimator handCursor5 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000110110110000
2r0001001001001100
2r0001000000001010
2r0000100000000010
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000110110110000
2r0001111111111100
2r0001111111111110
2r0000111111111110
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !


!CursorAnimator class methodsFor: 'saving' stamp: 'nishis 12/12/1998 13:38'!
save
	"CursorAnimator save."

	| fileName classCollection aStream timeStamp |
	fileName := 'CursAnim.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!CursorAnimator class methodsFor: 'saving' stamp: 'nishis 12/12/1998 13:35'!
saveClasses
	"CursorAnimator saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*CursorAnimator*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := ChangeSet superclassOrder: classCollection.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!CursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example1
	"CursorAnimator example1."

	| cursorAnimator cursorCollection |
	cursorAnimator := CursorAnimator new.
	cursorCollection := OrderedCollection new.
	(Parser new scanTokens: '
	#blank #bottomLeft #bottomRight #corner #crossHair
	#down #execute #marker #menu #move #normal
	#origin #read #rightArrow #square #topLeft #topRight
	#up #wait #write
	')
		do: [:each | cursorCollection add: (Cursor perform: each)].
	cursorAnimator cursors: cursorCollection.
	cursorAnimator showWhile: [10000000 timesRepeat: []].
	^cursorAnimator! !

!CursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example2
	"CursorAnimator example2."

	| cursorAnimator |
	cursorAnimator := CursorAnimator clockCursors.
	cursorAnimator tick: 125.
	cursorAnimator showWhile: [10000000 timesRepeat: []].
	^cursorAnimator! !

!CursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example3
	"CursorAnimator example3."

	| cursorAnimator |
	cursorAnimator := CursorAnimator handCursors.
	cursorAnimator tick: 300.
	cursorAnimator showWhile: [10000000 timesRepeat: []].
	^cursorAnimator! !

!CursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example4
	"CursorAnimator example4."

	| cursorAnimator |
	cursorAnimator := CursorAnimator clockCursors.
	cursorAnimator showWhileWithNoAmination: [10000000 timesRepeat: []].
	^cursorAnimator! !

!CursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example5
	"CursorAnimator example5."

	| cursorAnimator |
	cursorAnimator := CursorAnimator handCursors.
	cursorAnimator showWhileWithNoAmination: [10000000 timesRepeat: []].
	^cursorAnimator! !


!CursorAnimator class methodsFor: 'private' stamp: 'nishis 12/12/1998 22:25'!
extent: extentPoint fromArray: anArray mask: maskArray offset: offsetPoint
	| cursorMaker |
	cursorMaker := Smalltalk at: #CursorWithMask ifAbsent: [nil].
	cursorMaker isNil 
		ifTrue: 
			[^self extent: extentPoint fromArray: anArray offset: offsetPoint].
	^(cursorMaker 
			extent: extentPoint 
			fromArray: anArray
			offset: offsetPoint * -1)
		setMaskForm: 
			(Form 
				extent: extentPoint
				fromArray: (maskArray collect: [:bits | bits bitShift: 16]) 
				offset: 0 @ 0)! !

!CursorAnimator class methodsFor: 'private' stamp: 'nishis 12/12/1998 22:12'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	^Cursor extent: extentPoint fromArray: anArray offset: offsetPoint * -1! !


CursorAnimator initialize!
