'Goodies (11/18/2001 8:35:19 am)'.!


PrologList subclass: #PrologTerms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologTerms commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologTerms methodsFor: 'printing'!
printPrologOn: aStream 
	| list |
	aStream nextPut: $(.
	list := self.
	[list cdr consp]
		whileTrue: 
			[list ~~ self ifTrue: [aStream nextPut: $,].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self ifTrue: [aStream nextPut: $,].
	list car printPrologOn: aStream.
	list cdr isNil
		ifTrue: [aStream nextPut: $)]
		ifFalse:
			[aStream nextPut: $|.
			list cdr printPrologOn: aStream.
			aStream nextPut: $)]! !

!PrologTerms methodsFor: 'printing'!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !


!PrologTerms methodsFor: 'private'!
fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse! !

!PrologTerms methodsFor: 'private'!
fromReverseList: aPrologDotPair 
	| list terms mark |
	list := aPrologDotPair.
	terms := nil.
	[list consp]
		whileTrue: 
			[terms == nil
				ifTrue: [terms := mark := self class term: list car next: terms]
				ifFalse: [terms := self class term: list car next: terms].
			list := list cdr].
	mark cdr: list.
	^terms! !

!PrologTerms methodsFor: 'private'!
term: anObject next: link 
	carPart := anObject.
	cdrPart := link! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologTerms class
	instanceVariableNames: ''!

!PrologTerms class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologTerms class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologTerms class methodsFor: 'copyright'!
version
	^'003'! !


!PrologTerms class methodsFor: 'instance creation'!
fromList: aPrologDotPair 
	^super new fromList: aPrologDotPair! !

!PrologTerms class methodsFor: 'instance creation'!
fromReverseList: aPrologDotPair 
	^super new fromReverseList: aPrologDotPair! !

!PrologTerms class methodsFor: 'instance creation'!
term: term next: link 
	^super new term: term next: link! !
