'Goodies (11/18/2001 8:35:19 am)'.!


PrologList subclass: #PrologBody
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologBody commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologBody methodsFor: 'printing'!
prettyPrintPrologOn: aStream 
	| list |
	list := self.
	aStream cr; tab.
	[list cdr consp]
		whileTrue: 
			[list ~~ self
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream cr; tab].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self
		ifTrue: 
			[aStream nextPutAll: ', '.
			aStream cr; tab].
	list car printPrologOn: aStream! !

!PrologBody methodsFor: 'printing'!
printPrologOn: aStream 
	| list |
	list := self.
	[list cdr consp]
		whileTrue: 
			[list ~~ self ifTrue: [aStream nextPutAll: ', '].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self ifTrue: [aStream nextPutAll: ', '].
	list car printPrologOn: aStream! !

!PrologBody methodsFor: 'printing'!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !


!PrologBody methodsFor: 'private'!
fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse! !

!PrologBody methodsFor: 'private'!
fromReverseList: aPrologDotPair 
	| list body mark |
	list := aPrologDotPair.
	body := nil.
	[list consp]
		whileTrue: 
			[body == nil
				ifTrue: [body := mark := self class structure: list car next: body]
				ifFalse: [body := self class structure: list car next: body].
			list := list cdr].
	mark cdr: list.
	^body! !

!PrologBody methodsFor: 'private'!
structure: aPrologStructure next: link 
	carPart := aPrologStructure.
	cdrPart := link! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologBody class
	instanceVariableNames: ''!

!PrologBody class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologBody class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologBody class methodsFor: 'copyright'!
version
	^'003'! !


!PrologBody class methodsFor: 'instance creation'!
fromList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromList: aPrologDotPair! !

!PrologBody class methodsFor: 'instance creation'!
fromReverseList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromReverseList: aPrologDotPair! !

!PrologBody class methodsFor: 'instance creation'!
structure: aPrologStructure next: link 
	^super new structure: aPrologStructure next: link! !
