'Goodies (11/18/2001 8:34:49 am)'.!


StringHolderController subclass: #PluggableStringHolderController
	instanceVariableNames: 'localMenuSelectors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pluggable-Support'!
!PluggableStringHolderController commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
PluggableStringHolderController (Pluggable-StringHolderMVC)
Goodies for Squeak 1.31
This goodies for Squeak from Mr. AOKI
!


!PluggableStringHolderController methodsFor: 'initialize-release'!
initialize
	super initialize.
	localMenuSelectors := #(find findAgain setSearchString again undo copySelection cut paste doIt printIt inspectIt accept cancel)! !


!PluggableStringHolderController methodsFor: 'accessing'!
localMenuSelectors
	^localMenuSelectors! !

!PluggableStringHolderController methodsFor: 'accessing'!
localMenuSelectors: selectorArray
	localMenuSelectors := selectorArray! !


!PluggableStringHolderController methodsFor: 'menu messages' stamp: 'nishis 6/12/1998 02:11'!
accept 
	super accept.
	initialText := paragraph text copy.
	"view ifNotNil: [view accepted]."
	self view contents: paragraph string.
	"self unlockModel"! !

!PluggableStringHolderController methodsFor: 'menu messages' stamp: 'nishis 4/26/98 21:15'!
yellowButtonActivity
	| menu selector |
	menu := self view menu.
	menu isNil
		ifTrue: [super controlActivity]
		ifFalse: 
			[selector := menu startUp.
			selector isNil 
				ifFalse:
					[(self localMenuSelectors includes: selector)
						ifTrue: [self menuMessageReceiver performMenuMessage: selector]
						ifFalse: [self sendMenuMessageToModel: selector]]]! !


!PluggableStringHolderController methodsFor: 'pluggable support'!
sendMenuMessageToModel: selector
	| kind arguments |
	self controlTerminate.
	kind := selector numArgs.
	arguments := nil.
	kind = 0 ifTrue: [arguments := Array new].
	kind = 1 ifTrue: [arguments := Array with: self selection asString].
	kind = 2 ifTrue: [arguments := Array with: self selection asString with: paragraph asString].
	kind = 3 ifTrue: [arguments := Array with: self selection asString with: paragraph asString with: self].
	arguments notNil ifTrue: [self model perform: selector withArguments: arguments].
	self controlInitialize! !
