'Goodies (11/18/2001 8:34:50 am)'.!


Model subclass: #GaugeModel
	instanceVariableNames: 'gaugeValue gaugeRange dialog which '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Gauge'!
!GaugeModel commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Gauge MVC
Goodies for Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Gauge MVC
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Gauge.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Gauge.txt


Summary:

This Goodies is a gauge to handle a visualized numerical 
information on MVC style.


How to install:

FileIn this goodies and makes classes below in a category 
"Goodies-Gauge". 

GaugeController
GaugeModel
GaugeView

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove these classes 
"GaugeController", "GaugeModel", "GaugeView" from your system, 
simply.


how to use:

This pattern is to open a gauge on a window type.  You can 
set values at minimum value, maximum value, number of scales, 
range.

(GaugeModel value: 20) open
(GaugeModel value: -20 range: #(-100 100 10 1)) open

The pettern below is to open a gauge on a dialog.  It uses 
for input a number with mouse.

GaugeModel request: 20
GaugeModel request: -20 range: #(-100 100 10 5)


Attention!!

1) This implementation of a dialog type gauge has curious behavior. 
For closing dialog, you must click button and mouse move away from 
a view holding these buttons.

2) GaugeModel(class)>>example2 doesn't work.  Because Squeak ignores 
any statement after to open some window.  Instead of this, you can 
evaluate below, 

	| gaugeModel |
	gaugeModel := GaugeModel value: -20 range: #(-100 100 10 1).
	gaugeModel inspect.
	^gaugeModel

At a inspector, type 

	self open.
	(repeat as you like)

and paste below, select, and do it!!

	[(Delay forMilliseconds: 1000) wait.
	-100 to: 100
		do: 
			[:n | 
			(Delay forMilliseconds: 10) wait.
			self value: n]] fork.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Gauge.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Gauge.txt
QƂĂB


!!

1) _CAO^̃Q[WoꍇAIɂ "Accept", "Cancel" 
ꂩ̃{^NbNƁA}EX̃{^ڂĂ
r[OĂBȂƕ܂B

2) GaugeModel(class)>>example2 ́AƓ܂Bŏ 
	gaugeModel open.
sƁA㑱 statement ͎sȂ悤łB
@́AsłB

ŁAƂ肠LŎĂ݂ĂB

	| gaugeModel |
	gaugeModel := GaugeModel value: -20 range: #(-100 100 10 1).
	gaugeModel inspect.
	^gaugeModel

ŃCXyN^J܂B̒

	self open.
	(repeat as you like)

ŁADȂQ[WJ܂B

	[(Delay forMilliseconds: 1000) wait.
	-100 to: 100
		do: 
			[:n | 
			(Delay forMilliseconds: 10) wait.
			self value: n]] fork.

ŁAAj[Vς邱Ƃł܂B

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!GaugeModel methodsFor: 'accessing'!
range
	gaugeRange isNil ifTrue: [gaugeRange := #(0 100 10 1) copy].
	^gaugeRange! !

!GaugeModel methodsFor: 'accessing'!
range: anArray 
	gaugeRange := anArray! !

!GaugeModel methodsFor: 'accessing'!
value
	gaugeValue isNil ifTrue: [self value: 0].
	^gaugeValue! !

!GaugeModel methodsFor: 'accessing' stamp: 'nishis 5/5/98 00:42'!
value: aNumber 
	| value |
	(aNumber respondsTo: #value)
		ifTrue: [value := aNumber value]
		ifFalse: [value := aNumber].
	((value isKindOf: Number)
		and: [gaugeValue ~= value])
		ifTrue: 
			[gaugeValue := value.
			self changed: #value]! !

!GaugeModel methodsFor: 'accessing' stamp: 'nishis 5/4/98 19:18'!
which
	^which! !

!GaugeModel methodsFor: 'accessing' stamp: 'nishis 5/4/98 19:19'!
which: aSymbol
	which := aSymbol! !


!GaugeModel methodsFor: 'interface opening'!
createGaugeView
	| aView |
	aView := GaugeView
				on: self
				get: #value
				put: #value:
				valuesMinMaxDivideRound: self range.
	^aView! !

!GaugeModel methodsFor: 'interface opening' stamp: 'nishis 6/10/1998 00:56'!
open
	"GaugeModel new open."

	| topView gaugeView |
	topView := ScheduledView 
				model: nil 
				label: 'Gauge' 
				minimumSize: 64 @ 128.
	topView := StandardSystemView new.
	gaugeView := self createGaugeView.
	gaugeView borderWidth: 1.
	topView addSubView: gaugeView;
	borderWidth: 1.
	^topView controller open"In: (100 @ 100 corner: 180 @ 280)"! !


!GaugeModel methodsFor: 'interface dialog'!
dialog
	^dialog! !

!GaugeModel methodsFor: 'interface dialog'!
dialog: aSimpleDialog 
	dialog := aSimpleDialog! !


!GaugeModel methodsFor: 'printing'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' on: '.
	self value printOn: aStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GaugeModel class
	instanceVariableNames: ''!

!GaugeModel class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!GaugeModel class methodsFor: 'copyright'!
system
	^'Goodies'! !

!GaugeModel class methodsFor: 'copyright'!
version
	^'003'! !


!GaugeModel class methodsFor: 'instance creation' stamp: 'nishis 5/4/98 13:09'!
new
	| gaugeModel |
	gaugeModel := super new.
	gaugeModel value: 0.
	gaugeModel range: nil.
	^gaugeModel! !

!GaugeModel class methodsFor: 'instance creation'!
value: aNumber 
	^self value: aNumber range: nil! !

!GaugeModel class methodsFor: 'instance creation'!
value: aNumber range: anArray 
	| gaugeModel |
	gaugeModel := self new.
	gaugeModel value: aNumber.
	gaugeModel range: anArray.
	^gaugeModel! !


!GaugeModel class methodsFor: 'utilities'!
request: aNumber 
	"GaugeModel request: 20."

	^self request: aNumber range: nil! !

!GaugeModel class methodsFor: 'utilities' stamp: 'nishis 6/10/1998 00:05'!
request: aNumber range: anArray 
	"GaugeModel request: -20 range: #(-100 100 10 1)."

	| gaugeModel dialogModel view savedArea messageView gaugeView buttonView centerPoint displayRectangle |
	gaugeModel := self value: aNumber range: anArray.
	dialogModel := FillInTheBlank new initialize.
	gaugeModel dialog: dialogModel.

	view := View new model: dialogModel.
	view controller: ModalController new.
	view borderWidth: 2.

	"messageView := FillInTheBlankView buildMessageView: 'Gauge'."
	messageView := self buildMessageView: 'Gauge'.
	messageView window: (100 @ 0 extent: 100 @ 80); backgroundColor: Color lightGray.
	messageView borderWidth: 0.

	gaugeView := gaugeModel createGaugeView.
	gaugeView window: (0 @ 0 extent: 100 @ 180).

	buttonView := self buttonsView: view controller model: gaugeModel.
	buttonView window: (0 @ 0 extent: 100 @ 100).

	view addSubView: messageView.
	view addSubView: buttonView below: messageView.
	view addSubView: gaugeView toLeftOf: messageView.
	view window: (0 @ 0 extent: 200 @ 180).

	centerPoint := Sensor cursorPoint.
	displayRectangle := Display boundingBox 
			insetBy: (((view viewport width // 2) @ (view viewport height // 2)) + 2).
	centerPoint := centerPoint adhereTo: displayRectangle.
	view align: (view viewport center) with: centerPoint.

	savedArea := Form fromDisplay: view displayBox.
	view display.
	view controller startUp.
	view release.
	savedArea displayOn: Display at: view viewport topLeft.
	gaugeModel which = #Accept 
		ifTrue: [^gaugeModel value]
		ifFalse: [^nil]! !


!GaugeModel class methodsFor: 'saving' stamp: 'nishis 6/10/1998 00:36'!
save
	"GaugeModel save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Gauge.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!GaugeModel class methodsFor: 'saving' stamp: 'nishis 5/16/98 00:02'!
saveClasses
	"GaugeModel saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Gauge*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	classCollection add: ScheduledView.
	classCollection add: ScheduledController.
	^classCollection! !


!GaugeModel class methodsFor: 'examples'!
example1
	"GaugeModel example1."

	| gaugeModel |
	gaugeModel := GaugeModel value: 20.
	gaugeModel open.
	^gaugeModel! !

!GaugeModel class methodsFor: 'examples' stamp: 'nishis 5/5/98 01:56'!
example2
	"GaugeModel example2."

	| gaugeModel |
	gaugeModel := GaugeModel value: -20 range: #(-100 100 10 1).
	gaugeModel open.
	gaugeModel open.
	[(Delay forMilliseconds: 1000) wait.
	-100 to: 100
		do: 
			[:n | 
			(Delay forMilliseconds: 10) wait.
			gaugeModel value: n]] fork.
	^gaugeModel! !

!GaugeModel class methodsFor: 'examples'!
example3
	"GaugeModel example3."

	^GaugeModel request: 20! !

!GaugeModel class methodsFor: 'examples'!
example4
	"GaugeModel example4."

	^GaugeModel request: -20 range: #(-100 100 10 5)! !

!GaugeModel class methodsFor: 'examples' stamp: 'nishis 5/15/98 00:12'!
example5
	"GaugeModel example5."

	| gaugeModel |
	gaugeModel := GaugeModel value: -20 range: #(-100 100 10 1).
	^gaugeModel inspect
"do it on a inspector window."
"
	self open.

	[(Delay forMilliseconds: 1000) wait.
	-100 to: 100
		do: 
			[:n | 
			(Delay forMilliseconds: 10) wait.
			self value: n]] fork.
	^gaugeModel"! !


!GaugeModel class methodsFor: 'private' stamp: 'nishis 6/10/1998 00:04'!
buildMessageView: messageString
	"see FillInTheBlankView buildMessageView: on 1.31"
	|  messageView  |
	messageView _ DisplayTextView new model: messageString asDisplayText.
	messageView borderWidthLeft: 2 right: 2 top: 2 bottom: 0.
	messageView controller: NoController new.
	messageView window: (0@0 extent: (messageView window extent max: 200@30)).
	messageView centered.
	^messageView! !

!GaugeModel class methodsFor: 'private' stamp: 'nishis 6/11/1998 21:34'!
buttonView: baseView onAction: aAction label: label extent: extent
	"GaugeModel example3."
	| aSwitchView aSwitch |
	aSwitch := (Button new) onAction: aAction.
	aSwitchView := PluggableButtonView
		on: aSwitch
		getState: #isOff
		action: #switch.
	aSwitchView
		label: label asParagraph;
		window: (0@0 extent:  extent);
		borderWidth: 2;
			foregroundColor: Color black;
			backgroundColor: Color veryVeryLightGray.
	^aSwitchView! !

!GaugeModel class methodsFor: 'private' stamp: 'nishis 11/7/2001 22:32'!
buttonsView: aController model: model
	"GaugeModel request: -20 range: #(-100 100 10 1)."
	| baseView acceptView width height cancelView |
	width := 100.
	height := 100 / 2.
	baseView := View new 
		model: self;
		backgroundColor: Color lightGray;
		window: (0 @ 0 extent: width @ height);
		borderWidth: 0.
	acceptView := self 
		buttonView: baseView 
		onAction: 
			[model which: #Accept.
			aController controlTerminate.
			aController view topView controller close] 
		label: 'Accept' 
		extent: width - 10 @ height - 10.
	baseView 
		addSubView: acceptView 
		align: acceptView viewport topLeft 
		with: baseView window topLeft + (10 @ 10).
	cancelView := self 
		buttonView: baseView 
		onAction: 
			[model which: #Cancel.
			aController controlTerminate.
			aController view topView controller close] 
		label: 'Cancel' 
		extent: width - 10 @ height - 10.
	baseView 
		addSubView: cancelView 
		align: cancelView viewport topLeft 
		with: baseView window topLeft + (10 @ 55).
	^baseView
! !
