'Goodies (11/18/2001 8:34:50 am)'.!


StandardSystemView subclass: #ScheduledView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-ScheduledVC'!
!ScheduledView commentStamp: '<historical>' prior: 0!
Scheduled View and Scheduled Controller
Goodies for Squeak (Smalltalk-80)
Copyright (c) 1986-1998 AOKI Atsushi
1998/01/13

TvF

SqueakStandardSystemViewStandardSystemControllerꉻ
āCg₷ScheduledViewScheduledController񋟂
Bɂ́CCӂ̏ꏊɃEBhEJ߂̋@\t
ĂƋɁCEBhEɕ\̂LbV
ċL܂B

CXg[@F

SchedVC.stoCi[hŃ_E[hCt@CC
(fileIn)ĉBGoodies-ScheduledVCƂJeSɉL
̃NXCXg[܂B

ScheduledController
ScheduledView

gF

̃vO̓EBhEJꏊRectangle fromUserŊl
܂B

| topView |
topView := ScheduledView
	model: nil
	label: nil
	minimumSize: 300 @ 200.
topView controller openIn: Rectangle fromUser

EBhEJʒuw肷ɂ͎̂悤ɂ܂B

| topView |
topView := ScheduledView
	model: nil
	label: nil
	minimumSize: 300 @ 200.
topView controller openAt: 100 @ 100

EBhEJꏊw肷ɂ͎̂悤ɂ܂B

| topView |
topView := ScheduledView
	model: nil
	label: nil
	minimumSize: 300 @ 200.
topView controller openIn: (100 @ 100 extent: topView minimumSize)

------------------------------------------------------------
 ؏~(AOKI Atsushi)      http://www.sra.co.jp/people/aoki 
 Software Research Associates, Inc.   mailto:aoki@sra.co.jp 
 Marusho-Bldg.5F, 3-12 Yotsuya,            Tel:03-3357-9361 
 Shinjuku-ku, Tokyo 160-0004, JAPAN        Fax:03-3351-0880 
------------------------------------------------------------
!


!ScheduledView methodsFor: 'initialize-release'!
initialize
	super initialize.
	self backgroundColor: Color white! !


!ScheduledView methodsFor: 'controller access'!
defaultControllerClass
	^ScheduledController! !


!ScheduledView methodsFor: 'displaying'!
cacheBitsAsTwoTone
	^false! !


!ScheduledView methodsFor: 'deEmphasizing'!
deEmphasizeView
	super deEmphasizeView.
	(self isCollapsed not and: [self subViews isEmpty])
		ifTrue: [self clearInside]! !

!ScheduledView methodsFor: 'deEmphasizing'!
emphasizeView
	super emphasizeView.
	(self isCollapsed not and: [self subViews isEmpty])
		ifTrue: [self clearInside]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScheduledView class
	instanceVariableNames: ''!

!ScheduledView class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1986-1998 AOKI Atsushi, All Rights Reserved.'! !

!ScheduledView class methodsFor: 'copyright'!
system
	^'Goodies'! !

!ScheduledView class methodsFor: 'copyright'!
version
	^'002'! !


!ScheduledView class methodsFor: 'instance creation'!
model: aModel label: aString minimumSize: aPoint
	| scheduledView |
	scheduledView := self new.
	scheduledView model: aModel.
	scheduledView label: aString.
	scheduledView minimumSize: aPoint.
	scheduledView borderWidth: 1.
	^scheduledView! !


!ScheduledView class methodsFor: 'saving'!
save
	"ScheduledView save."

	| patternCollection fileName classCollection fileStream |
	patternCollection := #('*Scheduled*').
	fileName := 'SchedVC.st'.
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection select: [:aClass |
		(patternCollection detect: [:it | it match: aClass name asString] ifNone: [nil]) notNil].
	fileStream := FileStream newFileNamed: fileName.
	Cursor write showWhile: [
		fileStream nextPut: $'.
		fileStream nextPutAll: Date today printString.
		fileStream space.
		fileStream nextPutAll: Time now printString.
		fileStream nextPut: $'.
		fileStream nextChunkPut: String new.
		fileStream cr.
		fileStream cr.
		classCollection
			do: [:aClass |
				fileStream nextChunkPut: aClass definition.
				fileStream cr.
				fileStream cr].
		classCollection
			do: [:aClass |
				fileStream nextPut: Character newPage.
				aClass sharedPools size > 0
					ifTrue: [aClass shouldFileOutPools
						ifTrue: [aClass fileOutSharedPoolsOn: fileStream]].
				aClass fileOutOn: fileStream moveSource: false toFile: 0.
				fileStream cr.
				fileStream cr]].
	fileStream close! !


!ScheduledView class methodsFor: 'examples'!
example1
	"ScheduledView example1."

	| topView |
	topView := ScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200.
	topView controller openIn: (100 @ 100 extent: topView minimumSize)! !

!ScheduledView class methodsFor: 'examples'!
example2
	"ScheduledView example2."

	| topView leftView rightView |
	topView := ScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200.
	leftView := View new.
	leftView borderWidth: 1.
	leftView backgroundColor: Color red.
	topView addSubView: leftView.
	rightView := View new.
	rightView borderWidth: 1.
	rightView backgroundColor: Color green.
	topView addSubView: rightView toRightOf: leftView.
	topView controller openIn: (100 @ 100 extent: topView minimumSize)! !

!ScheduledView class methodsFor: 'examples'!
example3
	"ScheduledView example3."

	| topView leftView rightView |
	topView := ScheduledView
		model: nil
		label: nil
		minimumSize: 300 @ 200.
	leftView := View new.
	leftView borderWidth: 1.
	leftView backgroundColor: Color red.
	topView addSubView: leftView.
	rightView := View new.
	rightView borderWidth: 1.
	rightView backgroundColor: Color green.
	topView addSubView: rightView toRightOf: leftView.
	topView controller openAt: 100 @ 100! !
