'Goodies (11/18/2001 8:35 am)'.!


Controller subclass: #GaugeController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Gauge'!

!GaugeController methodsFor: 'control defaults' stamp: 'nishis 5/5/98 00:40'!
controlActivity
	(self sensor redButtonPressed and: [self viewHasCursor])
		ifTrue: [^self redButtonActivity].
	(self sensor yellowButtonPressed and: [self viewHasCursor])
		ifTrue: [^self yellowButtonActivity].
	(self viewHasCursor and: 
			[((view gaugeBorder extendBy: (0 @ 0 corner: 1 @ 1)) 
					translateBy: view insetDisplayBox origin)
			containsPoint: sensor cursorPoint])
		ifTrue: [Cursor crossHair show]
		ifFalse: [Cursor normal show].
	self redButtonActivity! !

!GaugeController methodsFor: 'control defaults' stamp: 'nishis 5/5/98 00:38'!
redButtonActivity
	| box block point |
	box := view gaugeBorder.
	box := box translateBy: view insetDisplayBox origin.
	block := [:p | box origin <= p and: [p <= box corner]].
	[sensor anyButtonPressed 
		and: 
			[point := sensor cursorPoint.
			block value: point]]
		whileTrue: 
			[Cursor crossHair showWhile: 
				[view setValue: point]]! !

!GaugeController methodsFor: 'control defaults'!
yellowButtonActivity
	self redButtonActivity! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GaugeController class
	instanceVariableNames: ''!

!GaugeController class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!GaugeController class methodsFor: 'copyright'!
system
	^'Goodies'! !

!GaugeController class methodsFor: 'copyright'!
version
	^'003'! !
