'Goodies (11/18/2001 8:35:05 am)'.!


Object subclass: #BrowserMenuEnhancements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Enhancements'!
!BrowserMenuEnhancements commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Browser Menu Enhancements
Goodies for Squeak 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Browser Menu Enhancements
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BrMenuEn.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BrMenuEn.txt


Summary:

This goodies adds menu items for local search or category search 
to yellow button menu of message selector pane of a browser.
It is easy to search implimentor or sender.


How to install:

FileIn this goodies and makes a class "BrowserMenuEnhancements" in a 
category "Goodies-Enhancements". 
AND
4 methods are added in a category "private memu messages" and 2 methods 
are added in a category "private utilities" of the class "Browser".

(private memu messages)
Browser>>categoryImplementors
Browser>>categorySenders
Browser>>localImplementors
Browser>>localSenders

(private utilities)
Browser>>stringMatch: string and: pattern 
Browser>>stringMatch: string sIndex: sindex and: pattern pIndex: pindex 

When you want to restore your image, please remove this class 
"BrowserMenuEnhancements" from your system, simply.
Also a menu items are removed automatically.


How to use:

When you install this goodies, it adds an enhancements for yellow 
button menu of message selector pane.


##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BrMenuEn.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/BrMenuEn.txt
QƂĂB

IWi͎ȊĂAũNX⃁\bhɂ͈؂̕ύX
Ă܂vÃR[hł́A

"Browser"  2 ̃JeS쐬A̒ɁAv 
6 ̃\bh}܂

(private memu messages) JeS
Browser>>categoryImplementors
Browser>>categorySenders
Browser>>localImplementors
Browser>>localSenders

(private utilities) JeS
Browser>>stringMatch: string and: pattern 
Browser>>stringMatch: string sIndex: sindex and: pattern pIndex: pindex 

ӂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BrowserMenuEnhancements class
	instanceVariableNames: 'enhancements '!

!BrowserMenuEnhancements class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!BrowserMenuEnhancements class methodsFor: 'copyright'!
system
	^'Goodies'! !

!BrowserMenuEnhancements class methodsFor: 'copyright'!
version
	^'003'! !


!BrowserMenuEnhancements class methodsFor: 'class initialization' stamp: 'nishis 6/3/1998 18:43'!
induct
	"BrowserMenuEnhancements induct."

	self messageListMenu.
	self stringMatchSIndexAndPIndexInBrowser.
	self stringMatchAndInBrowser.
	self categoryImplementorsInBrowser.
	self categorySendersInBrowser.
	self localImplementorsInBrowser.
	self localSendersInBrowser! !

!BrowserMenuEnhancements class methodsFor: 'class initialization'!
initialize
	"BrowserMenuEnhancements initialize."

	self induct! !

!BrowserMenuEnhancements class methodsFor: 'class initialization'!
install
	"BrowserMenuEnhancements install."

	| default done process count |
	Cursor normal show.
	default := false.
	done := false.
	process := 
			[default := self confirm: 'Do you want to enhance the browser menu?'.
			default ifTrue: [self induct].
			done := true] newProcess.
	process priority: Processor activeProcess priority + 0.
	process resume.
	count := 0.
	[done not and: [count < 10]]
		whileTrue: 
			[count := count + 1.
			(Delay forSeconds: 1) wait].
	process terminate.
	done ifFalse: [default ifTrue: [self induct]]! !

!BrowserMenuEnhancements class methodsFor: 'class initialization'!
obsolete
	self uninduct.
	super obsolete! !

!BrowserMenuEnhancements class methodsFor: 'class initialization' stamp: 'nishis 6/3/1998 18:38'!
uninduct
	| aClass aSelector |
	"BrowserMenuEnhancements uninduct."

	enhancements notNil
		ifTrue: 
			[enhancements copy
				do: 
					[:anArray | 
					aClass := Compiler evaluate: (anArray at: 1)
								logged: false.
					aSelector := anArray at: 3.
					self uninstallEnhanceClass: aClass selector: aSelector.
					aClass organization removeEmptyCategories	"added by nishis, 1998/04/12 11:05"].
			enhancements := nil]! !

!BrowserMenuEnhancements class methodsFor: 'class initialization'!
uninstall
	"BrowserMenuEnhancements uninstall."

	self uninduct! !


!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/20/1998 05:49'!
categoryImplementorsInBrowser
	"BrowserMenuEnhancements categoryImplementorsInBrowser."

	self
		installEnhanceClass: Browser
		protocol: 'private message functions'
		code: 'categoryImplementors
	| aBrowser className aClass aSelector aCategory aClassList aCollection |
	aBrowser := self.
	(aBrowser isKindOf: Browser)
		ifFalse: [^self].
	className := aBrowser selectedClassName.
	aClass := Smalltalk at: className ifAbsent: [nil].
	aClass isNil ifTrue: [^self].
	aSelector := aBrowser selectedMessageName.
	Sensor leftShiftDown
		ifTrue: 
			[aSelector := FillInTheBlank request: ''Please enter selector name'' initialAnswer: aSelector asString.
			aSelector = '''' ifTrue: [^self].
			aSelector := aSelector asSymbol].
	aSelector isNil ifTrue: [^self].
	aClass isMeta
		ifTrue: [aCategory := aClass soleInstance category]
		ifFalse: [aCategory := aClass category].
	aCategory := FillInTheBlank request: ''Please enter category name'' initialAnswer: aCategory asString.
	(aCategory isNil or: [aCategory isEmpty])
		ifTrue: [^self].
	aClassList := OrderedCollection new.
	Smalltalk allBehaviorsDo: [:class | (class isMeta not and: [self stringMatch: class category asString and: aCategory])
			ifTrue: [aClassList add: class]].
	aCollection := SortedCollection new.
	Cursor execute showWhile: [aClassList
			do: 
				[:class | 
				(class includesSelector: aSelector)
					ifTrue: [aCollection add: class name , '' '' , aSelector].
				(class class includesSelector: aSelector)
					ifTrue: [aCollection add: class class name , '' '' , aSelector]]].
	Smalltalk 
		browseMessageList: aCollection 
		name: ''Implementors of '' , aSelector printString, '' (category)'' 
		autoSelect:  ((aSelector isKindOf: LookupKey) 
							ifTrue: [aSelector key] 
							ifFalse: [aSelector keywords first])'! !

!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/20/1998 05:49'!
categorySendersInBrowser
	"BrowserMenuEnhancements categorySendersInBrowser."

	self
		installEnhanceClass: Browser
		protocol: 'private message functions'
		code: 'categorySenders
	| aBrowser className aClass aSelector aCategory aClassList aCollection list |
	aBrowser := self.
	(aBrowser isKindOf: Browser)
		ifFalse: [^self].
	className := aBrowser selectedClassName.
	aClass := Smalltalk at: className ifAbsent: [nil].
	aClass isNil ifTrue: [^self].
	aSelector := aBrowser selectedMessageName.
	Sensor leftShiftDown
		ifTrue: 
			[aSelector := FillInTheBlank request: ''Please enter selector name'' initialAnswer: aSelector asString.
			(aSelector isNil or: [aSelector isEmpty])
				ifTrue: [^self].
			aSelector := aSelector asSymbol].
	aSelector isNil ifTrue: [^self].
	aClass isMeta
		ifTrue: [aCategory := aClass soleInstance category]
		ifFalse: [aCategory := aClass category].
	aCategory := FillInTheBlank request: ''Please enter category name'' initialAnswer: aCategory asString.
	(aCategory isNil or: [aCategory isEmpty])
		ifTrue: [^self].
	aClassList := OrderedCollection new.
	Smalltalk allBehaviorsDo: [:class | (class isMeta not and: [self stringMatch: class category asString and: aCategory])
			ifTrue: [aClassList add: class]].
	aCollection := SortedCollection new.
	Cursor execute showWhile: [aClassList
			do: 
				[:class | 
				list := class whichSelectorsReferTo: aSelector.
				list size > 0 ifTrue: [list do: [:selector | aCollection add: class name , '' '' , selector]].
				list := class class whichSelectorsReferTo: aSelector.
				list size > 0 ifTrue: [list do: [:selector | aCollection add: class class name , '' '' , selector]]]].
	Smalltalk 
		browseMessageList: aCollection 
		name: ''Senders of '' , aSelector printString, '' (category)'' 
		autoSelect:  ((aSelector isKindOf: LookupKey) 
							ifTrue: [aSelector key] 
							ifFalse: [aSelector keywords first])'! !

!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/20/1998 05:49'!
localImplementorsInBrowser
	"BrowserMenuEnhancements localImplementorsInBrowser."

	self
		installEnhanceClass: Browser
		protocol: 'private message functions'
		code: 'localImplementors
	| aBrowser className aClass aSelector aCollection anOrderedCollection |
	aBrowser := self.
	(aBrowser isKindOf: Browser)
		ifFalse: [^self].
	className := aBrowser selectedClassName.
	aClass := Smalltalk at: className ifAbsent: [nil].
	aClass isNil ifTrue: [^self].
	aClass isMeta ifTrue: [aClass := aClass soleInstance].
	aSelector := aBrowser selectedMessageName.
	Sensor leftShiftDown
		ifTrue: 
			[aSelector := FillInTheBlank request: ''Please enter selector name'' initialAnswer: aSelector asString.
			aSelector = '''' ifTrue: [^self].
			aSelector := aSelector asSymbol].
	aSelector isNil ifTrue: [^self].
	aCollection := SortedCollection new.
	aCollection := SortedCollection new.
	anOrderedCollection := OrderedCollection new.
	anOrderedCollection addAll: aClass allSuperclasses asOrderedCollection.
	anOrderedCollection addAll: aClass withAllSubclasses asOrderedCollection.
	Cursor execute showWhile: [anOrderedCollection 
			do: 
				[:class | 
				(class includesSelector: aSelector)
					ifTrue: [aCollection add: class name , '' '' , aSelector].
				(class class includesSelector: aSelector)
					ifTrue: [aCollection add: class class name , '' '' , aSelector]]].
	Smalltalk 
		browseMessageList: aCollection 
		name: ''Implementors of '' , aSelector printString, '' (local)''  
		autoSelect:  ((aSelector isKindOf: LookupKey) 
							ifTrue: [aSelector key] 
							ifFalse: [aSelector keywords first])'! !

!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/20/1998 05:49'!
localSendersInBrowser
	"BrowserMenuEnhancements localSendersInBrowser."

	self
		installEnhanceClass: Browser
		protocol: 'private message functions'
		code: 'localSenders
	| aBrowser className aClass aSelector aCollection list anOrderedCollection |
	aBrowser := self.
	(aBrowser isKindOf: Browser)
		ifFalse: [^self].
	className := aBrowser selectedClassName.
	aClass := Smalltalk at: className ifAbsent: [nil].
	aClass isNil ifTrue: [^self].
	aClass isMeta ifTrue: [aClass := aClass soleInstance].
	aSelector := aBrowser selectedMessageName.
	Sensor leftShiftDown
		ifTrue: 
			[aSelector := FillInTheBlank request: ''Please enter selector name'' initialAnswer: aSelector asString.
			aSelector = '''' ifTrue: [^self].
			aSelector := aSelector asSymbol].
	aSelector isNil ifTrue: [^self].
	aCollection := SortedCollection new.
	anOrderedCollection := OrderedCollection new.
	anOrderedCollection addAll: aClass allSuperclasses asOrderedCollection.
	anOrderedCollection addAll: aClass withAllSubclasses asOrderedCollection.
	Cursor execute showWhile: [anOrderedCollection 
			do: 
				[:class | 
				list := class whichSelectorsReferTo: aSelector.
				list size > 0 ifTrue: [list do: [:selector | aCollection add: class name , '' '' , selector]].
				list := class class whichSelectorsReferTo: aSelector.
				list size > 0 ifTrue: [list do: [:selector | aCollection add: class class name , '' '' , selector]]]].
	Smalltalk 
		browseMessageList: aCollection 
		name: ''Senders of '' , aSelector printString, '' (local)'' 
		autoSelect:  ((aSelector isKindOf: LookupKey) 
							ifTrue: [aSelector key] 
							ifFalse: [aSelector keywords first])'! !

!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/3/1998 18:37'!
messageListMenu
	"BrowserMenuEnhancements messageListMenu."

	self
		installEnhanceClass: Browser
		protocol: 'message functions'
		code: 'messageListMenu: aMenu shifted: shifted
	^ shifted ifFalse: [aMenu labels:
''browse full
fileOut
printOut
senders of...
implementors of...
method inheritance
versions
inst var refs...
inst var defs...
class var refs...
class variables
class refs
remove
more...
local senders
local implementors
category senders
category implementors''
	lines: #(3 7 12 14)
	selections:
		#(browseMethodFull fileOutMessage printOutMessage
		browseSendersOfMessages browseMessages methodHierarchy browseVersions
		browseInstVarRefs browseInstVarDefs browseClassVarRefs 
			browseClassVariables browseClassRefs
		removeMessage shiftedYellowButtonActivity 
		localSenders localImplementors categorySenders categoryImplementors)]

	ifTrue: [aMenu labels: ''browse class hierarchy
browse class
browse method
implementors of sent messages
change sets with this method
inspect instances
inspect subinstances
remove from this browser
revert to previous version
remove from current change set
revert and forget
more...
local senders
local implementors
category senders
category implementors'' 
	lines: #(5 7 11 12)
	selections: #(classHierarchy browseClass 
		buildMessageBrowser browseAllMessages findMethodInChangeSets 
		inspectInstances inspectSubInstances
		removeMessageFromBrowser revertToPreviousVersion 
		removeFromCurrentChanges revertAndForget
		unshiftedYellowButtonActivity
		localSenders localImplementors categorySenders categoryImplementors)]'! !

!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/3/1998 18:42'!
stringMatchAndInBrowser
	"BrowserMenuEnhancements stringMatchAndInBrowser."

	self
		installEnhanceClass: Browser
		protocol: 'private utilities'
		code: 'stringMatch: string and: pattern 
	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1'! !

!BrowserMenuEnhancements class methodsFor: 'menu enhancements' stamp: 'nishis 6/3/1998 18:42'!
stringMatchSIndexAndPIndexInBrowser
	"BrowserMenuEnhancements stringMatchSIndexAndPIndexInBrowser."

	self
		installEnhanceClass: Browser
		protocol: 'private utilities'
		code: 'stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]'! !


!BrowserMenuEnhancements class methodsFor: 'saving' stamp: 'nishis 6/3/1998 18:39'!
save
	"BrowserMenuEnhancements save."

	| fileName classCollection aStream timeStamp |
	fileName := 'BrMenuEn.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!BrowserMenuEnhancements class methodsFor: 'saving'!
saveClasses
	"BrowserMenuEnhancements saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*BrowserMenuEnhancements*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!BrowserMenuEnhancements class methodsFor: 'private' stamp: 'nishis 4/13/98 15:21'!
installEnhanceClass: aClass protocol: aProtocol code: aCode 
	| aSelector anArray oldCode aCategory bool |
	(aClass isKindOf: Behavior) ifFalse: [^self].
	aSelector := Parser new parseSelector: aCode.
	aSelector isNil ifTrue: [^self].
	enhancements isNil ifTrue: [enhancements := OrderedCollection new].
	anArray := enhancements
				detect: 
					[:array | 
					bool := aClass name asString = (array at: 1).
					bool := bool and: [aSelector = (array at: 3)].
					bool yourself]
				ifNone: [nil].
	anArray isNil
		ifTrue: 
			[(aClass includesSelector: aSelector)
				ifTrue: 
					[oldCode := aClass sourceCodeAt: aSelector.
					aCategory := aClass organization categoryOfElement: aSelector.
					aCategory isNil ifTrue: [aCategory := #undefined]]
				ifFalse: 
					[oldCode := nil.
					aCategory := aProtocol].
			enhancements add: (Array
					with: aClass name asString
					with: aCategory asString
					with: aSelector
					with: oldCode)].
	aClass compile: aCode classified: aProtocol! !

!BrowserMenuEnhancements class methodsFor: 'private'!
stringMatch: string and: pattern 
	"BrowserMenuEnhancements stringMatch: ' Aoki' and: '*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!BrowserMenuEnhancements class methodsFor: 'private'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !

!BrowserMenuEnhancements class methodsFor: 'private' stamp: 'nishis 4/13/98 15:21'!
uninstallEnhanceClass: aClass selector: aSelector 
	| anArray aProtocol oldCode bool |
	(aClass isKindOf: Behavior) ifFalse: [^self].
	(aSelector isKindOf: Symbol)
		ifFalse: [^self].
	enhancements isNil ifTrue: [^self].
	anArray := enhancements
				detect: 
					[:array | 
					bool := aClass name asString = (array at: 1).
					bool := bool and: [aSelector = (array at: 3)].
					bool yourself]
				ifNone: [nil].
	anArray isNil ifTrue: [^self].
	aProtocol := anArray at: 2.
	oldCode := anArray at: 4.
	oldCode isNil
		ifTrue: ["remove method"
			aClass removeSelector: aSelector]
		ifFalse: ["restore method"
			aClass compile: oldCode classified: aProtocol].
	enhancements remove: anArray! !


BrowserMenuEnhancements initialize!
