'Goodies (11/18/2001 8:35:13 am)'.!


ClassReview subclass: #CodeReview
	instanceVariableNames: 'classCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Review'!
!CodeReview commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Code Review
Goodies for Squeak 1.31, 2.0

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Code Review
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (C) 1997-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CodeRevw.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CodeRevw.txt


Summary:

This goodies produces useful information to review program code.

Variables:
check not declared, not used, not assigned variables, and 
used variables list made from special, argument, temporary
instance, class, pool and global variables.  You can check 
using suitable variable name.

messages:
check not implemented, empty categories, and output list of 
receiver type (variables, literals or so).  This list is 
classified "sending messages to me" and "sending messages 
to them", so you can get information of delegation message .

other:
check used literals, number of assignments, number of blocks, 
number of cascades, number of returns, number of statements.

The output report made from items below.  You can output this 
report as html file which is used to varioud report.

MethodReview: 
    not declared variables: 
    not used variables: 
    not assigned variables: 
    used variables: 
        special variables: 
        argument variables: 
        temporary variables: (including block temporary made from Compiler)
        instance variables:
        class variables: 
        pool variables: 
        global variables: 
    sending messages: 
        to self: 
        to super: 
        to thisContext: 
        to literals: 
        to blocks: 
        to variables: 
            to argument variables: 
            to temporary variables: 
            to instance variables: 
            to class variables: 
            to pool variables: 
            to global variables: 
        to expressions: 
    used literals: 
    number of assignments: 
    number of blocks: 
    number of cascades: 
    number of returns: 
    number of statements: 
    main family percentage: 
    branch family percentage: 

ClassReview: 
    not declared variables: 
    not used instance variables: 
    not used class variables: 
    not used variables: 
    not assigned variables: 
    not implemented sendings: 
    empty categories: 
    used special variables: 
    used argument variables: 
    used temporary variables: (including block temporary made from Compiler)
    used instance variables: 
    used class variables: 
    used pool variables: 
    used global variables: 
    implemented messages: 
    sending messages to me: 
    sending messages to them: 
    used literals: 
    number of sending messages: 
    number of assignments: 
    number of blocks: 
    number of cascades: 
    number of returns: 
    number of statements: 
    main family percentage: 
    branch family percentage: 


How to install:

FileIn this goodies and makes classes below in a category 
"Goodies-Review". 

ClassReview
CodeReview
MethodReview

and a category 
"Goodies-Support"

MethodNodeEnumerator

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove these categories 
"Goodies-Review" and "Goodies-Support" from your system.


how to use:

| methodReview |
methodReview := MethodReview class: String selector: #displayOn:at:.
methodReview report.
^methodReview

| classReview |
classReview := ClassReview class: ClassReview.
classReview report.
^classReview

| codeReview |
codeReview := CodeReview classCollection: (Array
                                with: MethodReview
                                with: ClassReview
                                with: CodeReview).
codeReview report.
^codeReview


##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CodeRevw.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/CodeRevw.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


!CodeReview methodsFor: 'accessing'!
classCollection
	^classCollection! !


!CodeReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:10'!
report
	| aStream aModel |
	aStream := WriteStream on: (String new: 1024).
	Cursor wait showWhile: [self reportOn: aStream].
	aModel := StringHolder new.
	aModel contents: aStream contents.
	StringHolderView open: aModel label: 'Code Review'! !

!CodeReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:10'!
reportHtml
	| aStream aModel |
	aStream := WriteStream on: (String new: 1024).
	self reportHtmlOn: aStream.
	aModel := StringHolder new.
	aModel contents: aStream contents.
	StringHolderView open: aModel label: 'Code Review'! !

!CodeReview methodsFor: 'reporting'!
reportHtmlOn: aStream 
	self classCollection
		do: 
			[:aClass | 
			super setClass: aClass.
			super reportHtmlOn: aStream.
			self classCollection last = aClass ifFalse: [aStream cr]]! !

!CodeReview methodsFor: 'reporting' stamp: 'nishis 6/25/1998 03:44'!
reportHtmlToFile: filename
	| aStream |
	aStream := FileStream newFileNamed: filename.
	self reportHtmlOn: aStream.
	aStream close! !

!CodeReview methodsFor: 'reporting'!
reportOn: aStream 
	self classCollection
		do: 
			[:aClass | 
			super setClass: aClass.
			super reportOn: aStream.
			self classCollection last = aClass ifFalse: [aStream cr]]! !

!CodeReview methodsFor: 'reporting' stamp: 'nishis 6/25/1998 03:43'!
reportToFile: filename
	| aStream |
	aStream := FileStream newFileNamed: filename.
	Cursor wait showWhile: [self reportOn: aStream].
	aStream close! !

!CodeReview methodsFor: 'reporting' stamp: 'nishis 6/30/1998 14:12'!
shortReport
	| aStream aModel |
	aStream := WriteStream on: (String new: 1024).
	Cursor wait showWhile: [self shortReportOn: aStream].
	aModel := StringHolder new.
	aModel contents: aStream contents.
	StringHolderView open: aModel label: 'Code Short Review'! !

!CodeReview methodsFor: 'reporting'!
shortReportOn: aStream 
	self classCollection
		do: 
			[:aClass | 
			super setClass: aClass.
			super shortReportOn: aStream.
			self classCollection last = aClass ifFalse: [aStream cr]]! !

!CodeReview methodsFor: 'reporting' stamp: 'nishis 6/25/1998 03:44'!
shortReportToFile: filename
	| aStream |
	aStream := FileStream newFileNamed: filename.
	Cursor wait showWhile: [self shortReportOn: aStream].
	aStream close! !


!CodeReview methodsFor: 'private'!
setClassCollection: aCollection 
	| collection |
	collection := SortedCollection new: aCollection size * 2.
	collection sortBlock: [:c1 :c2 | c1 name < c2 name].
	aCollection do: [:aClass | aClass isMeta
			ifTrue: [collection add: aClass soleInstance; add: aClass]
			ifFalse: [collection add: aClass; add: aClass class]].
	classCollection := collection asArray.
	^self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CodeReview class
	instanceVariableNames: ''!

!CodeReview class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!CodeReview class methodsFor: 'copyright'!
system
	^'Goodies'! !

!CodeReview class methodsFor: 'copyright'!
version
	^'003'! !


!CodeReview class methodsFor: 'instance creation'!
class: aClass 
	^self classCollection: (Array with: aClass)! !

!CodeReview class methodsFor: 'instance creation'!
classCollection: classCollection 
	^(super new) setClassCollection: classCollection; yourself! !


!CodeReview class methodsFor: 'utilities'!
checkSubclassResponsibility: classCollection 
	"CodeReview checkSubclassResponsibility: 
	(SourceCodeSaver 
	name: 'dummy' 
	categories: #('*') 
	filter: [:aClass | true]) classes."

	| aBlock aCollection aCollection2 associations aMethod theClass startClass endClass theSelector aBoolean |
	aBlock := 
			[:aClass | 
			associations := OrderedCollection new.
			aClass selectors
				do: 
					[:aSelector | 
					aMethod := aClass compiledMethodAt: aSelector.
					(aMethod messages includes: #subclassResponsibility)
						ifTrue: [associations add: aClass -> aSelector]].
			associations yourself].
	aCollection := OrderedCollection new.
	(classCollection select: [:aClass | aClass isMeta not])
		do: 
			[:aClass | 
			aCollection addAll: (aBlock value: aClass).
			aCollection addAll: (aBlock value: aClass class)].
	aCollection2 := OrderedCollection new.
	aCollection do: [:assoc | (assoc key allSubclasses select: [:each | each subclasses isEmpty])
			do: [:aLeaf | aCollection2 add: aLeaf -> assoc]].
	aCollection := SortedCollection new.
	aCollection2
		do: 
			[:assoc | 
			theClass := startClass := assoc key.
			endClass := assoc value key.
			theSelector := assoc value value.
			aBoolean := false.
			[theClass notNil and: [(theClass = endClass) not]]
				whileTrue: 
					[(theClass selectors includes: theSelector)
						ifTrue: [aBoolean := true].
					theClass := theClass superclass].
			aBoolean ifFalse: [aCollection add: theSelector -> (Array with: endClass with: startClass)]].
	Transcript clear.
	Transcript show: 'subclass responsibility:'.
	Transcript cr.
	aCollection
		do: 
			[:assoc | 
			Transcript tab; show: assoc key printString.
			Transcript space; show: '('.
			Transcript space; show: assoc value first printString.
			Transcript space; show: '-'.
			Transcript space; show: assoc value last printString.
			Transcript space; show: ')'.
			Transcript cr].
	^aCollection! !


!CodeReview class methodsFor: 'saving' stamp: 'nishis 6/30/1998 14:29'!
save
	"CodeReview save."

	| fileName classCollection aStream timeStamp |
	fileName := 'CodeRevw.st'.
	classCollection := self saveClasses.
	aStream := FileStream newFileNamed: fileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today printString, ' ' , Time now printString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (String cr, 
							self comment asString, String cr) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream moveSource: false toFile: 0.
					aStream cr.
					aStream cr]].
	aStream close.
	^classCollection! !

!CodeReview class methodsFor: 'saving' stamp: 'nishis 7/3/1998 00:34'!
saveClasses
	"CodeReview saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Review*').
	classCollection := (SystemOrganization superclassOrder: self category).
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	classCollection addFirst: MethodNodeEnumerator.
	classCollection := ChangeSet superclassOrder: classCollection.
	^classCollection! !


!CodeReview class methodsFor: 'examples'!
example1
	"CodeReview example1."

	| codeReview |
	codeReview := CodeReview class: MethodReview.
	codeReview report.
	^codeReview! !

!CodeReview class methodsFor: 'examples' stamp: 'nishis 6/30/1998 14:00'!
example2
	"CodeReview example2."

	| codeReview |
	codeReview := CodeReview classCollection: (Array
					with: MethodReview
					with: ClassReview
					with: CodeReview).
	codeReview report.
	^codeReview! !

!CodeReview class methodsFor: 'examples' stamp: 'nishis 6/30/1998 13:59'!
example3
	"CodeReview example3."

	| codeReview |
	codeReview := CodeReview class: MethodReview.
	codeReview shortReport.
	^codeReview! !

!CodeReview class methodsFor: 'examples' stamp: 'nishis 10/20/1998 23:00'!
example4
	"CodeReview example4."

	| codeReview |
	codeReview := CodeReview classCollection: (Array
					with: MethodReview
					with: ClassReview
					with: CodeReview).
	codeReview reportToFile: 'CodeReview.txt'.
	^codeReview! !
