'Goodies (11/18/2001 8:35:14 am)'.!


StandardSystemController subclass: #ScheduledController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-ScheduledVC'!

!ScheduledController methodsFor: 'menu messages'!
toggleTwoTone
	"do nothing"! !


!ScheduledController methodsFor: 'scheduling'!
openAt: aPoint
	self openIn: (aPoint extent: self view minimumSize)! !

!ScheduledController methodsFor: 'scheduling' stamp: 'nishis 5/15/98 22:43'!
openIn: aRectangle
	| displayRectangle minimumExtent |
	view minimumSize isNil
		ifTrue: [view resizeTo: aRectangle]
		ifFalse:
			[minimumExtent := view minimumSize max: aRectangle extent.
			displayRectangle := aRectangle origin extent: minimumExtent.
			view resizeTo: displayRectangle].
	"InputSensor default cursorPoint: view insetDisplayBox center."
	status := #open.
	ScheduledControllers scheduleActive: self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ScheduledController class
	instanceVariableNames: ''!

!ScheduledController class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1986-1998 AOKI Atsushi, All Rights Reserved.'! !

!ScheduledController class methodsFor: 'copyright'!
system
	^'Goodies'! !

!ScheduledController class methodsFor: 'copyright' stamp: 'nishis 5/15/98 22:06'!
version
	^'002'! !


!ScheduledController class methodsFor: 'examples'!
example1
	"ScheduledController example1."

	| topView |
	topView := ScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	topView controller openIn: Rectangle fromUser! !

!ScheduledController class methodsFor: 'examples'!
example2
	"ScheduledController example2."

	| topView subView |
	topView := ScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	subView := View new.
	subView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller openIn: Rectangle fromUser! !

!ScheduledController class methodsFor: 'examples'!
example3
	"ScheduledController example3."

	| topView subView |
	topView := ScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	subView := View new.
	subView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller openAt: 100 @ 100! !
