'Goodies (11/18/2001 8:35:14 am)'.!


ScheduledController subclass: #AlteredScheduledController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-ScheduledVC'!

!AlteredScheduledController methodsFor: 'scheduling' stamp: 'nishis 5/15/98 23:35'!
open
	"AlteredScheduledController example3."
	| displayRectangle minimumExtent |
	view resizeInitially.
	view minimumSize isNil
		ifTrue: [view resizeTo: (view viewport origin extent: view superView minimumSize)]
		ifFalse:
			[minimumExtent := view minimumSize.
			displayRectangle := view viewport origin extent: minimumExtent - view labelOffset.
			view resizeTo: displayRectangle].
	status _ #open.
	ScheduledControllers scheduleActive: self! !

!AlteredScheduledController methodsFor: 'scheduling' stamp: 'nishis 5/15/98 23:32'!
openIn: aRectangle
	"AlteredScheduledController example3."
	| displayRectangle minimumExtent |
	view minimumSize isNil
		ifTrue: [view resizeTo: aRectangle]
		ifFalse:
			[minimumExtent := view minimumSize max: aRectangle extent.
			displayRectangle := aRectangle origin extent: minimumExtent - view labelOffset.
			view resizeTo: displayRectangle].
	"InputSensor default cursorPoint: view insetDisplayBox center."
	status := #open.
	ScheduledControllers scheduleActive: self! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AlteredScheduledController class
	instanceVariableNames: ''!

!AlteredScheduledController class methodsFor: 'copyright' stamp: 'nishis 5/15/98 23:08'!
copyright
	^'Copyright (C) 1998 NISHIHARA Satoshi, All Rights Reserved.'! !

!AlteredScheduledController class methodsFor: 'copyright' stamp: 'nishis 5/15/98 22:06'!
system
	^'Goodies'! !

!AlteredScheduledController class methodsFor: 'copyright' stamp: 'nishis 5/15/98 23:08'!
version
	^'001'! !


!AlteredScheduledController class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:36'!
example1
	"AlteredScheduledController example1."

	| topView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	topView controller openIn: Rectangle fromUser! !

!AlteredScheduledController class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:25'!
example2
	"AlteredScheduledController example2."

	| topView subView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200.
	subView := View new.
	subView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller openIn: Rectangle fromUser! !

!AlteredScheduledController class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:25'!
example3
	"AlteredScheduledController example3."

	| topView subView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200
		maximumSize: 200 @ 200.
	subView := View new.
	subView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller openAt: 100 @ 100! !

!AlteredScheduledController class methodsFor: 'examples' stamp: 'nishis 5/15/98 23:34'!
example4
	"AlteredScheduledController example4."

	| topView subView |
	topView := AlteredScheduledView
		model: nil
		label: nil
		minimumSize: 200 @ 200
		maximumSize: 200 @ 200.
	subView := View new.
	subView borderWidth: 1.
	subView backgroundColor: Color white.
	topView addSubView: subView.
	topView controller open! !
