'Goodies (11/18/2001 8:35:15 am)'.!


Object subclass: #Cursors
	instanceVariableNames: ''
	classVariableNames: 'ArrowCursor BetweenCursor BrushCursor CameraCursor ClockCursor CrossCursor EpilogueCursor EraserCursor FilmCursor FrameCursor GaugeCursor GlassCursor GoCursor HandCursor JuiceCursor LassoCursor NextCursor PaintCursor PauseCursor PencilCursor PlayCursor PreviousCursor PrologueCursor QuartersCursor RepeatCursor RoundtripCursor ScissorsCursor SpeakerCursor SpuitCursor StopCursor '
	poolDictionaries: ''
	category: 'Goodies-Cursors'!
!Cursors commentStamp: '<historical>' prior: 0!
#
# This file is encoded in (so called) SHIFT-JIS,
# line delimitor is CR.
#
Cursors
Goodies for Squeak 2.3 beta

Broken English description

This goodies is a modification for Squeak from Mr. AOKI's
Cursors
Goodies for VisualWorks 2.5 and VisualWave 1.0
Copyright (c) 1995-1998 AOKI Atsushi
1998/01/05
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Cursors.st
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Cursors.txt


Summary:


This goodies has a set of various mouse cursors.


Installing:

FileIn this goodies and makes a class "Cursors" in a 
category "Goodies-Cursors". 

This source adds no change to existing classes or methods.
It completes within self.

When you want to restore your image, please remove this class 
"Cursors" from your system, simply.


how to use:

Send message "xxxCursor" to Cursor class.  xxxCursor is a name 
of mouse cousor.

See example which shows all cursors by 1 second.

##########################################################

؂
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Cursors.st
 Squeak pɂ̂łB
hLg
http://www.sra.co.jp/people/aoki/SmalltalkGoodies/VisualWorks/Cursors.txt
QƂĂB

----------------------------------------------------------
m (NISHIHARA Satoshi)
e-mail:	nishis@urban.ne.jp, tcc00164@niftyserve.or.jp
URL:	http://www.urban.ne.jp/home/nishis/
----------------------------------------------------------
!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cursors class
	instanceVariableNames: ''!

!Cursors class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!Cursors class methodsFor: 'copyright'!
system
	^'Goodies'! !

!Cursors class methodsFor: 'copyright'!
version
	^'003'! !


!Cursors class methodsFor: 'class initialization'!
flushCursors
	"Cursors flushCursors."

	| mark string |
	self classPool
		keysDo: 
			[:key | 
			mark := 'Cursor'.
			string := key asString copyFrom: key size - mark size + 1 to: key size.
			string = mark ifTrue: [self classPool at: key put: nil]]! !

!Cursors class methodsFor: 'class initialization'!
install
	"Cursors install."

	| mark string |
	(Cursors class organization listAtCategoryNamed: #Cursors)
		do: 
			[:selector | 
			mark := 'Cursor'.
			string := selector asString copyFrom: selector size - mark size + 1 to: selector size.
			string = mark ifTrue: [Cursors perform: selector]]! !


!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:54'!
arrowCursor
	"Cursors arrowCursor."
	"
	Cursors arrowCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	ArrowCursor notNil ifTrue: [^ArrowCursor].
	ArrowCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000010000
2r0000000000011000
2r0011111111111100
2r0000000000011000
2r0000000000010000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000010000
2r0000000000111000
2r0011111111111100
2r0111111111111110
2r0011111111111100
2r0000000000111000
2r0000000000010000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
) 
				offset: 7 @ 7.
	^ArrowCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:56'!
betweenCursor
	"Cursors betweenCursor."
	"
	Cursors betweenCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	BetweenCursor notNil ifTrue: [^BetweenCursor].
	BetweenCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000100000010000
2r0001100000011000
2r0011111111111100
2r0001100000011000
2r0000100000010000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000100000010000
2r0001110000111000
2r0011111111111100
2r0111111111111110
2r0011111111111100
2r0001110000111000
2r0000100000010000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^BetweenCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:56'!
brushCursor
	"Cursors brushCursor."
	"
	Cursors brushCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	BrushCursor notNil ifTrue: [^BrushCursor].
	BrushCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000001001000
2r0000000001001000
2r0000000010010000
2r0000000010010000
2r0000000100100000
2r0000000100100000
2r0000001111000000
2r0000010011000000
2r0000100011000000
2r0000100111000000
2r0001001110000000
2r0001011100000000
2r0010111000000000
2r0111100000000000
2r0000000000000000
)
				mask: #(
2r0000000001001000
2r0000000011111100
2r0000000011111100
2r0000000111111000
2r0000000111111000
2r0000001111110000
2r0000001111110000
2r0000011111100000
2r0000111111100000
2r0001111111100000
2r0001111111100000
2r0011111111000000
2r0011111110000000
2r0111111100000000
2r1111111000000000
2r0111100000000000
)
				offset: 2 @ 14.
	^BrushCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:57'!
cameraCursor
	"Cursors cameraCursor."
	"
	Cursors cameraCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	CameraCursor notNil ifTrue: [^CameraCursor].
	CameraCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0011100000000000
2r0010100000111100
2r0111111111111110
2r0100000000000010
2r0100001111000010
2r0100011001100010
2r0100110000110010
2r0100100000010010
2r0100100001010010
2r0100110010110010
2r0100011001100010
2r0100001111000010
2r0100000000000010
2r0111111111111110
2r0000000000000000
)
				mask: #(
2r0011100000000000
2r0111110000111100
2r0111111111111110
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r0111111111111110
)
				offset: 7 @ 7.
	^CameraCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:57'!
clockCursor
	"Cursors clockCursor."
	"
	Cursors clockCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	ClockCursor notNil ifTrue: [^ClockCursor].
	ClockCursor := self
				extent: 16@16 
				fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000010001000000
2r1000010001000000
2r1000010001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
				mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
				offset: 5 @ 8.
	^ClockCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:57'!
crossCursor
	"Cursors crossCursor."
	"
	Cursors crossCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	CrossCursor notNil ifTrue: [^CrossCursor].
	CrossCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000000000000000
2r0111110001111110
2r0000000000000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000100000000
2r0000001110000000
2r0000001110000000
2r0000001110000000
2r0000001110000000
2r0000001110000000
2r0111111011111110
2r1111110001111111
2r0111111011111110
2r0000001110000000
2r0000001110000000
2r0000001110000000
2r0000001110000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
)
				offset: 7 @ 7.
	^CrossCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:58'!
epilogueCursor
	"Cursors epilogueCursor."
	"
	Cursors epilogueCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	EpilogueCursor notNil ifTrue: [^EpilogueCursor].
	EpilogueCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0001100000011000
2r0001110000011000
2r0001111000011000
2r0001101100011000
2r0001100110011000
2r0001100011011000
2r0001100011011000
2r0001100110011000
2r0001101100011000
2r0001111000011000
2r0001110000011000
2r0001100000011000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0001100000011000
2r0011110000111100
2r0011111000111100
2r0011111100111100
2r0011111110111100
2r0011111111111100
2r0011110111111100
2r0011110111111100
2r0011111111111100
2r0011111110111100
2r0011111100111100
2r0011111000111100
2r0011110000111100
2r0001100000011000
2r0000000000000000
)
				offset: 7 @ 7.
	^EpilogueCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:58'!
eraserCursor
	"Cursors eraserCursor."
	"
	Cursors eraserCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	EraserCursor notNil ifTrue: [^EraserCursor].
	EraserCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000111111110
2r0000001000000110
2r0000010000001010
2r0000100000010010
2r0001000000100100
2r0010000001001000
2r0111111110010000
2r0100000010100000
2r0100000011000000
2r0111111110000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000000111111110
2r0000001111111111
2r0000011111111111
2r0000111111111111
2r0001111111111111
2r0011111111111110
2r0111111111111100
2r1111111111111000
2r1111111111110000
2r1111111111100000
2r1111111111000000
2r0111111110000000
2r0000000000000000
2r0000000000000000
)
				offset: 1 @ 12.
	^EraserCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:59'!
filmCursor
	"Cursors filmCursor."
	"
	Cursors filmCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	FilmCursor notNil ifTrue: [^FilmCursor].
	FilmCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0111000000001110
2r0111000000001110
2r0101111111111010
2r0111000000001110
2r0111000000001110
2r0101000000001010
2r0111000000001110
2r0111000000001110
2r0101000000001010
2r0111000000001110
2r0111000000001110
2r0101111111111010
2r0111000000001110
2r0111000000001110
2r0000000000000000
)
				mask: #(
2r0111000000001110
2r1111100000011111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111111111111111
2r1111100000011111
2r0111000000001110
)
				offset: 7 @ 7.
	^FilmCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:59'!
frameCursor
	"Cursors frameCursor."
	"
	Cursors frameCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	FrameCursor notNil ifTrue: [^FrameCursor].
	FrameCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0111100111001110
2r0100000000000010
2r0100000000000010
2r0000000000000010
2r0000000000000000
2r0100000000000000
2r0100000000000010
2r0100000000000010
2r0000000000000010
2r0000000000000000
2r0100000000000000
2r0100000000000010
2r0100000000000010
2r0111001110011110
2r0000000000000000
)
				mask: #(
2r0111100111001110
2r1111111111111111
2r1111100111001111
2r1110000000000111
2r0100000000000111
2r0100000000000010
2r1110000000000010
2r1110000000000111
2r1110000000000111
2r0100000000000111
2r0100000000000010
2r1110000000000010
2r1110000000000111
2r1111001110011111
2r1111111111111111
2r0111001110011110
)
				offset: 7 @ 7.
	^FrameCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 21:59'!
gaugeCursor
	"Cursors gaugeCursor."
	"
	Cursors gaugeCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	GaugeCursor notNil ifTrue: [^GaugeCursor].
	GaugeCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0001111011111000
2r0000000010001000
2r0000011010001000
2r0000000010001000
2r0000011010001000
2r0000000010001000
2r0000111010001000
2r0000000010001000
2r0000011011111000
2r0000000011111000
2r0000011011111000
2r0000000011111000
2r0001111011111000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0001111011111000
2r0011111111111100
2r0001111111111100
2r0000111111111100
2r0000011111111100
2r0000111111111100
2r0000111111111100
2r0001111111111100
2r0000111111111100
2r0000111111111100
2r0000011111111100
2r0000111111111100
2r0001111111111100
2r0011111111111100
2r0001111011111000
)
				offset: 7 @ 7.
	^GaugeCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:00'!
glassCursor
	"Cursors glassCursor."
	"
	Cursors glassCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	GlassCursor notNil ifTrue: [^GlassCursor].
	GlassCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000111100000000
2r0011000011000000
2r0010000001000000
2r0100000000100000
2r0100000000100000
2r0100000000100000
2r0100000000100000
2r0010000001000000
2r0011000011100000
2r0000111101110000
2r0000000000111000
2r0000000000011100
2r0000000000001110
2r0000000000000110
2r0000000000000000
)
				mask: #(
2r0000111100000000
2r0011111111000000
2r0111111111100000
2r0111000011100000
2r1110000001110000
2r1110000001110000
2r1110000001110000
2r1110000001110000
2r0111000011100000
2r0111111111110000
2r0011111111111000
2r0000111101111100
2r0000000000111110
2r0000000000011111
2r0000000000001111
2r0000000000000110
)
				offset: 5 @ 5.
	^GlassCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:00'!
goCursor
	"Cursors goCursor."
	"
	Cursors goCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	GoCursor notNil ifTrue: [^GoCursor].
	GoCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0001110000111000
2r0010001001000100
2r0010000001000100
2r0010000001000100
2r0010011101000100
2r0010001001000100
2r0010001001000100
2r0001110000111000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0001110000111000
2r0011111001111100
2r0111111111111110
2r0111001011101110
2r0111011111101110
2r0111111111101110
2r0111011111101110
2r0111111111111110
2r0011111001111100
2r0001110000111000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^GoCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:00'!
handCursor
	"Cursors handCursor."
	"
	Cursors handCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	HandCursor notNil ifTrue: [^HandCursor].
	HandCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000110000000
2r0001101001110000
2r0010011001001000
2r0010011001001010
2r0001001001001101
2r0001001001001001
2r0110100000001001
2r1001100000000001
2r1000100000000010
2r0100000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
				mask: #(
2r0000000110000000
2r0001101111110000
2r0011111111111000
2r0011111111111010
2r0001111111111111
2r0001111111111111
2r0110111111111111
2r1111111111111111
2r1111111111111110
2r0111111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
				offset: 7 @ 7.
	^HandCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:00'!
juiceCursor
	"Cursors juiceCursor."
	"
	Cursors juiceCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	JuiceCursor notNil ifTrue: [^JuiceCursor].
	JuiceCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000100000000
2r0000000100000000
2r0000001010000000
2r0000001010000000
2r0000010001000000
2r0000100000100000
2r0000100000100000
2r0001000000010000
2r0001000000010000
2r0001000000010000
2r0001000000010000
2r0000100000100000
2r0000010001000000
2r0000001110000000
2r0000000000000000
)
				mask: #(
2r0000000100000000
2r0000001110000000
2r0000001110000000
2r0000011111000000
2r0000011111000000
2r0000111011100000
2r0001110001110000
2r0001110001110000
2r0011100000111000
2r0011100000111000
2r0011100000111000
2r0011100000111000
2r0001110001110000
2r0000111111100000
2r0000011111000000
2r0000001110000000
)
				offset: 7 @ 8.
	^JuiceCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:01'!
lassoCursor
	"Cursors lassoCursor."
	"
	Cursors lassoCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	LassoCursor notNil ifTrue: [^LassoCursor].
	LassoCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000111110000
2r0000111000001100
2r0001000000000010
2r0010000000000010
2r0100000000000010
2r0100000000001100
2r0100000000110000
2r0011100011000000
2r0110011100000000
2r0101010000000000
2r0011100000000000
2r0000100000000000
2r0000100000000000
2r0001000000000000
2r0000000000000000
)
				mask: #(
2r0000000111110000
2r0000111111111100
2r0001111111111110
2r0011111000001111
2r0111000000000111
2r1110000000001111
2r1110000000111110
2r1111100011111100
2r0111111111110000
2r1111111111000000
2r1111111100000000
2r0111110000000000
2r0011110000000000
2r0001110000000000
2r0011100000000000
2r0001000000000000
)
				offset: 3 @ 14.
	^LassoCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:01'!
nextCursor
	"Cursors nextCursor."
	"
	Cursors nextCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	NextCursor notNil ifTrue: [^NextCursor].
	NextCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0001001100000000
2r0001001110000000
2r0001001111000000
2r0001001101100000
2r0001001100110000
2r0001001100011000
2r0001001100011000
2r0001001100110000
2r0001001101100000
2r0001001111000000
2r0001001110000000
2r0001001100000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0001001100000000
2r0011111110000000
2r0011111111000000
2r0011111111100000
2r0011111111110000
2r0011111111111000
2r0011111110111100
2r0011111110111100
2r0011111111111000
2r0011111111110000
2r0011111111100000
2r0011111111000000
2r0011111110000000
2r0001001100000000
2r0000000000000000
)
				offset: 7 @ 7.
	^NextCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:01'!
paintCursor
	"Cursors paintCursor."
	"
	Cursors paintCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	PaintCursor notNil ifTrue: [^PaintCursor].
	PaintCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000011100000000
2r0000100110000000
2r0000101011000000
2r0000110010110000
2r0000100010011100
2r0001000010001110
2r0010000101000110
2r0100000010000110
2r0100000000001110
2r0010000000010110
2r0001000000100110
2r0000100001000110
2r0000010010000110
2r0000001100000100
2r0000000000000000
)
				mask: #(
2r0000011100000000
2r0000111110000000
2r0001111111000000
2r0001111111110000
2r0001111111111100
2r0001111111111110
2r0011111111111111
2r0111111111111111
2r1111111111111111
2r1111111111111111
2r0111111111111111
2r0011111111111111
2r0001111111101111
2r0000111111001111
2r0000011110001110
2r0000001100000100
)
				offset: 13 @ 14.
	^PaintCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:02'!
pauseCursor
	"Cursors pauseCursor."
	"
	Cursors pauseCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	PauseCursor notNil ifTrue: [^PauseCursor].
	PauseCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000110000110000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0000110000110000
2r0000000000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^PauseCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:02'!
pencilCursor
	"Cursors pencilCursor."
	"
	Cursors pencilCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	PencilCursor notNil ifTrue: [^PencilCursor].
	PencilCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000111100000
2r0000000100010000
2r0000001000010000
2r0000011100100000
2r0000010011100000
2r0000100001000000
2r0000100010000000
2r0001000010000000
2r0001000100000000
2r0001100100000000
2r0001111000000000
2r0001110000000000
2r0001100000000000
2r0001000000000000
2r0000000000000000
)
				mask: #(
2r0000000111100000
2r0000001111110000
2r0000001111111000
2r0000011111111000
2r0000111111110000
2r0000111111110000
2r0001111111100000
2r0001111111000000
2r0011111111000000
2r0011111110000000
2r0011111110000000
2r0011111100000000
2r0011111000000000
2r0011110000000000
2r0011100000000000
2r0001000000000000
)
				offset: 3 @ 14.
	^PencilCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:02'!
playCursor
	"Cursors playCursor."
	"
	Cursors playCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	PlayCursor notNil ifTrue: [^PlayCursor].
	PlayCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000011000000000
2r0000011100000000
2r0000011110000000
2r0000011011000000
2r0000011001100000
2r0000011000110000
2r0000011000110000
2r0000011001100000
2r0000011011000000
2r0000011110000000
2r0000011100000000
2r0000011000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000011000000000
2r0000111100000000
2r0000111110000000
2r0000111111000000
2r0000111111100000
2r0000111111110000
2r0000111101111000
2r0000111101111000
2r0000111111110000
2r0000111111100000
2r0000111111000000
2r0000111110000000
2r0000111100000000
2r0000011000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^PlayCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:02'!
previousCursor
	"Cursors previousCursor."
	"
	Cursors previousCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	PreviousCursor notNil ifTrue: [^PreviousCursor].
	PreviousCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000011001000
2r0000000111001000
2r0000001111001000
2r0000011011001000
2r0000110011001000
2r0001100011001000
2r0001100011001000
2r0000110011001000
2r0000011011001000
2r0000001111001000
2r0000000111001000
2r0000000011001000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000011001000
2r0000000111111100
2r0000001111111100
2r0000011111111100
2r0000111111111100
2r0001111111111100
2r0011110111111100
2r0011110111111100
2r0001111111111100
2r0000111111111100
2r0000011111111100
2r0000001111111100
2r0000000111111100
2r0000000011001000
2r0000000000000000
)
				offset: 7 @ 7.
	^PreviousCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:03'!
prologueCursor
	"Cursors prologueCursor."
	"
	Cursors prologueCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	PrologueCursor notNil ifTrue: [^PrologueCursor].
	PrologueCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0001100000011000
2r0001100000111000
2r0001100001111000
2r0001100011011000
2r0001100110011000
2r0001101100011000
2r0001101100011000
2r0001100110011000
2r0001100011011000
2r0001100001111000
2r0001100000111000
2r0001100000011000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0001100000011000
2r0011110000111100
2r0011110001111100
2r0011110011111100
2r0011110111111100
2r0011111111111100
2r0011111110111100
2r0011111110111100
2r0011111111111100
2r0011110111111100
2r0011110011111100
2r0011110001111100
2r0011110000111100
2r0001100000011000
2r0000000000000000
)
				offset: 7 @ 7.
	^PrologueCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:04'!
quartersCursor
	"Cursors quartersCursor."
	"
	Cursors quartersCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	QuartersCursor notNil ifTrue: [^QuartersCursor].
	QuartersCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000100000000
2r0000001110000000
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0010000000000100
2r0111110001111110
2r0010000000000100
2r0000000100000000
2r0000000100000000
2r0000000100000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000100000000
2r0000001110000000
2r0000011111000000
2r0000001110000000
2r0000001110000000
2r0010001110000100
2r0111111011111110
2r1111110001111111
2r0111111011111110
2r0010001110000100
2r0000001110000000
2r0000001110000000
2r0000011111000000
2r0000001110000000
2r0000000100000000
2r0000000000000000
)
				offset: 7 @ 7.
	^QuartersCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:04'!
repeatCursor
	"Cursors repeatCursor."
	"
	Cursors repeatCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	RepeatCursor notNil ifTrue: [^RepeatCursor].
	RepeatCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000100000000
2r0000000110000000
2r0001111111111000
2r0011000110001100
2r0010000100000100
2r0010000000000100
2r0011000000001100
2r0001111111111000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000000100000000
2r0000001110000000
2r0001111111111000
2r0011111111111100
2r0111111111111110
2r0111001110001110
2r0111000100001110
2r0111111111111110
2r0011111111111100
2r0001111111111000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^RepeatCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:04'!
roundtripCursor
	"Cursors roundtripCursor."
	"
	Cursors roundtripCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	RoundtripCursor notNil ifTrue: [^RoundtripCursor].
	RoundtripCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000010000
2r0000000000011000
2r0011111111111100
2r0000000000011000
2r0000000000010000
2r0000100000000000
2r0001100000000000
2r0011111111111100
2r0001100000000000
2r0000100000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000010000
2r0000000000111000
2r0011111111111100
2r0111111111111110
2r0011111111111100
2r0000100000111000
2r0001110000010000
2r0011111111111100
2r0111111111111110
2r0011111111111100
2r0001110000000000
2r0000100000000000
2r0000000000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^RoundtripCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:05'!
scissorsCursor
	"Cursors scissorsCursor."
	"
	Cursors scissorsCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	ScissorsCursor notNil ifTrue: [^ScissorsCursor].
	ScissorsCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000001010000000
2r0000011011000000
2r0000011011000000
2r0000011011000000
2r0000011011000000
2r0000001010000000
2r0000001110000000
2r0000001010000000
2r0000001110000000
2r0000011011000000
2r0000101010100000
2r0001001010010000
2r0001001010010000
2r0000111011100000
2r0000000000000000
)
				mask: #(
2r0000001010000000
2r0000011111000000
2r0000111111100000
2r0000111111100000
2r0000111111100000
2r0000111111100000
2r0000011111000000
2r0000011111000000
2r0000011111000000
2r0000011111000000
2r0000111111100000
2r0001111111110000
2r0011111111111000
2r0011111111111000
2r0001111111110000
2r0000111011100000
)
				offset: 7 @ 8.
	^ScissorsCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:05'!
speakerCursor
	"Cursors speakerCursor."
	"
	Cursors speakerCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	SpeakerCursor notNil ifTrue: [^SpeakerCursor].
	SpeakerCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000100000000
2r0000001100010000
2r0000010100001000
2r0000100100000100
2r0001000100100100
2r0110000100100100
2r0100000100010010
2r0100000100010010
2r0110000100100100
2r0001000100100100
2r0000100100000100
2r0000010100001000
2r0000001100010000
2r0000000100000000
2r0000000000000000
)
				mask: #(
2r0000000100000000
2r0000001110010000
2r0000011110111000
2r0000111110011100
2r0001111110101110
2r0111111111111110
2r1111111111111110
2r1111111110111111
2r1111111110111111
2r1111111111111110
2r0111111111111110
2r0001111110101110
2r0000111110011100
2r0000011110111000
2r0000001110010000
2r0000000100000000
)
				offset: 7 @ 7.
	^SpeakerCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:05'!
spuitCursor
	"Cursors spuitCursor."
	"
	Cursors spuitCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	SpuitCursor notNil ifTrue: [^SpuitCursor].
	SpuitCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000011100
2r0000000000111110
2r0000000000111110
2r0000000111111110
2r0000000011111100
2r0000000101110000
2r0000001000110000
2r0000010001010000
2r0000100010000000
2r0001000100000000
2r0010001000000000
2r0010010000000000
2r0101100000000000
2r0010000000000000
2r0000000000000000
)
				mask: #(
2r0000000000011100
2r0000000000111110
2r0000000001111111
2r0000011111111111
2r0000001111111111
2r0000000111111110
2r0000001111111100
2r0000011111111000
2r0000111111111000
2r0001111111011000
2r0011111110001000
2r0111111100000000
2r0111111000000000
2r1101110000000000
2r0111100000000000
2r0010000000000000
)
				offset: 2 @ 13.
	^SpuitCursor! !

!Cursors class methodsFor: 'Cursors' stamp: 'nishis 12/12/1998 22:05'!
stopCursor
	"Cursors stopCursor."
	"
	Cursors stopCursor show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"
	"Cursors flushCursors."

	StopCursor notNil ifTrue: [^StopCursor].
	StopCursor := self
				extent: 16@16 
				fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000111111110000
2r0000111111110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000110000110000
2r0000111111110000
2r0000111111110000
2r0000000000000000
2r0000000000000000
2r0000000000000000
)
				mask: #(
2r0000000000000000
2r0000000000000000
2r0000111111110000
2r0001111111111000
2r0001111111111000
2r0001111111111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111001111000
2r0001111111111000
2r0001111111111000
2r0001111111111000
2r0000111111110000
2r0000000000000000
2r0000000000000000
)
				offset: 7 @ 7.
	^StopCursor! !


!Cursors class methodsFor: 'saving' stamp: 'nishis 6/11/1998 22:37'!
save
	"Cursors save."

	| fileName classCollection aStream timeStamp |
	fileName := 'Cursors.st'.
	classCollection := self saveClasses.
	aStream := FileStream fileNamed: fileName asFileName.
	aStream reset.
	Cursor write
		showWhile: 
			[timeStamp := Date today mmddyyyy, ' ' , Time now asString.
			aStream cr.
			aStream nextChunkPut: timeStamp printString.
			aStream cr; cr.
			(self comment isNil or: [self comment isEmpty])
				ifFalse: 
					[aStream nextChunkPut: (self comment asString) printString.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextChunkPut: aClass definition.
					aStream cr; cr].
			classCollection
				do: 
					[:aClass | 
					aStream nextPut: Character newPage.
					aStream cr.
					aClass fileOutOn: aStream.
					aStream cr]].
	aStream close.
	^classCollection! !

!Cursors class methodsFor: 'saving'!
saveClasses
	"Cursors saveClasses."

	| patternCollection classCollection string something |
	patternCollection := #('*Cursors*').
	classCollection := SystemOrganization superclassOrder: self category.
	classCollection := classCollection
				select: 
					[:aClass | 
					string := aClass name asString.
					something := patternCollection detect: [:it | it match: string]
								ifNone: [nil].
					something notNil].
	^classCollection! !


!Cursors class methodsFor: 'private' stamp: 'nishis 12/12/1998 22:25'!
extent: extentPoint fromArray: anArray mask: maskArray offset: offsetPoint
	| cursorMaker |
	cursorMaker := Smalltalk at: #CursorWithMask ifAbsent: [nil].
	cursorMaker isNil 
		ifTrue: 
			[^self extent: extentPoint fromArray: anArray offset: offsetPoint].
	^(cursorMaker 
			extent: extentPoint 
			fromArray: anArray
			offset: offsetPoint * -1)
		setMaskForm: 
			(Form 
				extent: extentPoint
				fromArray: (maskArray collect: [:bits | bits bitShift: 16]) 
				offset: 0 @ 0)! !

!Cursors class methodsFor: 'private' stamp: 'nishis 12/12/1998 22:11'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	^Cursor extent: extentPoint fromArray: anArray offset: offsetPoint * -1! !

!Cursors class methodsFor: 'private' stamp: 'nishis 12/12/1998 14:52'!
makeCursorFromGifFile: filenameString
	"Cursors makeCursorFromGifFile: 'Squeakers.GIF'."

	| image dstImage bits mask string |
	dstImage := GIFReadWriter formFromFileNamed: filenameString.
	image := Form extent: dstImage extent depth: 1.
	dstImage displayOn: image.
	bits := image bits.
	Transcript clear.
	bits
		do: 
			[:byte | 
			string := (byte bitShift: -16) printStringBase: 2.
			Transcript show: string.
			18 - string size timesRepeat: [Transcript show: '0'].
			Transcript cr].
	mask := image copy.
	mask
		copy: mask boundingBox
		from: 1 @ 0
		in: image
		rule: Form under.
	mask
		copy: mask boundingBox
		from: 0 @ 1
		in: image
		rule: Form under.
	mask
		copy: mask boundingBox
		from: -1 @ 0
		in: image
		rule: Form under.
	mask
		copy: mask boundingBox
		from: 0 @ -1
		in: image
		rule: Form under.
	bits := mask bits.
	Transcript cr.
	bits
		do: 
			[:byte | 
			string := (byte bitShift: -16) printStringBase: 2.
			Transcript show: string.
			18 - string size timesRepeat: [Transcript show: '0'].
			Transcript cr].
	Transcript endEntry! !


!Cursors class methodsFor: 'examples' stamp: 'nishis 4/8/98 02:15'!
example1
	"Cursors example1."

	| aCursor |
	(Cursors class organization listAtCategoryNamed: #Cursors)
		do: 
			[:selector | 
			aCursor := Cursors perform: selector.
			aCursor
				showWhile: 
					[Transcript cr; show: selector "aCursor name".
					(Delay forSeconds: 1) wait]]! !
