'Goodies (11/18/2001 8:35:17 am)'.!


PrologList subclass: #PrologStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologStructure commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologStructure methodsFor: 'accessing'!
arity
	^self terms length! !

!PrologStructure methodsFor: 'accessing'!
functor
	^carPart! !

!PrologStructure methodsFor: 'accessing'!
functor: aPrologSymbol 
	carPart := aPrologSymbol! !

!PrologStructure methodsFor: 'accessing'!
nthTerm: anInteger 
	^cdrPart nth: anInteger! !

!PrologStructure methodsFor: 'accessing'!
terms
	^cdrPart! !

!PrologStructure methodsFor: 'accessing'!
terms: aPrologTerms 
	cdrPart := aPrologTerms! !


!PrologStructure methodsFor: 'functions'!
structureList
	"disassemble prolog structure of myself into a list."
	^(self functor) cons: self terms asPrologList! !


!PrologStructure methodsFor: 'printing'!
printPrologOn: aStream 
	| functor terms |
	functor := self functor.
	terms := self terms.
	functor printPrologOn: aStream.
	terms == nil
		ifFalse:
			[(terms consp)
				ifTrue: [terms printPrologOn: aStream]
				ifFalse:
					[aStream nextPutAll: '(|'.
					terms printPrologOn: aStream.
					aStream nextPut: $)]]! !

!PrologStructure methodsFor: 'printing'!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !


!PrologStructure methodsFor: 'private'!
functor: aPrologSymbol terms: aPrologTerms 
	self functor: aPrologSymbol.
	self terms: aPrologTerms! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologStructure class
	instanceVariableNames: ''!

!PrologStructure class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologStructure class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologStructure class methodsFor: 'copyright'!
version
	^'003'! !


!PrologStructure class methodsFor: 'instance creation'!
functor: aPrologSymbol terms: aPrologTerms 
	^super new functor: aPrologSymbol terms: aPrologTerms! !
