'Goodies (11/18/2001 8:35:17 am)'.!


PrologEntity subclass: #PrologString
	instanceVariableNames: 'string '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologString commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologString methodsFor: 'accessing'!
at: index
	^string at: index! !

!PrologString methodsFor: 'accessing'!
at: index put: char
	^string at: index put: char! !

!PrologString methodsFor: 'accessing'!
size
	^string size! !

!PrologString methodsFor: 'accessing'!
string
	^string! !

!PrologString methodsFor: 'accessing'!
string: aString
	string := aString! !


!PrologString methodsFor: 'testing'!
= anObject 
	anObject class = self class ifFalse: [^false].
	^self string = anObject string! !


!PrologString methodsFor: 'comparing'!
< aPrologString 
	^self string < aPrologString string! !

!PrologString methodsFor: 'comparing'!
<= aPrologString 
	^self string <= aPrologString string! !

!PrologString methodsFor: 'comparing'!
> aPrologString 
	^self string > aPrologString string! !

!PrologString methodsFor: 'comparing'!
>= aPrologString 
	^self string >= aPrologString string! !

!PrologString methodsFor: 'comparing'!
hash
	^self asString hash! !


!PrologString methodsFor: 'enumerating'!
do: aBlock
	^self asString do: aBlock! !


!PrologString methodsFor: 'converting'!
asString
	^self string! !


!PrologString methodsFor: 'printing'!
printOn: aStream 
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '('.
	aStream nextPutAll: self asString.
	aStream nextPutAll: ')'! !

!PrologString methodsFor: 'printing'!
printPrologOn: aStream 
	| i length x |
	aStream nextPut: $".
	i := 0.
	length := string size.
	[(i := i + 1) <= length]
		whileTrue: 
			[aStream nextPut: (x := string at: i).
			x == $" ifTrue: [aStream nextPut: x]].
	aStream nextPut: $"! !

!PrologString methodsFor: 'printing'!
printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologString class
	instanceVariableNames: ''!

!PrologString class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologString class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologString class methodsFor: 'copyright'!
version
	^'003'! !


!PrologString class methodsFor: 'instance creation'!
fromString: aString 
	^super new string: aString! !

!PrologString class methodsFor: 'instance creation' stamp: 'nishis 5/8/98 22:47'!
readFrom: aStream 
	| buffer char string |
	buffer := WriteStream on: (String new: 20).
	char := aStream next.
	char = $" ifTrue: [
		[char := aStream peek.
		char ~~ nil]
			whileTrue: 
				[char = $"
					ifTrue: 
						[aStream next.
						char := aStream peek.
						char = $" ifFalse: [^self fromString: buffer contents]].
				buffer nextPut: aStream next]].
	string := aStream upToEnd.
	string size > 100 ifTrue: [string := string copyFrom: 1 to: 100].
	Debugger
		openContext: thisContext
		label: 'Error'
		contents: 'Syntax error near $" unmatched $"\' withCRs , (string = ''
					ifTrue: ['-- end of file --']
					ifFalse: ['--> ' , string])! !
