'Goodies (11/18/2001 8:35:23 am)'.!


PrologList subclass: #PrologClause
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Goodies-Prolog'!
!PrologClause commentStamp: '<historical>' prior: 0!
Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

!


!PrologClause methodsFor: 'accessing'!
body
	^cdrPart! !

!PrologClause methodsFor: 'accessing'!
body: aPrologBody 
	cdrPart := aPrologBody! !

!PrologClause methodsFor: 'accessing'!
head
	^carPart! !

!PrologClause methodsFor: 'accessing'!
head: aPrologStructure 
	carPart := aPrologStructure! !


!PrologClause methodsFor: 'printing'!
prettyPrintPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ' :- '.
			body prettyPrintPrologOn: aStream].
	aStream nextPut: $.! !

!PrologClause methodsFor: 'printing'!
prettyPrintPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self prettyPrintPrologOn: aStream.
	^aStream contents! !

!PrologClause methodsFor: 'printing'!
printPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	aStream nextPut: $(.
	head printPrologOn: aStream.
	body == nil
		ifFalse: 
			[aStream nextPutAll: ', '.
			body printPrologOn: aStream].
	aStream nextPut: $)! !

!PrologClause methodsFor: 'printing'!
printPrologOn: aStream level: anInteger
	self printPrologOn: aStream! !

!PrologClause methodsFor: 'printing'!
questionPrintPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	aStream nextPutAll: '?- '.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ', '.
			body printPrologOn: aStream].
	aStream nextPut: $.! !


!PrologClause methodsFor: 'private'!
head: aPrologStructure body: aPrologBody 
	self head: aPrologStructure.
	self body: aPrologBody! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PrologClause class
	instanceVariableNames: ''!

!PrologClause class methodsFor: 'copyright'!
copyright
	^'Copyright (C) 1995-1998 AOKI Atsushi, All Rights Reserved.'! !

!PrologClause class methodsFor: 'copyright'!
system
	^'Goodies'! !

!PrologClause class methodsFor: 'copyright'!
version
	^'003'! !


!PrologClause class methodsFor: 'instance creation'!
head: aPrologStructure body: aPrologBody 
	^super new head: aPrologStructure body: aPrologBody! !
